;ASMD_ROUTINES.INC
;ASMD : ADDITION, SUBTRACTION, MULTIPLICATION & DIVISION
;********************************************************************
;ALIGN_XY_EXP : ALIGN THE THE EXPONENT OF X & Y REGISTERS
;NUMBERS IN X & Y REGISTERS ARE IN NORMALIZED (CANONICAL) FORM
ALIGN_XY_EXP	NOP
;CONVERT PACKED-BCD EXPONENTS INTO BINARY -> MORE THAN 200 DECADES CAN BE HANDLED
	MOVF	X_EXP,W
	CALL	BCD2_2_BIN8
	MOVWF	X_EXP_BIN
;
	MOVF	Y_EXP,W
	CALL	BCD2_2_BIN8
	MOVWF	Y_EXP_BIN
;CHECK THE SIGNS OF EXPONENTS
	BTFSC	X_EXP_SIGN	;SKIP IF THE EXPONENT-SIGN OF X_REG. =0 -> POSITIVE	
	BRA	ALIGN_X_EXP_NEG
;EXPONENT SIGN OF X_REG. -> POSITIVE
	BTFSC	Y_EXP_SIGN	;SKIP IF THE EXPONENT-SIGN OF Y_REG. =0 -> POSITIVE	
	BRA	EXP_X_P_Y_N
;BOTH EXP. SIGNS ARE POSITIVE
EXP_X_P_Y_P	MOVF	Y_EXP_BIN,W
	CPFSEQ	X_EXP_BIN	;SKIP IF X_EXP = Y_EXP
	BRA	EXP_X_P_Y_P_5
	RETURN		;EXPONENTS ARE EQUAL -> NOTHING TO DO
;EXPONENTS ARE DIFFERENT, WHICH ONE IS THE GREATER
EXP_X_P_Y_P_5	MOVF	Y_EXP_BIN,W
	CPFSGT	X_EXP_BIN	;Compare f with W, Skip if f > W	
	BRA	EXP_X_P_Y_P_10
;X-EXPONENT > Y-EXPONENT, CALCULATE THE DIFFERENCE
	MOVF	Y_EXP_BIN,W
	SUBWF	X_EXP_BIN,W	;SUBTRACT Y_EXP_BIN FROM X_EXP_BIN
	MOVWF	EXP_SHIFT_REG	;RESULT OF SUBTRACTION IN EXP_SHIFT_REG
	CALL	SHIFT_Y_R_N
	MOVFF	X_EXP,Y_EXP	;COPY THE EXPONENT OF THE GREATER NUMBER
	RETURN
;Y-EXPONENT > X-EXPONENT, CALCULATE THE DIFFERENCE
EXP_X_P_Y_P_10	MOVF	X_EXP_BIN,W
	SUBWF	Y_EXP_BIN,W	;SUBTRACT X_EXP_BIN FROM Y_EXP_BIN
	MOVWF	EXP_SHIFT_REG	;RESULT OF SUBTRACTION IN EXP_SHIFT_REG
	CALL	SHIFT_X_R_N
	MOVFF	Y_EXP,X_EXP	;COPY THE EXPONENT OF THE GREATER NUMBER
	RETURN
;EXPONENT OF X IS POSITIVE, EXPONENT OF Y IS NEGATIVE -> X > Y (X_x IS GREATER THAN Y_y)
;ADD |Y_EXP_BIN| TO X_EXP_BIN	(|Y_EXP_BIN| -> ABSOLUTE VALUE!)
EXP_X_P_Y_N	MOVF	Y_EXP_BIN,W
	ADDWF	X_EXP_BIN,W
	MOVWF	EXP_SHIFT_REG	;RESULT OF SUBTRACTION IN EXP_SHIFT_REG
	CALL	SHIFT_Y_R_N
	MOVFF	X_EXP,Y_EXP	;COPY THE EXPONENT OF THE GREATER NUMBER	
	RETURN
;EXPONENT SIGN OF X_REG. -> NEGATIVE
ALIGN_X_EXP_NEG	BTFSC	Y_EXP_SIGN	;SKIP IF THE EXPONENT-SIGN OF Y_REG. =0 -> POSITIVE
	BRA	EXP_X_N_Y_N
;EXPONENT OF X IS NEGATIVE, EXPONENT OF Y IS POSITIVE 
;ADD |X_EXP_BIN| TO Y_EXP_BIN	(|X_EXP_BIN| -> ABSOLUTE VALUE!)
EXP_X_N_Y_P	MOVF	X_EXP_BIN,W
	ADDWF	Y_EXP_BIN,W
	MOVWF	EXP_SHIFT_REG
	CALL	SHIFT_X_R_N
	MOVFF	Y_EXP,X_EXP	;COPY THE EXPONENT OF THE GREATER NUMBER
	BCF	X_EXP_SIGN
	RETURN
;BOTH EXPONENT SIGNS ARE NEGATIVE, THE SMALLER EXPONENT -> THE GREATER NUMBER
EXP_X_N_Y_N	MOVF	Y_EXP,W
	CPFSEQ	X_EXP	;SKIP IF X_EXP = Y_EXP
	BRA	EXP_X_N_Y_N_5
	RETURN		;EXPONENTS ARE EQUAL -> NOTHING TO DO
;
EXP_X_N_Y_N_5	MOVF	Y_EXP_BIN,W
	CPFSGT	X_EXP_BIN	;Compare f with W, Skip if f > W	
	BRA	EXP_X_N_Y_N_10
;X-EXPONENT > Y-EXPONENT -> X_x SMALLER THAN Y_y, CALCULATE THE DIFFERENCE
	MOVF	Y_EXP_BIN,W
	SUBWF	X_EXP_BIN,W	;SUBTRACT Y_EXP_BIN FROM X_EXP_BIN
	MOVWF	EXP_SHIFT_REG	;RESULT OF SUBTRACTION IN EXP_SHIFT_REG
	CALL	SHIFT_X_R_N
	MOVFF	Y_EXP,X_EXP	;COPY THE EXPONENT OF THE GREATER NUMBER
	RETURN
;Y-EXPONENT > X-EXPONENT -> X_x GREATER THAN Y_y -> Y_y SHOULD BE SHIFTED, CALCULATE THE DIFFERENCE
EXP_X_N_Y_N_10	MOVF	X_EXP_BIN,W
	SUBWF	Y_EXP_BIN,W	;SUBTRACT X_EXP_BIN FROM Y_EXP_BIN
	MOVWF	EXP_SHIFT_REG	;RESULT OF SUBTRACTION IN EXP_SHIFT_REG
	CALL	SHIFT_Y_R_N
	MOVFF	X_EXP,Y_EXP	;COPY THE EXPONENT OF THE GREATER NUMBER
	RETURN
;********************************************************************
;ADD_YREG_2_XREG
;T ~ 25 usec @ 32MHz
;(5,5555.5555.5555 * 10^5 + 7,7777.7777.7777 * 10^7)
ADD_YREG_2_XREG	BTFSC	X_SIGN	;SKIP IF X_SIGN = 0 -> X IS POSITIVE
	BRA	ADD_X_NEGATIVE
;
ADD_X_POSITIVE	BTFSC	Y_SIGN	;SKIP IF Y_SIGN = 0 -> Y IS POSITIVE
	BRA	ADD_X_POS_Y_NEG
;
ADD_X_POS_Y_POS	CALL	NORM_ADD_Y_2_X
	BRA	ADD_Y_2_X_END
;
ADD_X_POS_Y_NEG	CALL	CHANGE_XY
	BCF	Y_SIGN
	CALL	NORM_SUB_X_FROM_Y
	BRA	ADD_Y_2_X_END
;
ADD_X_NEGATIVE	BTFSC	Y_SIGN	;SKIP IF Y_SIGN = 0 -> Y IS POSITIVE
	BRA	ADD_X_NEG_Y_NEG
;
ADD_X_NEG_Y_POS	BCF	X_SIGN
	CALL	NORM_SUB_X_FROM_Y
	BRA	ADD_Y_2_X_END
;
ADD_X_NEG_Y_NEG	BCF	X_SIGN
	BCF	Y_SIGN
	CALL	NORM_ADD_Y_2_X
	BSF	X_SIGN
;
ADD_Y_2_X_END	MOVF	X_EXP,F
	BTFSC	Z	;SKIP IF X_EXP =/= 0
	BCF	X_EXP_SIGN	
;
	RETURN
;********************************************************************
;NORM_ADD_Y_2_X : NORMALIZED ADDITION
;
NORM_ADD_Y_2_X	CALL	ALIGN_XY_EXP
	CALL	ADD_Y_2_X
;X_6 HIGH-NIBBLE TEST
	MOVF	X_6,W
	ANDLW	H'F0'
	BTFSC	Z	;SKIP IF W =/= 0 -> HIGH NIBBLE =/= 0
	BRA	X_6_LOW_NIBBLE_TEST
;HIGH NIBBLE OF X_6 IS NOT ZERO -> SHIFT X_x RIGHT -> DIVIDE BY TEN
	CALL	SHIFT_X_R1
;INCREMENT X-EXPONENT
	CALL	INCREMENT_X_EXP	;MULTIPLY BY TEN
;
	RETURN
;********************************************************************
;ADD_Y_2_X : ADD Y_y TO X_x
;14 DIGIT PACKED BCD ADDITION
;RESULT IN X-REG
;NO FSRs ARE USED
;CALLS : NOTHING
;DESTROYS : WREG, X_x REGs, STATUS
ADD_Y_2_X	BCF	C	;NO INCOMING OVERFLOW
;1-2
	MOVF	X_0,W
	ADDWFC	Y_0,W
	DAW
	MOVWF	X_0
;3-4
	MOVF	X_1,W
	ADDWFC	Y_1,W
	DAW
	MOVWF	X_1
;5-6
	MOVF	X_2,W
	ADDWFC	Y_2,W
	DAW
	MOVWF	X_2
;7-8
	MOVF	X_3,W
	ADDWFC	Y_3,W
	DAW
	MOVWF	X_3
;9-10
	MOVF	X_4,W
	ADDWFC	Y_4,W
	DAW
	MOVWF	X_4
;11-12
	MOVF	X_5,W
	ADDWFC	Y_5,W
	DAW
	MOVWF	X_5
;13-14
	MOVF	X_6,W
	ADDWFC	Y_6,W
	DAW
	MOVWF	X_6
;
	RETURN
;********************************************************************
;SUB_XREG_FROM_YREG
;SUBTRACTION IS ALLWAYS PERFORMED AS: X-REGISTER SUBTRACTED FROM Y-REGISTER
;T ~ 25 usec @ 32MHz
;(9,9999.9999.9999 * 10^9 - 8,8888.8888.8888 * 10^8)
SUB_XREG_FROM_YREG NOP
	BTFSC	X_SIGN	;SKIP IF X_SIGN = 0 -> X IS POSITIVE
	BRA	SUB_X_NEGATIVE
;SIGN OF X-REG. IS POSITIVE
SUB_X_POSITIVE	BTFSC	Y_SIGN	;SKIP IF Y_SIGN = 0 -> Y IS POSITIVE
	BRA	SUB_X_POS_Y_NEG
;BOTH SIGNS ARE POSITIVE -> SUBTRACTION
SUB_X_POS_Y_POS	CALL	NORM_SUB_X_FROM_Y
	BRA	SUB_X_FROM_Y_END	
;SIGN OF X-REG. IS POSITIVE, SIGN OF Y-REG. IS NEGATIVE 
; -Y_y - X_x -> - (Y_y + X_x)
SUB_X_POS_Y_NEG	CALL	NORM_ADD_Y_2_X
	BSF	X_SIGN
	BRA	SUB_X_FROM_Y_END
;SIGN OF X-REG. IS NEGATIVE
SUB_X_NEGATIVE	BTFSC	Y_SIGN	;SKIP IF Y_SIGN = 0 -> Y IS POSITIVE
	BRA	SUB_X_NEG_Y_NEG
;SIGN OF X-REG. IS NEGATIVE, SIGN OF Y-REG. IS POSITIVE
; Y_y - -X_x -> Y_y + X_x
SUB_X_NEG_Y_POS	BCF	X_SIGN
	CALL	NORM_ADD_Y_2_X
	BRA	SUB_X_FROM_Y_END	
;BOTH SIGNS ARE NEGATIVE
; -Y_y - -X_x -> -Y_y + X_x -> X_x - Y_y
SUB_X_NEG_Y_NEG	BCF	X_SIGN
	BCF	Y_SIGN
	CALL	CHANGE_XY
	CALL	NORM_SUB_X_FROM_Y
;
SUB_X_FROM_Y_END MOVF	X_EXP,F
	BTFSC	Z	;SKIP IF X_EXP =/= 0
	BCF	X_EXP_SIGN	
;
	RETURN
;********************************************************************
;NORM_SUB_X_FROM_Y : NORMALIZED SUBTRACTION
NORM_SUB_X_FROM_Y CALL	ALIGN_XY_EXP
	CALL	SUB_X_FROM_Y
;BE SURE HIGH NIBBLE OF X_6 = 0
	MOVF	X_6,W
	ANDLW	H'0F'
	MOVWF	X_6
;RESULT MAY BE THE NEXT : 0,0000.0000.000x, WHERE x = 0 or 1
;AFTER THE SUBTRACTION THE X_x REGISTER SHOLUD BE NORMALIZED
;X = 0,xxxx.xxxx.xxxx ?
X_6_LOW_NIBBLE_TEST MOVF	X_6,F	;ZERO CHECKING
	BTFSS	Z	;SKIP IF X_6 = 0
	RETURN
	CALL	SHIFT_X_L1	
	CALL	DECREMENT_X_EXP
;X = 0,xxxx.xxxx.xxx0 ?
	MOVF	X_6,F	;ZERO CHECKING
	BTFSS	Z	;SKIP IF X_6 = 0
	RETURN
	CALL	SHIFT_X_L1	
	CALL	DECREMENT_X_EXP
;X = 0,xxxx.xxxx.xx00 ?
	MOVF	X_6,F	;ZERO CHECKING
	BTFSS	Z	;SKIP IF X_6 = 0
	RETURN
	CALL	SHIFT_X_L1	
	CALL	DECREMENT_X_EXP
;X = 0,xxxx.xxxx.x000 ?
	MOVF	X_6,F	;ZERO CHECKING
	BTFSS	Z	;SKIP IF X_6 = 0
	RETURN
	CALL	SHIFT_X_L1	
	CALL	DECREMENT_X_EXP
;X = 0,xxxx.xxxx.0000 ?
	MOVF	X_6,F	;ZERO CHECKING
	BTFSS	Z	;SKIP IF X_6 = 0
	RETURN
	CALL	SHIFT_X_L1	
	CALL	DECREMENT_X_EXP
;X = 0,xxxx.xxx0.0000 ?
	MOVF	X_6,F	;ZERO CHECKING
	BTFSS	Z	;SKIP IF X_6 = 0
	RETURN
	CALL	SHIFT_X_L1	
	CALL	DECREMENT_X_EXP
;X = 0,xxxx.xx00.0000 ?
	MOVF	X_6,F	;ZERO CHECKING
	BTFSS	Z	;SKIP IF X_6 = 0
	RETURN
	CALL	SHIFT_X_L1	
	CALL	DECREMENT_X_EXP
;X = 0,xxxx.x000.0000 ?
	MOVF	X_6,F	;ZERO CHECKING
	BTFSS	Z	;SKIP IF X_6 = 0
	RETURN
	CALL	SHIFT_X_L1	
	CALL	DECREMENT_X_EXP
;X = 0,xxxx.0000.0000 ?
	MOVF	X_6,F	;ZERO CHECKING
	BTFSS	Z	;SKIP IF X_6 = 0
	RETURN
	CALL	SHIFT_X_L1	
	CALL	DECREMENT_X_EXP
;X = 0,xxx0.0000.0000 ?
	MOVF	X_6,F	;ZERO CHECKING
	BTFSS	Z	;SKIP IF X_6 = 0
	RETURN
	CALL	SHIFT_X_L1	
	CALL	DECREMENT_X_EXP
;X = 0,xx00.0000.0000 ?
	MOVF	X_6,F	;ZERO CHECKING
	BTFSS	Z	;SKIP IF X_6 = 0
	RETURN
	CALL	SHIFT_X_L1	
	CALL	DECREMENT_X_EXP
;X = 0,x000.0000.0000 ?
	MOVF	X_6,F	;ZERO CHECKING
	BTFSS	Z	;SKIP IF X_6 = 0
	RETURN
	CALL	SHIFT_X_L1	
	CALL	DECREMENT_X_EXP
;X = 0,0000.0000.0000 ?
	MOVF	X_6,F	;ZERO CHECKING
	BTFSS	Z	;SKIP IF X_6 = 0
	RETURN
	CALL	CLEAR_X	
;
	RETURN
;********************************************************************
;SUB_X_FROM_Y : SUBTRACT X_REG FROM Y_REG
;14 DIGIT PACKED BCD SUBTRACTION
;RESULT IN X-REG
;IF RESULT IS NEGATIV -> SET X_SIGN
;NO FSRs ARE USED
;CALLS : TENS_COMPLEMENT
;DESTROYS : WREG, X_x REGs, STATUS, SIGN_REG
SUB_X_FROM_Y	BCF	X_SIGN	;DEFAULT SETTING
	CALL	TENS_COMPLEMENT
	CALL	ADD_Y_2_X
	MOVFF	X_6,WREG
	ANDLW	H'F0'	
	XORLW	H'90'
	BTFSS	Z	;SKIP IF [X_.] = 9 -> NEGATIV
	RETURN
;RESULT NEGATIV -> COMPLEMENT X AGAIN!	
	CALL	TENS_COMPLEMENT
	BSF	X_SIGN
;
	RETURN
;********************************************************************
;TENS_COMPLEMENT : CREATES TEN'S COMPLEMENT OF A NUMBER
TENS_COMPLEMENT	NOP
;1st GENERATE THE 9's COMPLEMENT USING SUBFWB : (W) - (f) - (/C) -> destination
	MOVLW	H'99'
	BSF	C	;C := 1	IMPORTANT!
	SUBFWB	X_0,F
	SUBFWB	X_1,F
	SUBFWB	X_2,F
	SUBFWB	X_3,F
	SUBFWB	X_4,F
	SUBFWB	X_5,F
	SUBFWB	X_6,F
;NOW, WE SHOULD TO ADD D'1' TO 9's COMPLEMENT NUMBER
	BCF	C	;NO INCOMING OVERFLOW
;1-2
	MOVLW	D'1'
	ADDWFC	X_0,W
	DAW
	MOVWF	X_0
;3-4
	MOVLW	D'0'
	ADDWFC	X_1,W
	DAW
	MOVWF	X_1
;5-6
	MOVLW	D'0'
	ADDWFC	X_2,W
	DAW
	MOVWF	X_2
;7-8
	MOVLW	D'0'
	ADDWFC	X_3,W
	DAW
	MOVWF	X_3
;9-10
	MOVLW	D'0'
	ADDWFC	X_4,W
	DAW
	MOVWF	X_4
;11-12
	MOVLW	D'0'
	ADDWFC	X_5,W
	DAW
	MOVWF	X_5
;13-14
	MOVLW	D'0'
	ADDWFC	X_6,W
	DAW
	MOVWF	X_6
;
	RETURN
;********************************************************************
;MUL_YREG_BY_XREG : Y_y * X_x -> RESULT IN P_p -> X_x
;14 DIGIT PACKED BCD MULTIPLICATION
;THE NUMBERS IN X & Y REGISTERS ARE IN NORMALIZED FORM
;FSR0 -> R POINTER
;FSR1 -> X POINTER
;FSR2 -> Y POINTER
;T ~ 707 usec @ 32MHz
;(5,5555.5555.5555 * 10^5 * 7,7777.7777.7777 * 10^7)
MUL_YREG_BY_XREG NOP
	CALL	SAVE_X
	CALL	SAVE_Y
;MULTIPLY MANTISSAs
;THE GREATEST RESULT -> 9,9999.9999.9999 * 9,9999.9999.9999 = 99,9999.9999.9980 
;THE LEAST RESULT -> 1,0000.0000.0000 * 1,0000.0000.0000 = 1,0000.0000.0000
;
	CALL	MUL_Y_BY_X_MAN	;MULTIPLY THE MANTISSAS
;
	CALL	RELOAD_X_EXP
	CALL	RELOAD_Y_EXP
	NOP
;NORMALIZE X_x IF NEEDED
	MOVF	X_6,W
	ANDLW	H'F0'	;DELETE LOW NIBBLE IN WREG
	BZ	MUL_Y_BY_X_10	;HIGH NIBBLE = 0 -> NO SHIFTING IS NEEDED
;HIGH NIBBLE =/= 0 -> X MANTISSA SHOULD BE SHIFTED RIGHT -> DIVIDE BY TEN
	CALL	SHIFT_X_R1
;CHECK X-EXPONENT SIGN
	BTFSS	X_EXP_SIGN	;SKIP IF X-EXPONENT IS NEGATIVE
	BRA	MUL_Y_BY_X_5
;X_EXP SHOULD BE "DECREMENTED" IF X-EXPONENT NEGATIVE -> MULTIPLY BY TEN
	CALL	DEC_X_EXP
	BRA	MUL_Y_BY_X_10
;X_EXP SHOULD BE INCREMENTED IF X-EXPONENT POSITIVE 
MUL_Y_BY_X_5	CALL	INC_X_EXP	
;NOW: EXPONENT POSTPROCESSING -> DEPENDING ON EXPONENTS SIGNS ->
; -> EXPONENTS SHOULD BE ADDED OR SUBTRACTED
MUL_Y_BY_X_10	BTFSC	X_EXP_SIGN	;SKIP IF X_EXP_SIGN = 0 -> POSITIVE
	BRA	MUL_X_EXP_SIGN_N
;X-EXPONENT IS POSITIVE
MUL_X_EXP_SIGN_P BTFSC	Y_EXP_SIGN	;SKIP IF Y_EXP_SIGN = 0 -> POSITIVE
	BRA	MUL_X_EXP_P_Y_EXP_N
;BOTH EXPONENT SIGNS ARE POSITIVE -> ADDITION
MUL_X_EXP_P_Y_EXP_P
	CALL	ADD_Y_EXP_2_X_EXP
	BRA	MUL_SIGN_PROCESS
;NUMBER-X IS GREATER THAN NUMBER-Y
;Y-EXPONENT SHOULD BE SUBTRACTED FROM X-EXPONENT
MUL_X_EXP_P_Y_EXP_N
	CALL	SUB_Y_EXP_FROM_X_EXP
	BRA	MUL_SIGN_PROCESS
;X-EXPONENT IS NEGATIVE
MUL_X_EXP_SIGN_N BTFSC	Y_EXP_SIGN	;SKIP IF Y_EXP_SIGN = 0 -> POSITIVE
	BRA	MUL_X_EXP_N_Y_EXP_N
;NUMBER-Y IS GREATER THAN NUMBER-X
;X-EXPONENT SHOULD BE SUBTRACTED FROM Y-EXPONENT
MUL_X_EXP_N_Y_EXP_P
	CALL	SUB_X_EXP_FROM_Y_EXP
	BRA	MUL_SIGN_PROCESS
;BOTH EXPONENT SIGNS ARE NEGATIVE -> ADDITION
MUL_X_EXP_N_Y_EXP_N
	CALL	ADD_Y_EXP_2_X_EXP
;MANTISSA SIGN POSTPROCESSING
MUL_SIGN_PROCESS
;RELOAD MANTISSA SIGNS
	BCF	X_SIGN
	BTFSC	X_SAVE_SIGN
	BSF	X_SIGN
;
	BCF	Y_SIGN
	BTFSC	Y_SAVE_SIGN
	BSF	Y_SIGN
;
	BTFSC	X_SIGN	;SKIP IF X_SIGN = 0 -> POSITIVE
	BRA	MUL_X_NEGATIVE
;X_SIGN IS POSITIVE
MUL_X_POSITIVE	BTFSS	Y_SIGN	;SKIP IF Y_SIGN = 1 -> NEGATIVE
	BRA	MUL_Y_BY_X_END	;BOTH SIGNS ARE POSITIVE
;X_SIGN IS POSITIVE, Y_SIGN -S NEGATIVE -> RESULT IS NEGATIVE
MUL_X_P_Y_N	BSF	X_SIGN
	BRA	MUL_Y_BY_X_END
;X_SIGN IS NEGATIVE
MUL_X_NEGATIVE	BTFSC	Y_SIGN	;SKIP IF Y_SIGN = 0 -> POSITIVE
	BRA	MUL_X_N_Y_N
;X_SIGN IS NEGTIVE, Y_SIGN -S POSITIVE -> RESULT IS NEGATIVE
	BSF	X_SIGN
	BRA	MUL_Y_BY_X_END
;BOTH SIGNS ARE NEGATIVE -> RESULT IS POSITIVE
MUL_X_N_Y_N	BCF	X_SIGN
;
MUL_Y_BY_X_END	MOVF	X_EXP,F
	BTFSC	Z	;SKIP IF X_EXP =/= 0
	BCF	X_EXP_SIGN	
;
	CALL	CHECK_X_0?
	BTFSC	X_0_BIT	;SKIP IF X_x = 0
	RETURN
;
	CLRF	X_EXP
	BCF	X_SIGN
	BCF	X_EXP_SIGN
;
	RETURN
;********************************************************************
;MUL_Y_BY_X_MAN : MULTIPLY Y-MANTISSA BY X-MANTISSA
MUL_Y_BY_X_MAN	CALL	CLEAR_P
;X_0
	LFSR	1,X_0
	LFSR	0,R_0
	CALL	INNER_LOOP
;X_1
	LFSR	1,X_1
	LFSR	0,R_1
	CALL	INNER_LOOP
;X_2
	LFSR	1,X_2
	LFSR	0,R_2
	CALL	INNER_LOOP
;X_3
	LFSR	1,X_3
	LFSR	0,R_3
	CALL	INNER_LOOP
;X_4
	LFSR	1,X_4
	LFSR	0,R_4
	CALL	INNER_LOOP
;X_5
	LFSR	1,X_5
	LFSR	0,R_5
	CALL	INNER_LOOP
;X_6
	LFSR	1,X_6
	LFSR	0,R_6
	CALL	INNER_LOOP
;RESULT IS LOADED INTO X_x
	MOVFF	P_C,X_6
	MOVFF	P_B,X_5
	MOVFF	P_A,X_4
	MOVFF	P_9,X_3
	MOVFF	P_8,X_2
	MOVFF	P_7,X_1
	MOVFF	P_6,X_0
	NOP
;
	RETURN
;********************************************************************
;INNER_LOOP
INNER_LOOP	MOVLF	D'7',INNER_LOOP_CNT
	LFSR	2,Y_0
;
INNER_LOOP_0	MOVF	INDF2,W	;ZERO CHECKING
	BZ	Y_EQUAL_0	;Y_y = 0 -> RESULT = 0
;
	MOVWF	TEMP	;SAVE WREG
	MOVLW	H'01'
	XORWF	TEMP,W
	BNZ	INNER_LOOP_5	
;Y_y = 01 -> Y_y * X_x = X_x THE RESULT IS X_x ITSELF
	CALL	CLEAR_R
	MOVFF	INDF1,POSTINC0
	BRA	INNER_LOOP_10
;
INNER_LOOP_5	CALL	CLEAR_R
	MOVFF	INDF1,TBLPTRL	;X_x -> TBLPTRL
	MOVFF	INDF2,TBLPTRH	;Y_y -> TBLPTRH
;MULTIPLY ADDRESS BY 2 -> RESULT = 2 Bytes
	CLRF	TBLPTRU
	BCF	C
	RLCF	TBLPTRL,F
	RLCF	TBLPTRH,F
	RLCF	TBLPTRU,F
;
	TBLRD*+
	MOVFF	TABLAT,POSTINC0	;LOW BYTE OF TABLE -> R_r
	TBLRD*
	MOVFF	TABLAT,INDF0	;HIGH BYTE OF TABLE -> R_r+1
;
INNER_LOOP_10	CALL	ADD_R_2_P	;P_p = P_p + R_r
;Y_y WAS NO 0 -> PREPARE THE NEXT LOOP
	DECF	INNER_LOOP_CNT,F
	BTFSC	Z	;SKIP IF NO ZERO
	RETURN
;
	INCF	FSR2L,F	;Y POINTER INCREMENTED
	BRA	INNER_LOOP_0
;Y_y WAS 0 -> PREPARE THE NEXT LOOP
Y_EQUAL_0	DECF	INNER_LOOP_CNT,F
	BTFSC	Z	;SKIP IF NO ZERO
	RETURN
;
	INCF	FSR2L,F	;Y POINTER INCREMENTED
	INCF	FSR0L,F	;R POINTER INCREMENTED
	BRA	INNER_LOOP_0
;********************************************************************
;DIV_YREG_BY_XREG
;DIVIDEND IN Y_y
;DIVISOR IN X_x
;T ~ 20 msec @ 32MHz
;(9,9999.9999.9999 * 10^9 / 8,8888.8888.8888 * 10^8)
DIV_YREG_BY_XREG	NOP
;CHECK DIVIDEND
	CALL	CHECK_Y_0?	;IF Y_y = 0 -> NO DIVISION NEEDED
	BTFSC	Y_0_BIT	;SKIP IF Y_y = 0
	BRA	DIV_Y_BY_X_5
;
	CALL	CLEAR_X
	RETURN
;
DIV_Y_BY_X_5	CALL	SAVE_Y_TEMP0	; y,yyyy.yyyy.yyyy * 10^yy -> Y_TEMP0_y
	CALL	SAVE_Y_TEMP0_SIGN
	CALL	SAVE_Y_TEMP0_EXP;10^yy -> Y_TEMP0_EXP
	CALL	SAVE_X_TEMP0	; x,xxxx.xxxx.xxxx *  -> X_TEMP0_x
	CALL	SAVE_X_TEMP0_SIGN
	CALL	SAVE_X_TEMP0_EXP;10^xx -> X_TEMP0_EXP
;	CALL	CLEAR_T
	CALL	CLEAR_Q
;
	MOVLF	D'43',N_REGISTER
; DIVISION_LOOP : LET'S FIND THE NUMBER "N", WHERE 2^N * DIVISOR < y,yyyy.yyyy.yyyy
DIVISION_LOOP	CALL	LOAD_PWR2_2_Y
	NOP
	CALL	COPY_Y_2_B	;COPY Y_y TO B_b, IT WILL BE GOOD LATER
	CALL	RELOAD_X_TEMP0	;RELOAD DIVISOR INTO X_x
	CALL	MUL_Y_BY_X_MAN	;2^N * DIVISOR -> RESULT IN X_x
;
	MOVF	P_D,F	;ZERO CHECKING
	BNZ	NEXT_N	;RESULT OF MULTIPLYING IS TOO HIGH
	MOVF	X_6,W
	ANDLW	H'F0'	;CLEAR LOW NIBBLE
	BNZ	NEXT_N	;X_6 HI NIBBLE NOT ZERO -> RESULT OF MULTIPLYING IS TOO HIGH
	NOP
	CALL	RELOAD_Y_TEMP0	;DIVIDEND IN Y_y, 2^N * DIVISOR IN X_x
	CALL	SUB_X_FROM_Y
	BTFSS	X_SIGN	;SKIP IF RESULT OF SUBTRACTION IS NEGATIVE -> N IS TOO HIGH
	BRA	DIV_N_IS_GOOD	;y,yyyy.yyyy.yyyy > 2^N * DIVISOR	
;"N" IS TOO HIGH
DIV_N_IS_TOO_HIGH
NEXT_N	DECF	N_REGISTER,F
;N_REGISTER MUST NOT UNDERRUN FROM H'00' TO H'FF' -> ENDLESS CYCLE
	MOVLW	H'FF'
	XORWF	N_REGISTER,W
	BZ	NO_MORE_N	;SOMETHING ERROR OCCURED!!!!
	BRA	DIVISION_LOOP
;N_IS_GOOD : y,yyyy.yyyy.yyyy > 2^N * DIVISOR -> 2^N IS PART OF THE QUOTIENT
DIV_N_IS_GOOD	NOP
;EARLIER, WE SAVED THE LAST 2^N VALUE IN B_b REGISTERS -> NOW, THIS IS THE PART OF THE QUOTIENT
DIV_N_IS_GOOD_5	CALL	ADD_B_2_Q
;REMAINDER OF SUBTRACTION IN X_x, SAVE IT (y,yyyy.yyyy.yyyy - 2^N*DIVISOR -> Y_y)
	CALL	COPY_X_2_Y
	CALL	SAVE_Y_TEMP0
;FIND MORE PARTS OF QUOTIENT
	BRA	NEXT_N
;
NO_MORE_N	CALL	COPY_Q_2_X
;CALCULATE EXPONENT OF X_x & THAN NORMALIZE X_x.
CAL_X_EXP	CALL	RELOAD_Y_TEMP0_EXP
	CALL	RELOAD_X_TEMP0_EXP
;
	BTFSC	X_EXP_SIGN	;SKIP IF EXPONENT OF X IS POSITIVE
	BRA	X_EXP_NEG
;
X_EXP_POS	BTFSC	Y_EXP_SIGN	;SKIP IF EXPONENT OF Y IS POSITIVE
	BRA	X_EXP_P_Y_EXP_N
;BOTH EXPONENTS ARE POSITIVE -> SUBTRACT X_EXP FROM Y_EXP
	CALL	SUB_X_EXP_FROM_Y_EXP
	BRA	DIV_Y_BY_X_10
;THE RESULT OF SUBTRACTION IS NEGATIVE -> THE RESULT OF DIVISION < 0, COMPLEMENT THE RESULT
XP_YP_COMP_EXP	GET_10S_COMP	TEMP,X_EXP
	BSF	X_EXP_SIGN
	BRA	DIV_Y_BY_X_10
;X_EXP IS POSITIVE, Y_EXP IS NEGATIVE -> ADD THEM & SET X_EXP_SIGN
X_EXP_P_Y_EXP_N	MOVF	Y_EXP,W	
	ADDWF	X_EXP,W
	DAW
	MOVWF	X_EXP
	BSF	X_EXP_SIGN
	BRA	DIV_Y_BY_X_10
;
X_EXP_NEG	BTFSC	Y_EXP_SIGN	;SKIP IF Y_EXP IS POSITIVE
	BRA	X_EXP_N_Y_EXP_N
;X_EXP IS NEGATIVE, Y_EXP IS POSITIVE -> ADD THE |ABSOLUTE| VALUES
X_EXP_N_Y_EXP_P	MOVF	Y_EXP,W	
	ADDWF	X_EXP,W
	DAW
	MOVWF	X_EXP
	BCF	X_EXP_SIGN
;
	MOVF	X_6,F	;ZERO CHECKING
	BNZ	DIV_Y_BY_X_END	;BRANCH IF X_6 =/= 0
;X_x = 0,xxxx.xxxx.xxxx -> X_x SHOLUD BE NORMALIZED
	CALL	SHIFT_X_L1
	CALL	DEC_X_EXP
	BRA	DIV_Y_BY_X_END
;BOTH EXPONENTS ARE NEGATIVE -> SUBTRACT X_EXP FROM Y_EXP
;BECAUSE SUBTRACTION & X_EXP IS NEGATIVE -> X_EXP IS POSITIVE!
;SUBTRACT Y_EXP FROM X_EXP
X_EXP_N_Y_EXP_N	CALL	SUB_Y_EXP_FROM_X_EXP
	BRA	DIV_Y_BY_X_10
;NOW, RESULT OF DIVISION IN X-REGISTER
;THE GREATEST RESULT -> 9,9999.9999.9999 : 1,0000.0000.0000 = 9,9999.9999.9999 
;THE LEAST RESULT -> 1,0000.0000.0000 : 9,9999.9999.9999 = 0,1000.0000.0000 (0100....)
DIV_Y_BY_X_10	MOVF	X_6,F	;ZERO CHECKING
	BTFSS	Z	;SKIP IF X_6 = 0  -> NORMALIZING IS NEEDED
	BRA	DIV_Y_BY_X_END	;X_6 =/= 0
;X_x = 0,xxxx.xxxx.xxxx -> X_x SHOLUD BE NORMALIZED
	CALL	SHIFT_X_L1	
;X_x = X,xxxx.xxxx.xxx0
;IF SIGN OF EXPONENT of X IS POSITIVE (or ZERO) -> DECREMENT EXPONENT
;IF SIGN OF EXPONENT of X IS NEGATIVE -> INCREMENT EXPONENT
	BTFSS	X_EXP_SIGN	;SKIP IF X_EXP_SIGN IS NEGATIVE
	BRA	DIV_Y_BY_X_15
;INCREMENT X-EXPONENT
	CALL	INC_X_EXP
	BRA	DIV_Y_BY_X_END
;
DIV_Y_BY_X_15	CALL	DEC_X_EXP
;SET X_SIGN ACCORDING TO SIGNS OF MANTISSA'S
DIV_Y_BY_X_END	CALL	RELOAD_Y_TEMP0_SIGN	
	BTFSC	Y_SIGN	;SKIP IF Y_SIGN = 0 -> Y IS POSITIVE
	BRA	DIV_Y_NEGATIVE
;
DIV_Y_POSITIVE	CALL	RELOAD_X_TEMP0_SIGN
	BTFSS	X_SIGN	;SKIP IF X_SIGN = 1 -> X IS NEGATIVE
	BRA	DIV_Y_POS_X_POS
;ONLY ONE SIGN OF THE OPERANDS IS NEGATIVE -> RESULT IS NEGATIVE
DIV_Y_POS_X_NEG	BSF	X_SIGN
	RETURN	
;BOTH SIGNS OF OPERANDS ARE POSITIVE -> RESULT IS POSITIVE
DIV_Y_POS_X_POS	BCF	X_SIGN
	BRA	DIV_Y_BY_X_END5
;	
DIV_Y_NEGATIVE	BTFSS	X_ORI_SIGN	;SKIP IF X_ORI_SIGN = 1 -> X IS NEGATIVE	
	BRA	DIV_Y_NEG_X_POS
;BOTH  OPERANDS ARE NEGATIVE -> RESULT IS POSITIVE
	BCF	X_SIGN
	BRA	DIV_Y_BY_X_END5
;ONLY ONE SIGN OF THE OPERANDS IS NEGATIVE -> RESULT IS NEGATIVE
DIV_Y_NEG_X_POS	BSF	X_SIGN
;
DIV_Y_BY_X_END5	MOVF	X_EXP,F
	BTFSC	Z	;SKIP IF X_EXP =/= 0
	BCF	X_EXP_SIGN	
;
	RETURN
;********************************************************************
;LOAD_PWR2_2_Y : LOAD 2^N TO Y_y FROM K14_TBL_PWR_OF_2 TABLE
LOAD_PWR2_2_Y	MOVLF	UPPER K14_TBL_PWR_OF_2,TBLPTRU
	MOVLF	HIGH K14_TBL_PWR_OF_2,TBLPTRH	
	MOVFF	N_REGISTER,TBLPTRL
;MULTIPLY THE TABLE ADDRESS BY D'8' -> SHIFT 3* -> REGISTER LENGHT = 8 Bytes
;TEMP1 IS USED FOR TEMPORARY STORAGE
	CLRF	TEMP1
	BCF	C
	RLCF	TBLPTRL,F
	RLCF	TEMP1,F
	BCF	C
	RLCF	TBLPTRL,F
	RLCF	TEMP1,F
	BCF	C
	RLCF	TBLPTRL,F
	RLCF	TEMP1,F
;
	MOVF	TEMP1,W
	ADDWF	TBLPTRH,F
;0
	TBLRD*+
	MOVFF	TABLAT,Y_0
;1
	TBLRD*+
	MOVFF	TABLAT,Y_1
;2
	TBLRD*+
	MOVFF	TABLAT,Y_2
;3
	TBLRD*+
	MOVFF	TABLAT,Y_3
;4
	TBLRD*+
	MOVFF	TABLAT,Y_4
;5
	TBLRD*+
	MOVFF	TABLAT,Y_5
;6
	TBLRD*+
	MOVFF	TABLAT,Y_6
;
	CLRF	Y_EXP
;
	RETURN
;********************************************************************
;	BCD<->BIN CONVERSIONS
;********************************************************************
;BCD2_2_BIN8 : CONVERTS A PACKED BCD NUMBER IN W-REG INTO BINARY VALUE
;RESULT ALSO STORED IN W-REG
;DESTROYS : WREG, BCD_REG
BCD2_2_BIN8	MOVWF	BCD_REG	;SAVE THE ORIGINAL VALUE
	SWAPF	BCD_REG,W	;NIBBLES ARE SWAPPED
	ANDLW	H'0F'	;W = TENS
	RLNCF	WREG,W	;W = 2*TENS
;NOTE : SUBWF -> SUBTRACT W FROM F
	SUBWF	BCD_REG,F	;16*TENS + ONES  - 2*TENS
	SUBWF	BCD_REG,F	;14*TENS + ONES  - 2*TENS
	SUBWF	BCD_REG,W	;12*TENS + ONES  - 2*TENS
	RETURN
;********************************************************************
;BIN8_2_BCD2 : CONVERT A BINARY NUMBER IN W-REG INTO PACKED BCD NUMBER.
;RESULT ALSO STORED IN W-REG
;DESTROYS : WREG, BCD_REG, BCD_HI,
BIN8_2_BCD2	CLRF	BCD_HI
	MOVWF	BCD_REG
GET_TENTH	MOVLW	D'10'
;NOTE : SUBWF -> SUBTRACT W FROM F
	SUBWF	BCD_REG,W
	BTFSS	C	;SKIP IF C = 1 -> RESULT = 0 or POSITIVE
	BRA	BIN_2_BCD_END
	MOVWF	BCD_REG
	INCF	BCD_HI,F
	BRA	GET_TENTH
;
BIN_2_BCD_END	SWAPF	BCD_HI,W
	IORWF	BCD_REG,W
	RETURN
;********************************************************************
;BIN16_2_BCD5
;INPUT:16 BIT BINARY NUMBER IN HEX_HI, HEX_LO REGISTERS
;OUTPUT:5 DIGIT BCD NUMBER IN BCD_UP...BCD_REG REGISTERS
;CALLS:ADJBCD
;DESTROYS:W,HEXCNT,BCD_UP(MSD)...BCD_REG(LSD),HEXTEMP,HEX_HI...HEX_LO
BIN16_2_BCD5	BCF	C
	MOVLW	D'16'
	MOVWF	HEXCNT
	CLRF	BCD_REG
	CLRF	BCD_HI
	CLRF	BCD_UP
LOOP16	RLCF	HEX_LO,F
	RLCF	HEX_HI,F
	RLCF	BCD_REG,F
	RLCF	BCD_HI,F
	RLCF	BCD_UP,F
	DECFSZ	HEXCNT,F
	BRA	ADJDEC
	RETURN
;
ADJDEC	LFSR	2,BCD_REG
	CALL	ADJBCD
	LFSR	2,BCD_HI
	CALL	ADJBCD
	LFSR	2,BCD_UP
	CALL	ADJBCD
	BRA	LOOP16
;********************************************************************
ADJBCD	MOVLW	D'3'
	ADDWF	INDF2,W
	MOVWF	HEXTEMP
	BTFSC	HEXTEMP,3
	MOVWF	INDF2
	MOVLW	H'30'
	ADDWF	INDF2,W
	MOVWF	HEXTEMP
	BTFSC	HEXTEMP,7
	MOVWF	INDF2
;
	RETURN
;********************************************************************
;	MISC. ROUTINES
;********************************************************************
;CHANGE_XY
CHANGE_XY	MOVFF	X_0,TEMP
	MOVFF	Y_0,X_0
	MOVFF	TEMP,Y_0
;
	MOVFF	X_1,TEMP
	MOVFF	Y_1,X_1
	MOVFF	TEMP,Y_1
;
	MOVFF	X_2,TEMP
	MOVFF	Y_2,X_2
	MOVFF	TEMP,Y_2
;
	MOVFF	X_3,TEMP
	MOVFF	Y_3,X_3
	MOVFF	TEMP,Y_3
;
	MOVFF	X_4,TEMP
	MOVFF	Y_4,X_4
	MOVFF	TEMP,Y_4
;
	MOVFF	X_5,TEMP
	MOVFF	Y_5,X_5
	MOVFF	TEMP,Y_5
;
	MOVFF	X_6,TEMP
	MOVFF	Y_6,X_6
	MOVFF	TEMP,Y_6
;
	MOVFF	X_EXP,TEMP
	MOVFF	Y_EXP,X_EXP
	MOVFF	TEMP,Y_EXP
;CHANGE SIGNS
	MOVFF	SIGN_REG,TEMP
;TEMP,0 = X_SIGN, TEMP,1 = Y_SIGN
	BCF	X_SIGN
	BTFSC	TEMP,1	;!Y_SIGN!
	BSF	X_SIGN
;
	BCF	Y_SIGN
	BTFSC	TEMP,0
	BSF	Y_SIGN
;
	MOVFF	EXP_SIGN_REG,TEMP
;TEMP,0 = X_EXP_SIGN, TEMP,1 = Y_EXP_SIGN
	BCF	X_EXP_SIGN
	BTFSC	TEMP,1
	BSF	X_EXP_SIGN
;
	BCF	Y_EXP_SIGN
	BTFSC	TEMP,0
	BSF	Y_EXP_SIGN
;
	RETURN
;********************************************************************
;	EXPONENT ARITHMETIC SUBROUTINES
;********************************************************************
;INCREMENT_X_EXP
;IF X-EXPONENT-SIGN IS POSITIVE -> ADD 1 TO EXPONENT
;IF X-EXPONENT-SIGN IS NEGATIVE -> SUBTRACT 1 FROM EXPONENT
INCREMENT_X_EXP	BTFSC	X_EXP_SIGN	;SKIP IF X_EXPONENT IS POSITIVE
	BRA	DEC_X_EXP
;
INC_X_EXP	BCF	C
	MOVLW	D'1'
	ADDWFC	X_EXP,W
	DAW
	MOVWF	X_EXP
;RESET X-EXPONENT-SIGN IF X_EXP = 0
	MOVF	X_EXP,F
	BTFSC	Z
	BCF	X_EXP_SIGN
;
	RETURN
;********************************************************************
;DECREMENT_X_EXP : DECREMENT X-EXPONENT
DECREMENT_X_EXP BTFSC	X_EXP_SIGN	;SKIP IF X_EXPONENT IS POSITIVE
	BRA	INC_X_EXP
;DEC_X_EXP
DEC_X_EXP	BCF	C
	MOVLW	H'99'	;PACKED-BCD -> TEN'S COMPLEMENT OF 1
	ADDWFC	X_EXP,W
	DAW	
	MOVWF	X_EXP
	BTFSS	C
	BRA	DEC_X_EXP_10
;RESET X-EXPONENT-SIGN IF X_EXP = 0
	MOVF	X_EXP,F
	BTFSC	Z	;SKIP IF EXPONENT =/= 0
	BCF	X_EXP_SIGN
;
	RETURN	
;
DEC_X_EXP_10	GET_10S_COMP	X_EXP,X_EXP
	BSF	X_EXP_SIGN
;RESET X-EXPONENT-SIGN IF X_EXP = 0
	MOVF	X_EXP,F
	BTFSC	Z	;SKIP IF EXPONENT =/= 0
	BCF	X_EXP_SIGN
;
	RETURN
;********************************************************************
;INCREMENT_Y_EXP
;IF Y-EXPONENT-SIGN IS POSITIVE -> ADD 1 TO EXPONENT
;IF Y-EXPONENT-SIGN IS NEGATIVE -> SUBTRACT 1 FROM EXPONENT
INCREMENT_Y_EXP	BTFSC	Y_EXP_SIGN	;SKIP IF Y_EXPONENT IS POSITIVE
	BRA	DEC_Y_EXP
;
INC_Y_EXP	BCF	C
	MOVLW	D'1'
	ADDWFC	Y_EXP,W
	DAW
	MOVWF	Y_EXP
;
	MOVF	Y_EXP,F
	BTFSC	Z	;SKIP IF EXPONENT =/= 0
	BCF	Y_EXP_SIGN
;
	RETURN
;********************************************************************
;DECREMENT_Y_EXP
DECREMENT_Y_EXP BTFSC	Y_EXP_SIGN	;SKIP IF X_EXPONENT IS POSITIVE
	BRA	INC_Y_EXP
;
DEC_Y_EXP	BCF	C
	MOVLW	H'99'	;PACKED-BCD -> TEN'S COMPLEMENT OF 1
	ADDWFC	Y_EXP,W
	DAW	
	MOVWF	Y_EXP
	BTFSS	C
	BRA	DEC_Y_EXP_10
;RESET Y-EXPONENT-SIGN IF Y_EXP = 0
	MOVF	Y_EXP,F
	BTFSC	Z
	BCF	Y_EXP_SIGN	
;
DEC_Y_EXP_10	GET_10S_COMP	Y_EXP,Y_EXP
	BSF	Y_EXP_SIGN
;RESET Y-EXPONENT-SIGN IF Y_EXP = 0
	MOVF	Y_EXP,F
	BTFSC	Z
	BCF	Y_EXP_SIGN
;
	RETURN
;********************************************************************
;ADD_Y_EXP_2_X_EXP : ADD Y-EXPONENT TO X-EXPONENT
ADD_Y_EXP_2_X_EXP BCF	C	;NO INCOMING OVERFLOW
	CLRF	ERROR_REG	;DEFAULT
	MOVF	Y_EXP,W
	ADDWFC	X_EXP,W
	DAW	
	MOVWF	X_EXP
;
	BTFSS	C	;SKIP IF OVERFLOW
	RETURN
;
	BSF	ERROR_BIT
	BSF	OVFL_BIT
;
	RETURN
;********************************************************************
;SUB_Y_EXP_FROM_X_EXP : |X_EXP| - |Y_EXP|
SUB_Y_EXP_FROM_X_EXP
	MOVF	Y_EXP,F	;ZERO CHECKING
	BNZ	SUB_Y_E_F_X_E
	RETURN		;X_EXP - 0 = X_EXP
;
SUB_Y_E_F_X_E	BCF	X_EXP_SIGN
	BCF	Y_EXP_SIGN
	CLRF	Y_EXP_TEMP
;10'S COMPLEMENT
	GET_10S_COMP	Y_EXP,Y_EXP_TEMP
;NOW ADD TEN'S COMPLEMENT OF Y-EXPONENT TO X-EXPONENT
	BCF	C
	MOVF	X_EXP,W
	ADDWFC	Y_EXP_TEMP,W
	DAW
	MOVWF	X_EXP
;
	BTFSC	C
	RETURN
;RESULT OF SUBTRACTION IS NEGATIVE
	GET_10S_COMP	X_EXP,X_EXP
	BSF	X_EXP_SIGN
;
	RETURN
;********************************************************************
;SUB_X_EXP_FROM_Y_EXP : |Y_EXP| - |X_EXP|
SUB_X_EXP_FROM_Y_EXP
	MOVF	X_EXP,F	;ZERO CHECKING
	BNZ	SUB_X_E_F_Y_E
	MOVFF	Y_EXP,X_EXP	;Y_EXP - 0 = Y_EXP
	RETURN
;
SUB_X_E_F_Y_E	BCF	Y_EXP_SIGN
	BCF	X_EXP_SIGN
	CLRF	X_EXP_TEMP
;10'S COMPLEMENT
	GET_10S_COMP	X_EXP,X_EXP_TEMP
;NOW ADD 10'S COMPLEMENT OF X-EXPONENT TO Y-EXPONENT
	BCF	C
	MOVF	Y_EXP,W
	ADDWFC	X_EXP_TEMP,W
	DAW
	MOVWF	X_EXP
;
	BTFSC	C
	RETURN
;RESULT OF SUBTRACTION IS NEGATIVE
	GET_10S_COMP	X_EXP,X_EXP
	BSF	X_EXP_SIGN
;
	RETURN
;********************************************************************
;ADD_B_2_Q : ADD B_b TO Q_q
;RESULT IN Q_q
;16 DIGIT PACKED BCD ADDITION
ADD_B_2_Q	BCF	C	;NO INCOMING OVERFLOW
;0
	MOVF	Q_0,W
	ADDWFC	B_0,W
	DAW
	MOVWF	Q_0
;1
	MOVF	Q_1,W
	ADDWFC	B_1,W
	DAW
	MOVWF	Q_1
;2
	MOVF	Q_2,W
	ADDWFC	B_2,W
	DAW
	MOVWF	Q_2
;3
	MOVF	Q_3,W
	ADDWFC	B_3,W
	DAW
	MOVWF	Q_3
;4
	MOVF	Q_4,W
	ADDWFC	B_4,W
	DAW
	MOVWF	Q_4
;5
	MOVF	Q_5,W
	ADDWFC	B_5,W
	DAW
	MOVWF	Q_5
;6
	MOVF	Q_6,W
	ADDWFC	B_6,W
	DAW
	MOVWF	Q_6
;
	RETURN
;********************************************************************
;ADD_X_2_Q : ADD X_x TO Q_q
;RESULT IN Q_q
;14 DIGIT PACKED BCD ADDITION
ADD_X_2_Q	BCF	C	;NO INCOMING OVERFLOW
;0
	MOVF	Q_0,W
	ADDWFC	X_0,W
	DAW
	MOVWF	Q_0
;1
	MOVF	Q_1,W
	ADDWFC	X_1,W
	DAW
	MOVWF	Q_1
;2
	MOVF	Q_2,W
	ADDWFC	X_2,W
	DAW
	MOVWF	Q_2
;3
	MOVF	Q_3,W
	ADDWFC	X_3,W
	DAW
	MOVWF	Q_3
;4
	MOVF	Q_4,W
	ADDWFC	X_4,W
	DAW
	MOVWF	Q_4
;5
	MOVF	Q_5,W
	ADDWFC	X_5,W
	DAW
	MOVWF	Q_5
;6
	MOVF	Q_6,W
	ADDWFC	X_6,W
	DAW
	MOVWF	Q_6
;
	RETURN
;********************************************************************
;ADD_R_2_P
;RESULT IN P_p
;28 DIGIT PACKED BCD ADDITION
ADD_R_2_P	BCF	C	;NO INCOMING OVERFLOW
;0
	MOVF	P_0,W
	ADDWFC	R_0,W
	DAW
	MOVWF	P_0
;1
	MOVF	P_1,W
	ADDWFC	R_1,W
	DAW
	MOVWF	P_1
;2
	MOVF	P_2,W
	ADDWFC	R_2,W
	DAW
	MOVWF	P_2
;3
	MOVF	P_3,W
	ADDWFC	R_3,W
	DAW
	MOVWF	P_3
;4
	MOVF	P_4,W
	ADDWFC	R_4,W
	DAW
	MOVWF	P_4
;5
	MOVF	P_5,W
	ADDWFC	R_5,W
	DAW
	MOVWF	P_5
;6
	MOVF	P_6,W
	ADDWFC	R_6,W
	DAW
	MOVWF	P_6
;7
	MOVF	P_7,W
	ADDWFC	R_7,W
	DAW
	MOVWF	P_7
;8
	MOVF	P_8,W
	ADDWFC	R_8,W
	DAW
	MOVWF	P_8
;9
	MOVF	P_9,W
	ADDWFC	R_9,W
	DAW
	MOVWF	P_9
;A
	MOVF	P_A,W
	ADDWFC	R_A,W
	DAW
	MOVWF	P_A
;B
	MOVF	P_B,W
	ADDWFC	R_B,W
	DAW
	MOVWF	P_B
;C
	MOVF	P_C,W
	ADDWFC	R_C,W
	DAW
	MOVWF	P_C
;D
	MOVF	P_D,W
	ADDWFC	R_D,W
	DAW
	MOVWF	P_D
;
	RETURN
;********************************************************************





