;NSC_SCIENTIST
;NSC MM5758 CALCULATOR IC CLONE
;DISPLAY: NSA5101 (THE ORIGINAL NSC DISPLAY)
;SOFTWARE VERSION : 1.0.
;HARDWARE VERSION : 1.0.
;LAST REVISION: 2018. 08. 15.
;WRITTEN BY KOVAX
;FREQUENCY = 32MHz
	NOLIST
	#INCLUDE	 <P18F47J13.INC>
	LIST
;******************************************************************************
	CONFIG	OSC=INTOSCPLLO
	CONFIG	FCMEN=ON
	CONFIG	IESO=ON
	CONFIG	WDTEN=ON
	CONFIG	WDTPS = 32768
	CONFIG	RTCOSC = T1OSCREF
	CONFIG	SOSCSEL = HIGH
	CONFIG	CP0 = OFF
	CONFIG	DSBOREN = OFF        ;Disabled
	CONFIG	DSWDTEN = OFF        ;Disabled
	CONFIG	XINST = OFF
;
	ERRORLEVEL	-311	;DON'T WARN ON HIGH OPERATOR VALUES -> 16-bits
;********************************************************************
	RADIX	HEX
;********************************************************************
;FOR BAUD-RATE CALCULATION:
OSCFREQ	EQU	D'32'	;OSCILLATOR FREQUENCY IN MHz
OSCFREQ10	EQU	OSCFREQ*D'10'	;USED AT WAIT ROUTINES
;USART USED IN TEST PERIOD, ONLY
CLOCKRATE	EQU	D'32000000'	;
;SPBRGH & SPBRG ARE USED!
FCLK	EQU	(CLOCKRATE/D'4')
;REQUESTED BAUD-RATE #1
BAUDRATE1	EQU	D'460800'
BAUDCONST1	EQU	((FCLK/BAUDRATE1) - 1)
_SPBRGH1	EQU	HIGH BAUDCONST1
_SPBRG1	EQU	LOW BAUDCONST1
;********************************************************************
;PORT EQUATIONS
;PORT-A : DIGITAL OUTPUTS
#DEFINE	_RA7	PORTA,7	;NOT USED (OUTPUT)
#DEFINE	FOSC_OUT	PORTA,6	;fosc/4 (OUTPUT)
#DEFINE	_RA5	PORTA,5	;NOT USED (OUTPUT)
#DEFINE	_RA4	PORTA,4	;NOT USED (OUTPUT)
#DEFINE	DS8868_DD	LATA,3	;DS 8868 DIGIT DRIVER-DD (OUTPUT)
#DEFINE	DS8868_DC	LATA,2	;DS 8868 DIGIT DRIVER-DC (OUTPUT)
#DEFINE	DS8868_DB	LATA,1	;DS 8868 DIGIT DRIVER-DB (OUTPUT)
#DEFINE	DS8868_DA	LATA,0	;DS 8868 DIGIT DRIVER-DA (OUTPUT)
;
PADEF	EQU	B'00000000'	;PORT-A DEFAULT VALUES
PADIR	EQU	B'00000000'	;PORT-A DIRECTIONS
;********************************************************************
;PORT-B : DIGITAL INPUTS
#DEFINE	_PGD	PORTB,7	;ICP DATA -> NOT USED (INPUT)
#DEFINE	_PGC	PORTB,6	;ICP CLOCK -> NOT USED (INPUT)
#DEFINE	_RB5	PORTB,5	;NOT USED (INPUT)
#DEFINE	DISP_RES	LATB,4	;DISP_RES (INPUT) TEST OUTPUT!
#DEFINE	K4	PORTB,3	;KEYBOARD INPUT-4 (INPUT)	
#DEFINE	K3	PORTB,2	;KEYBOARD INPUT-3 (INPUT)
#DEFINE	K2	PORTB,1	;KEYBOARD INPUT-2 (INPUT)
#DEFINE	K1	PORTB,0	;KEYBOARD INPUT-1 (INPUT)
;
PBDEF	EQU	B'11101111'	;DEFAULT VALUE
PBDIR	EQU	B'11101111'	;DIRECTION
;********************************************************************
;PORT-C : DIGITAL I/O
#DEFINE	RXD	PORTC,7	;SERIAL RxD BIT (INPUT)
#DEFINE	TXD	PORTC,6	;SERIAL TxD BIT (OUTPUT)
#DEFINE	_RC5	PORTC,5	;NOT USED (OUTPUT)
#DEFINE	_RC4	PORTC,4	;NOT USED (OUTPUT)
#DEFINE	_RC3	PORTC,3	;NOT USED (OUTPUT)
#DEFINE	_RC2	PORTC,2	;NOT USED (OUTPUT)
#DEFINE	_RC1	PORTC,1	;NOT USED (OUTPUT)
#DEFINE	READY#	LATC,0	;READY (OUTPUT)
;
PCDEF	EQU	B'11000001'	;DEFAULT VALUE
PCDIR	EQU	B'10000000'	;DIRECTION
;********************************************************************
;PORT-D : DIGITAL OUTPUTS -> DISPLAY ANODE SEGMENTS
#DEFINE	SEGMENT_F	LATD,7	;SEGMENT-F (OUTPUT)
#DEFINE	SEGMENT_B	LATD,6	;SEGMENT-B (OUTPUT)
#DEFINE	SEGMENT_G	LATD,5	;SEGMENT-G (OUTPUT)
#DEFINE	SEGMENT_D	LATD,4	;SEGMENT-D (OUTPUT)
#DEFINE	SEGMENT_E	LATD,3	;SEGMENT-E (OUTPUT)
#DEFINE	SEGMENT_A	LATD,2	;SEGMENT-A (OUTPUT)
#DEFINE	SEGMENT_DP	LATD,1	;SEGMENT-DP (OUTPUT)
#DEFINE	SEGMENT_C	LATD,0	;SEGMENT-C (OUTPUT)
;
PDDEF	EQU	H'00'
PDDIR	EQU	H'00'
;********************************************************************
;PORT-E : DIGITAL OUTPUTS
#DEFINE	_RE2	LATE,2	;NOT USED (OUTPUT)
#DEFINE	_RE1	LATE,1	;NOT USED (OUTPUT)
#DEFINE	_RE0	LATE,0	;NOT USED (OUTPUT)
;
PEDEF	EQU	H'00'
PEDIR	EQU	H'00'
;********************************************************************
;FILE REGISTERS USED BY PROGRAM
;********************************************************************
CMDREG	EQU	H'100'	;COMMAND REGISTER
NUM1	EQU    	H'101'	;LAST HEX CODE FROM INPUT STREAM
NUM2	EQU	H'102'
NUM3	EQU	H'103'
NUM4	EQU    	H'104'
NUM5	EQU	H'105'
NUM6	EQU	H'106'
NUM7	EQU	H'107'
NUM8	EQU	H'108'
COUNTER	EQU	H'109'
UPBYTE	EQU	H'10A'	;UPPER POINTER
HIBYTE	EQU	H'10B'	;HIGH POINTER
LOBYTE	EQU	H'10C'	;LOW POINTER
ADDRUP	EQU	H'10D'	;ADDRESS UPPER REGISTER
ADDRHI	EQU	H'10E'	;ADDRESS HIGH REGISTER
ADDRLO	EQU	H'10F'	;ADDRESS LOW REGISTER
;********************************************************************
TBLOFFSET	EQU	H'110'	;TABLE R/W OFFSET REGISTER
LOOP_COUNTER	EQU	H'111'
LOOP_CNT	EQU	H'112'	;
COUNT	EQU	H'113'	;UNIVERSAL COUNTER
BITCNT	EQU	H'114'	;BIT COUNTER
BYTCNT	EQU	H'115'	;BYTE COUNTER
LINE_CNT	EQU	H'116'	;LINE COUNTER AT DUMP FUNCTION
TEMP	EQU	H'117'	;GENERAL PURPUSE TEMPORARY REGISTER
TEMP1	EQU	H'118'	;GENERAL PURPUSE TEMPORARY REGISTER #1
TEMP2	EQU	H'119'	;GENERAL PURPUSE TEMPORARY REGISTER #2
TEMPIKE	EQU	H'11A'	;GENERAL PURPUSE TEMPORARY REGISTER
DELAY_HI	EQU	H'11B'	;VALUE OF DELAY_HI DEFINES THE DELAY IN msecs
DELAY_LO	EQU	H'11C'	;USED AT WAIT (OR DELAY) ROUTINES
DELAY_CNT	EQU	H'11D'	;
FLAGS	EQU	H'11E'	;FLAG REGISTER
#DEFINE	NBIT	FLAGS,2	;"NUMBER O.K." BIT
#DEFINE	EBIT	FLAGS,1	;"ERROR" BIT
#DEFINE	VBIT	FLAGS,0	;"VALID" DELIMITER (CR) BIT
MISCREG	EQU	H'11F'
#DEFINE	X_1_BIT	MISCREG,7
#DEFINE	RX_BIT	MISCREG,6
#DEFINE	X_OVFL	MISCREG,5
#DEFINE	NEWD	MISCREG,3	;"NEW DIGIT" CAME
#DEFINE	IT_BIT	MISCREG,2
#DEFINE	POS_BIT	MISCREG,1	;IF POS_BIT=1 > RESULT OF SUBTRACTION IS POSITIVE
#DEFINE	NON0BIT	MISCREG,0
;********************************************************************
;	EQU	H'120'
;	EQU	H'121'
;	EQU	H'122'
;	EQU	H'123'
;	EQU	H'124'
;	EQU	H'125'
;	EQU	H'126'
;MISC. REGISTERS
HEXCNT	EQU	H'127'
HEXTEMP	EQU	H'128'
HEX_HI	EQU	H'129'
HEX_LO	EQU	H'12A'
BCD_REG	EQU	H'12B'
SFE_NUMBER	EQU	H'12C'	;NUMBER OF DISPLAYED DECIMALS
REL_CNT	EQU	H'12D'
DIGIT_CODE	EQU	H'12E'
PC_TEMP	EQU	H'12F'
;********************************************************************
KEYREG	EQU	H'130'
KEYBITS	EQU	H'131'
#DEFINE	START_BIT	KEYBITS,7	
#DEFINE	STOP_BIT	KEYBITS,6
#DEFINE	ESC_BIT	KEYBITS,2
#DEFINE	REL_BIT	KEYBITS,1	;1, IF VALID DEBOUNCING
#DEFINE	KEY_ON	KEYBITS,0	;1, IF KEY WAS PRESSED
BIT_REG	EQU	H'132'
#DEFINE	LIFT_BIT	BIT_REG,7	;0: LIFT DISABLED, 1: LIFT ENABLED
#DEFINE	STACK_BIT	BIT_REG,0	;0: NORMAL DISPLAY, 1: STACK DISPLAY
LOOP_REG	EQU	H'133'
MUL_X	EQU	H'134'
;	EQU	H'135'
;	EQU	H'136'
;	EQU	H'137'
;	EQU	H'138'
;	EQU	H'139'
;	EQU	H'13A'
;	EQU	H'13B'
;	EQU	H'13C'
;	EQU	H'13D'
;	EQU	H'13E'
;	EQU	H'13F'
;********************************************************************
;TEMPORARY STORAGE AREA FROM H'140' TO H'14F'
POINTER	EQU	H'140'
;********************************************************************
;	EQU	H'150'	;FOR FUTURE USE
DISP_1ST	EQU	H'151'
DISP_2ND	EQU	H'152'
DISP_3RD	EQU	H'153'
DISP_4TH	EQU	H'154'
DISP_5TH	EQU	H'155'
DISP_6TH	EQU	H'156'
DISP_7TH	EQU	H'157'
DISP_8TH	EQU	H'158'
DISP_9TH	EQU	H'159'	;FOR FUTURE USE
DISP_10TH	EQU	H'15A'	;FOR FUTURE USE
DISP_EXP_SIGN	EQU	H'15B'
DISP_EXP_10S	EQU	H'15C'
DISP_EXP_1S	EQU	H'15D'
;	EQU	H'15E'
CHAR_POS_SAVE	EQU	H'15F'
;********************************************************************
LED_0	EQU	H'160'	;NOT USED
LED_1	EQU	H'161'	;SIGN, EXP-SIGN, 2nd_BIT
LED_2	EQU	H'162'	;LEFTMOST DIGIT OF MANTISSA
LED_3	EQU	H'163'
LED_4	EQU	H'164'
LED_5	EQU	H'165'
LED_6	EQU	H'166'
LED_7	EQU	H'167'
LED_8	EQU	H'168'
LED_9	EQU	H'169'	;RIGHTMOST DIGIT OF MANTISSA
LED_10	EQU	H'16A'	;NOT USED
LED_11	EQU	H'16B'	;NOT USED
LED_12	EQU	H'16C'	;NOT USED
LED_EXP_10S	EQU	H'16D'	;TENS OF EXPONENT
LED_EXP_1S	EQU	H'16E'	;UNITS OF EXPONENT
LED_15	EQU	H'16F'	;NOT USED
;********************************************************************
	NOLIST
	#INCLUDE	<REGISTERS.INC>
	LIST
;********************************************************************
MEM_STO_RCL	EQU	H'0300'	;REGISTERS USED AT MEMORY RELATED OPERATIONS
;********************************************************************
;Keycodes -> ASCII characters & their functions
;	
;a	A	0: 0
;b	B	1: 1
;c: COS	C: ON/C	2: 2
;d	D	3: 3
;e: e^x	E: ENTER	4: 4
;f	F	5: 5
;g	G	6: 6
;h	H: +/-	7: 7
;i	I	8: 8
;j	J	9: 9
;k	K	,: DP
;l	L: 2nd	+: ADD
;m	M	-: SUB
;n	N	*: MUL
;o	O: ROLL	/: DIV
;p	P
;q	Q: SQR
;r	R: RCL
;s: SIN	S: STO
;t: TAN	T
;u	U
;v	V
;w	W
;x: 10^x	X: EE
;y: y^x	Y
;z	Z
;********************************************************************
;DIGIT CODES -> DS8868 DIGIT DRIVER INPUT CODES
DIGIT1_CODE	EQU	H'0C'
DIGIT2_CODE	EQU	H'0F'
DIGIT3_CODE	EQU	H'07'
DIGIT4_CODE	EQU	H'0B'
DIGIT5_CODE	EQU	H'05'
DIGIT6_CODE	EQU	H'0A'
DIGIT7_CODE	EQU	H'0D'
DIGIT8_CODE	EQU	H'06'
DIGIT9_CODE	EQU	H'03'
DIGIT10_CODE	EQU	H'0E'
DIGIT11_CODE	EQU	H'01'
DIGIT12_CODE	EQU	H'08'
DIGIT_BLANK	EQU	H'00'
;********************************************************************
;	MACRO DEFINITIONS
;********************************************************************
TXT_OUT	MACRO	LABEL
	MOVLF	UPPER LABEL,TBLPTRU
	MOVLF	HIGH LABEL,TBLPTRH
	MOVLF	LOW LABEL,TBLPTRL
	CALL	TEXTOUT
	ENDM
;********************************************************************
CR	EQU	H'0D'	;^M Carriage Return
ESC	EQU	H'1B'	;^[ Escape
;********************************************************************
CR_ECHO	MACRO
	MOVLW	CR
	CALL	CO
	ENDM
;********************************************************************
;MOVLF : MOVES A LITERAL TO f	
MOVLF	MACRO	LITERAL,DESTINATION
	MOVLW	LITERAL
	MOVWF	DESTINATION
	ENDM
;********************************************************************
;GET_10S_COMP
GET_10S_COMP	MACRO	SOURCE,DESTINATION
	MOVLW	H'99'
	BSF	C	;C := 1	IMPORTANT!
	SUBFWB	SOURCE,F
	MOVLW	D'1'
	ADDWF	SOURCE,W
	DAW
	MOVFF	WREG,DESTINATION
	ENDM
;********************************************************************
;LOAD_CONST_2_X
LOAD_CONST_2_X	MACRO	LABEL
	MOVLF	UPPER LABEL,TBLPTRU
	MOVLF	HIGH LABEL,TBLPTRH
	MOVLF	LOW LABEL,TBLPTRL
	CALL	LOAD_C_2_X
	ENDM
;********************************************************************
;LOAD_CONST_2_Y
LOAD_CONST_2_Y	MACRO	LABEL
	MOVLF	UPPER LABEL,TBLPTRU
	MOVLF	HIGH LABEL,TBLPTRH
	MOVLF	LOW LABEL,TBLPTRL
	CALL	LOAD_C_2_Y
	ENDM
;********************************************************************
;STACK_LIFT_ENABLE
STACK_LIFT_ENABLE MACRO
	BSF	LIFT_BIT
	ENDM
;********************************************************************
;STACK_LIFT_DISABLE
STACK_LIFT_DISABLE MACRO
	BCF	LIFT_BIT
	ENDM
;********************************************************************
;LED_TXT
LED_TXT	MACRO	LABEL
	MOVLF	UPPER LABEL,TBLPTRU
	MOVLF	HIGH LABEL,TBLPTRH
	MOVLF	LOW LABEL,TBLPTRL
	CALL	LED_TEXT_OUT
	ENDM
;********************************************************************
	#INCLUDE	<TBL_MULTIPLICATION.INC>
;********************************************************************
	ORG	H'14000'	
	#INCLUDE	<TBL_PWR_OF_2.INC>
;********************************************************************
	ORG	H'14200'	
	#INCLUDE	<TBL_2_AD_MINUS_n.INC>
;********************************************************************
	ORG	H'14400'	;H'14300'
	#INCLUDE	<TBL_SQUARE_ROOT.INC>
;********************************************************************
	ORG	H'14600'	;H'14500'
	#INCLUDE	<TBL_REC_FACTORIAL.INC>
;********************************************************************
	ORG	H'14800'
	#INCLUDE	<TBL_for_LNx.INC>
;********************************************************************
	ORG	H'14A00'
	#INCLUDE	<TBL_ARCTAN.INC>
;********************************************************************
	ORG	H'14C00'
	#INCLUDE	<TBL_CONSTANTS.INC>
;********************************************************************
	ORG	H'15000'
	#INCLUDE	<TBL_FACTORIAL.INC>
;********************************************************************
	ORG	H'000000'
;********************************************************************
M_RESET	NOP
	GOTO	START
;********************************************************************
	ORG	H'000008'
	BRA	HIGH_INT
;********************************************************************
	ORG	H'000018'
LOW_INT	RETURN
;********************************************************************
	ORG	H'00001A'
;********************************************************************
;INTERRUPT HANDLING
HIGH_INT	BSF	IT_BIT
	CLRF	LATD	;TURN-OFF ALL SEGMENTS
	CLRF	LATA	;TURN-OFF ALL DIGITS
;PROGRAM CONTINUES ACCORDING TO PC_TEMP
	MOVF	PC_TEMP,W
	MOVWF	PCL
;THEORETICALLY PROGRAM NEVER CONTINUES HERE!
	NOP
	RESET
;DIGIT_1 & DIGIT_10 ARE HANDLED TOGETHER -> SIGN, UPPER-DOT, EXPONENT-SIGN
;MANTISSA SIGN, EXPONENT SIGN, 2nd BIT
DIGIT_1	MOVLF	DIGIT1_CODE,LATA
	MOVWF	DIGIT_CODE
	MOVFF	LED_1,LATD
	MOVLF	LOW DIGIT_2,PC_TEMP
	BSF	START_BIT	
	BRA	INTEND
;MOST SIGNIFICANT DIGIT OF MANTISSA
DIGIT_2	MOVLF	DIGIT2_CODE,LATA
	MOVWF	DIGIT_CODE
	MOVFF	LED_2,LATD
	BTFSC	DP_REG,7
	BSF	LATD,1
	MOVLF	LOW DIGIT_3,PC_TEMP
	BRA	INTEND
;
DIGIT_3	MOVLF	DIGIT3_CODE,LATA
	MOVWF	DIGIT_CODE
	MOVFF	LED_3,LATD
	BTFSC	DP_REG,6
	BSF	LATD,1
	MOVLF	LOW DIGIT_4,PC_TEMP
	BRA	INTEND
;
DIGIT_4	MOVLF	DIGIT4_CODE,LATA
	MOVWF	DIGIT_CODE
	MOVFF	LED_4,LATD
	BTFSC	DP_REG,5
	BSF	LATD,1
	MOVLF	LOW DIGIT_5,PC_TEMP
	BRA	INTEND
;
DIGIT_5	MOVLF	DIGIT5_CODE,LATA
	MOVWF	DIGIT_CODE
	MOVFF	LED_5,LATD	
	BTFSC	DP_REG,4
	BSF	LATD,1
	MOVLF	LOW DIGIT_6,PC_TEMP
	BRA	INTEND
;
DIGIT_6	MOVLF	DIGIT6_CODE,LATA
	MOVWF	DIGIT_CODE
	MOVFF	LED_6,LATD	
	BTFSC	DP_REG,3
	BSF	LATD,1
	MOVLF	LOW DIGIT_7,PC_TEMP
	BRA	INTEND
;
DIGIT_7	MOVLF	DIGIT7_CODE,LATA
	MOVWF	DIGIT_CODE
	MOVFF	LED_7,LATD
	BTFSC	DP_REG,2
	BSF	LATD,1
	MOVLF	LOW DIGIT_8,PC_TEMP
	BRA	INTEND
;
DIGIT_8	MOVLF	DIGIT8_CODE,LATA
	MOVWF	DIGIT_CODE
	MOVFF	LED_8,LATD
	BTFSC	DP_REG,1
	BSF	LATD,1
	MOVLF	LOW DIGIT_9,PC_TEMP
	BRA	INTEND
;LAST SIGNIFICANT DIGIT OF MANTISSA
DIGIT_9	MOVLF	DIGIT9_CODE,LATA
	MOVWF	DIGIT_CODE
	MOVFF	LED_9,LATD
	BTFSC	DP_REG,0
	BSF	LATD,1
	MOVLF	LOW DIGIT_11,PC_TEMP
	BRA	INTEND
;TEN's OF EXPONENT
DIGIT_11	MOVLF	DIGIT11_CODE,LATA
	MOVWF	DIGIT_CODE
	MOVFF	LED_EXP_10S,LATD
	MOVLF	LOW DIGIT_12,PC_TEMP
	BRA	INTEND
;UNIT's OF EXPONENT
DIGIT_12	MOVLF	DIGIT12_CODE,LATA
	MOVWF	DIGIT_CODE
	MOVFF	LED_EXP_1S,LATD
	MOVLF	LOW DIGIT_1,PC_TEMP
;
INTEND	CLRF	TMR0L
	BCF	TMR0IF
;
	RETFIE	FAST
;********************************************************************
	ORG	H'01400'
;********************************************************************
START	NOP
	NOP
	CLRF	STATUS
	MOVLF	H'00',INTCON
	CLRF	PCLATH
	CLRF	RCON
;OSCILLATOR SETTINGS, MFINTOSC = 8 MHz
	MOVLF	H'70',OSCCON
;PLL ENABLE -> 32 MHz	
	CLRF	OSCTUNE
	BSF	OSCTUNE,6
	BCF	SWDTEN
;NO A/D CONVERTERS
	MOVLW	H'00'
	MOVWF	ADCON0
	MOVLW	H'00'
	MOVWF	ADCON1
;
	MOVLB	H'0F'
	MOVLW	H'FF'
	MOVWF	ANCON0
	MOVWF	ANCON1
	MOVLB	H'01'
;
	MOVLF	PADEF,LATA
	MOVLF	PBDEF,LATB
	MOVLF	PCDEF,LATC
	MOVLF	PDDEF,LATD
	MOVLF	PEDEF,LATE
;PORT-A SETTING
	MOVLF	PADIR,TRISA
;PORT-B SETTING
	MOVLF	PBDIR,TRISB
	BCF	RBPU	;ENABLE PULL-UP ON PORT-B
;PORT-C SETTING
	MOVLF	PCDIR,TRISC
;PORT-D SETTING
	MOVLF	PDDIR,TRISD
;PORT-E SETTING
	MOVLF	PEDIR,TRISE
;
;TIMER0 SETTING
;T0CON,7 TMR0ON : 1 ENABLE TMR0
;T0CON,6 T08BIT : 1 TMR0: 8Bit COUNTER
;T0CON,5 T0CS   : 0 TMR0 FROM INSTRUCTION CLOCK -> 8 MHz	
;T0CON,4 T0SE   : 0 TMR0 INCREMENT ( DON'T CARE )
;T0CON,3 PSA    : 0 PRESCALER ASSIGNED TO TIMER0
;T0CON,2 PS2    : 1 TMR0 PRESCALER RATE = 64
;T0CON,1 PS1    : 0
;T0CON,0 PS0    : 1
	MOVLF	H'C5',T0CON
;USART #1 SETTING
	MOVLW	H'24'	;TRANSMIT STATUS WORD
	MOVWF	TXSTA
	MOVLW	H'90'	;RECEIVE STATUS WORD
	MOVWF	RCSTA
	MOVLW	H'08'
	MOVWF	BAUDCON
	MOVLF	_SPBRGH1,SPBRGH1
	MOVLF	_SPBRG1,SPBRG1
	CALL	CLR_USART1
;CLEAR MEMORIES
	LFSR	0,H'0000'
CLEAR_LOOP	MOVLW	H'00'
	MOVWF	POSTINC0
	MOVLW	H'04'
	XORWF	FSR0H,W	
	BNZ	CLEAR_LOOP
	CALL	CLEAR_P
	CALL	CLEAR_R
	CALL	CLEAR_T
	CALL	CLEAR_Z
	CALL	CLEAR_Y
	CALL	CLEAR_X
	BSF	READY#
;
	MOVLW	LOW DIGIT_1
	MOVWF	PC_TEMP
	BCF	TMR0IF
	BSF	TMR0IE
	BSF	GIE
;
START_ENTRY_0	MOVLF	D'8',DIGIT_CNT
	MOVLF	H'00',DP_REG
	MOVLF	H'00',DP_POS
	CALL	CLEAR_X
	MOVLF	"0",DISP_1ST	;H'30'
	CLRF	DISP_2ND
	CLRF	DISP_3RD
	CLRF	DISP_4TH
	CLRF	DISP_5TH
	CLRF	DISP_6TH
	CLRF	DISP_7TH
	CLRF	DISP_8TH
;
	MOVLF	" ",DISP_EXP_SIGN
	CLRF	DISP_EXP_10S
	CLRF	DISP_EXP_1S
	LFSR	0,DISP_1ST	;1ST DIGIT ADDRESS -> DISP_1ST
	BCF	_2ND_BIT
	CALL	DISPLAY_ENTRIES
;START_ENTRY
START_ENTRY	BSF	NEW_ENTRY_BIT	;SET NEW_ENTRY_BIT=1 -> NO NUMBERS ENTERED
	CLRF	OP_BITS
	CLRF	ENTRY_BITS	;MAX_NUM, DP_OK, _1ST_DIGIT_BIT  
	CLRF	ERROR_REG
	BCF	_2ND_BIT
	CLRF	MODE_REG	;ALG, DEG ....
	BSF	DEG_BIT	;ANGLES ARE IN DEGREES
;GET_NEXT_KEY -> MODE INDEPENDENT
GET_NEXT_KEY	BCF	READY#
	CALL	KEYIN
	BTFSS	KEY_ON	;SKIP IF A KEY WAS PRESSED
	BRA	GET_NEXT_KEY
;
	CLRWDT
	BCF	REL_BIT
	BSF	READY#
;KEY DECODING
KEY_ONC?	MOVLW	"C"
	XORWF	KEYREG,W
	BNZ	GET_NEXT_KEY_5
;ON/C KEY IS PRESSED
	CLRF	ERROR_REG
	STACK_LIFT_DISABLE
	BTFSS	_2ND_BIT	;SKIP IF _2ND_BIT = 1
	BRA	START_ENTRY_0	;CLEAR REGISTERS
;
	RESET		;TURN-OFF
;IF ERROR -> ON/C KEY IS ACCEPTED ONLY
GET_NEXT_KEY_5	BTFSC	ERROR_BIT	;SKIP IF NO ERROR OCCURED
	BRA	GET_NEXT_KEY
;
	MOVLW	"L"	;"bLue" KEY -> 2nd FUNCTION
	XORWF	KEYREG,W
	BNZ	DECODE_KEYS
	BTG	_2ND_BIT
	BRA	GET_NEXT_KEY
;
DECODE_KEYS	BTFSC	OP_BIT	;KEY ENTRY : OPERATION
	GOTO	KEYIN_OPERAND
;
	BTFSC	MEM_BIT	;MEMORY OPERATIONS
	GOTO	MEMORY_OPS
;
	BTFSC	DIGIT_BIT	;KEY ENTRY : DIGIT
	GOTO	DIGIT_ENTRY

;
	MOVLW	"a"	; CHANGE xy
	XORWF	KEYREG,W
	BTFSC	Z
	GOTO	KEY_CHANGE_X_Y
;
	MOVLW	"E"	; ENTER
	XORWF	KEYREG,W
	BTFSC	Z
	GOTO	KEY_ENTER
;
	MOVLW	"O"	; ROLL DOWN
	XORWF	KEYREG,W
	BTFSC	Z
	GOTO	KEY_ROLL_DOWN
;
	MOVLW	"P"	; pi
	XORWF	KEYREG,W
	BTFSC	Z
	GOTO	KEY_PI
;
	MOVLW	"H"	; CHANGE SIGN
	XORWF	KEYREG,W
	BTFSC	Z
	GOTO	KEY_CHANGE_SIGN	
;
	MOVLW	"X"	; ENTER EXPONENT
	XORWF	KEYREG,W
	BTFSC	Z
	GOTO	ENTER_EXPONENT
;
	MOVLW	","	; DECIMAL POINT (COMMA)
	XORWF	KEYREG,W
	BTFSC	Z
	GOTO	DECIMAL_POINT
;
	MOVLW	"s"	;SIN
	XORWF	KEYREG,W
	BTFSC	Z
	GOTO	KEY_TRIG_FUNCTION
;
	MOVLW	"c"	;COS
	XORWF	KEYREG,W
	BTFSC	Z
	GOTO	KEY_TRIG_FUNCTION
;
	MOVLW	"t"	;TAN
	XORWF	KEYREG,W
	BTFSC	Z
	GOTO	KEY_TRIG_FUNCTION
;
	MOVLW	"e"
	XORWF	KEYREG,W
	BTFSC	Z
	GOTO	KEY_E_AD_X	;e^x
;
	MOVLW	"x"
	XORWF	KEYREG,W
	BTFSC	Z
	GOTO	KEY_10_AD_X	;10^x
;
	MOVLW	"y"
	XORWF	KEYREG,W
	BTFSC	Z
	GOTO	KEY_Y_AD_X	;y^x
;
	MOVLW	"r"
	XORWF	KEYREG,W
	BTFSC	Z
	GOTO	KEY_RECIPROCAL	;1/x
;
	MOVLW	"Q"
	XORWF	KEYREG,W
	BTFSC	Z
	GOTO	KEY_SQUARE_ROOT	;x^1/2
;
	MOVLW	"G"
	XORWF	KEYREG,W
	BTFSC	Z
	GOTO	KEY_LOG_X	;LOGx
;
	MOVLW	"l"
	XORWF	KEYREG,W
	BTFSC	Z
	GOTO	KEY_LN_X	;LNx
;
	GOTO	GET_NEXT_KEY
;********************************************************************
; KEYIN_OPERAND
KEYIN_OPERAND	BTFSS	NEW_ENTRY_BIT
	CALL	COPY_ASCII_2_X
;
	BCF	OP_BIT
;
	MOVLW	"+"
	XORWF	KEYREG,W
	BTFSC	Z
	GOTO	KEY_ADDITION
;
	MOVLW	"-"
	XORWF	KEYREG,W
	BTFSC	Z
	GOTO	KEY_SUBTRACTION
;
	MOVLW	"*"
	XORWF	KEYREG,W
	BTFSC	Z
	GOTO	KEY_MULTIPLICATION
;
	MOVLW	"/"
	XORWF	KEYREG,W
	BTFSC	Z
	GOTO	KEY_DIVISION
;
	GOTO	GET_NEXT_KEY
;********************************************************************
;KEY_ADDITION : ADD Y_y REGISTER TO X_x REGISTER. RESULT IN X_x REGISTER.
;
; t ---------\----> T
; z -------\  \---> Z
; y |       \-----> Y
; x |-- y+x ------> X
;
; x --> LastX
;
KEY_ADDITION	CALL	COPY_X_2_LASTX
	CALL	ADD_YREG_2_XREG
	CALL	COPY_Z_2_Y
	CALL	COPY_T_2_Z
;
	BTFSC	ERROR_BIT	;SKIP IF NO ERROR
	GOTO	_ERROR
;
	CALL	DISPLAY_ANNS
	CALL	DISPLAY_X
;
	STACK_LIFT_ENABLE
	GOTO	START_ENTRY
;********************************************************************
;KEY_SUBTRACTION : SUBTRACT X_x REGISTER FROM Y_y REGISTER. RESULT IN X_x REGISTER.
;
; t ---------\----> T
; z -------\  \---> Z
; y |       \-----> Y
; x |-- y-x ------> X
;
; x --> LastX
;
KEY_SUBTRACTION	CALL	COPY_X_2_LASTX
	CALL	SUB_XREG_FROM_YREG
	CALL	COPY_Z_2_Y
	CALL	COPY_T_2_Z
;
	CALL	DISPLAY_ANNS
	CALL	DISPLAY_X
;
	STACK_LIFT_ENABLE
	GOTO	START_ENTRY
;********************************************************************
;KEY_MULTIPLICATION : MULTIPLY X_x BY Y_y.RESULT IN X_x REGISTER.
;
; t ---------\----> T
; z -------\  \---> Z
; y |       \-----> Y
; x |-- y*x ------> X
;
; x --> LastX
;
KEY_MULTIPLICATION	CALL	COPY_X_2_LASTX
	CALL	MUL_YREG_BY_XREG
	CALL	COPY_Z_2_Y
	CALL	COPY_T_2_Z
;
	BTFSC	ERROR_BIT	;SKIP IF NO ERROR
	GOTO	_ERROR
;
	CALL	DISPLAY_ANNS
	CALL	DISPLAY_X
;
	STACK_LIFT_ENABLE
	GOTO	START_ENTRY
;********************************************************************
;KEY_DIVISION : DIVIDE Y_y BY X_x. RESULT IN X_x REGISTER.
;
; t ---------\----> T
; z -------\  \---> Z
; y |       \-----> Y
; x |-- y/x ------> X
;
; x --> LastX
;
KEY_DIVISION	CALL	CHECK_X_0?	;CHECK DIVISOR =?= 0
	BTFSC	X_0_BIT
	BRA	DIVISION_5
;DIVISION BY 0 IS NOT POSSIBLE
	CLRF	ERROR_REG
	BSF	ERROR_BIT
	BSF	DIV0_BIT
	GOTO	_ERROR
;
DIVISION_5	CALL	COPY_X_2_LASTX
	CALL	DIV_YREG_BY_XREG
;
	CALL	COPY_Z_2_Y
	CALL	COPY_T_2_Z
;
	CALL	DISPLAY_ANNS
	CALL	DISPLAY_X
;
	STACK_LIFT_ENABLE
	GOTO	START_ENTRY
;********************************************************************
;KEY_ENTER 		CODE:"E"
;X_x REMAINS UNCHANGED, T_t: LOST
;
;       /---------> LOST
; t ---/  /-------> T
; z -----/  /-----> Z
; y -------/  /---> Y
; x ---------/----> X
;
KEY_ENTER	BTFSS	NEW_ENTRY_BIT	;SKIP IF NEW_ENTRY_BIT=1 -> NO NUMBERS ENTERED
;NUMBER(S) HAS(HAVE) BEEN ENTERED
	CALL	COPY_ASCII_2_X
	CALL	ENTER
;	CALL	DISPLAY_X
;
	STACK_LIFT_DISABLE
	GOTO	START_ENTRY
;********************************************************************
;ENTER
ENTER	CALL	COPY_Z_2_T
	CALL	COPY_Y_2_Z
	CALL	COPY_X_2_Y
;
	RETURN
;********************************************************************
;KEY_ROLL_DOWN		CODE:"O"
KEY_ROLL_DOWN	CALL	SAVE_X
	CALL	COPY_Y_2_X
	CALL	COPY_Z_2_Y
	CALL	COPY_T_2_Z
	CALL	COPY_X_SAVE_2_T
	CALL	DISPLAY_X
	GOTO	START_ENTRY
;********************************************************************
;KEY_CHANGE_SIGN	CODE:"H"
KEY_CHANGE_SIGN	BTFSC	EEX_BIT	;SKIP IF EEX_BIT = 0
	BRA	KEYIN_SIGN_EXP
;
	BTG	X_SIGN
	CALL	DISPLAY_ENTRIES
	GOTO	GET_NEXT_KEY
;
KEYIN_SIGN_EXP	BTG	X_EXP_SIGN
;
	MOVLW	" "	;DEFAULT
	BTFSC	X_EXP_SIGN
	MOVLW	"-"
	MOVWF	DISP_EXP_SIGN
	CALL	DISPLAY_ENTRIES
	GOTO	GET_NEXT_KEY
;********************************************************************
;KEY_CHANGE X & Y
KEY_CHANGE_X_Y	BTFSS	NEW_ENTRY_BIT	;SKIP IF NEW_ENTRY_BIT=1 -> NO NUMBERS ENTERED
	CALL	COPY_ASCII_2_X
	CALL	CHANGE_XY
	CALL	DISPLAY_X
	GOTO	GET_NEXT_KEY
;********************************************************************
; ENTER_EXPONENT	CODE:"X"
ENTER_EXPONENT	BTFSC	EEX_BIT
	GOTO	GET_NEXT_KEY	;DO NOTHING -> EEX_BIT HAS BEEN SET
;
	BSF	EEX_BIT
	MOVLW	"0"
	MOVWF	DISP_EXP_10S	;LOAD ZEROES INTO DISP_EXP REGITERS
	MOVWF	DISP_EXP_1S
;
	BTFSS	NEW_ENTRY_BIT	;SKIP IF NO DIGIT(S) ENTERED INTO MANTISSA	
	BRA	ENTER_EXPONENT_END
	MOVLF	"1",DISP_1ST
	MOVLF	D'1',X_6
	MOVLF	B'10000000',DP_POS
;
ENTER_EXPONENT_END
	MOVFF	DP_POS,DP_REG
	MOVLF	D'2',DIGIT_CNT	;NUBER OF EXPONENT DIGITS
	BCF	MAX_NUM
	CALL	DISPLAY_ENTRIES
	GOTO	GET_NEXT_KEY
;********************************************************************
;DECIMAL_POINT		CODE:","
DECIMAL_POINT	BTFSC	EEX_BIT
	GOTO	GET_NEXT_KEY	;DO NOTHING -> NO DP HANDLING AT EXPONENT
	BTFSC	DP_OK	;SKIP IF DECIMAL POINT HASN'T BEEN ENTERED YET	
	GOTO	GET_NEXT_KEY	;DP HAS BEEN ENTERED -> 2nd DP CANCELLED
;
	BTFSS	NEW_ENTRY_BIT	;SKIP IF NO DIGIT ENTERED YET
	BRA	DECIMAL_POINT_END
;
DP_ENTRY_1ST	CALL	NEW_ENTRY
;CHANGE SOME BITS ACCORDING TO THIS CASE
	DECF	DIGIT_CNT,F	;1st DIGIT IS 0, REMAIN 7 DIGITS
	MOVF	POSTINC0,W	;DUMMY READ -> SET NEXT DIGIT POINTER
	MOVLF	B'10000000',DP_POS
;
DECIMAL_POINT_END BSF	DP_OK
	MOVFF	DP_POS,DP_REG
	BCF	NEW_ENTRY_BIT
	CALL	DISPLAY_ENTRIES
	GOTO	GET_NEXT_KEY
;********************************************************************
;DIGIT_ENTRY
DIGIT_ENTRY	BTFSC	EEX_BIT	;SKIP IF NO EXPONENT ENTRY IS IN PROGRESS
	BRA	KEYIN_EXP
;
	BTFSC	MAX_NUM	;SKIP IF MAX. NUMBER HASN'T BEEN REACHED
	GOTO	GET_NEXT_KEY	;MAX. NUMBER HAS BEEN REACHED
;
	BTFSS	NEW_ENTRY_BIT	;SKIP IF NEW_ENTRY_BIT =1 -> NEW NUMBER ENTRY
	BRA	DIGIT_ENTRY_Nth
;CHECK THE LIFT_BIT
	BTFSS	LIFT_BIT	;SKIP IF STACK LIFTING IS ENABLED
	BRA	DIGIT_ENTRY_1st
;
	CALL	ENTER
	STACK_LIFT_DISABLE	
DIGIT_ENTRY_1st	CALL	NEW_ENTRY
;CHECK FIRST ENTERD DIGIT
	MOVLW	"0"
	XORWF	KEYREG,W	;FIRST NUMBER =?= 0
	BNZ	D_ENTRY_1st_5
;1st DIGIT=0  -> ACCEPTED & DP_POS IS SET	
	MOVLF	B'10000000',DP_POS
	MOVLF	B'10000000',DP_REG
	BSF	DP_OK
;1ST_DIGIT = 1...9
D_ENTRY_1st_5	MOVFF	KEYREG,POSTINC0
	MOVLF	B'10000000',DP_POS
	DECF	DIGIT_CNT,F	;DIGIT_CNT=7
	BCF	NEW_ENTRY_BIT
	BRA	DIGIT_ENTRY_END
;Nth: 2nd....8th
DIGIT_ENTRY_Nth	MOVFF	KEYREG,POSTINC0
	DECF	DIGIT_CNT,F	;DIGIT_CNT=7
	BTFSC	Z	;SKIP IF DIGIT_CNT =/= 0
	BSF	MAX_NUM	;DIGIT_CNT = 0 -> SET MAX_NUM
;
	BTFSS	DP_OK	;SKIP IF DECIMAL POINT HAS BEEN ENTERED
	RRNCF	DP_POS,F
	BRA	DIGIT_ENTRY_END
;
KEYIN_EXP	BTFSC	MAX_NUM	;2
	GOTO	GET_NEXT_KEY
;
	MOVLW	D'2'
	XORWF	DIGIT_CNT,W	;COMPARE 2 & DIGIT_CNT
	BZ	KEYIN_DIG_EXP_2
;1 DIGIT HAS BEEN ENTERED INTO EXPONENT -> THE 2nd DIGIT TERMINATES THE NUMBER ENTRY INTO EXPONENT
KEYIN_DIG_EXP_1	MOVFF	DISP_EXP_1S,DISP_EXP_10S
	MOVFF	KEYREG,DISP_EXP_1S
	BSF	MAX_NUM
	CLRF	DIGIT_CNT
	BRA	DIGIT_ENTRY_END
;NO EXPONENT DIGIT ENTERED YET -> THIS IS THE 1st DIGIT
KEYIN_DIG_EXP_2	MOVFF	KEYREG,DISP_EXP_1S ;COPY THE ENTERED NUMBER INTO EXPONENT UNITS
	DECF	DIGIT_CNT,F
	BCF	NEW_ENTRY_BIT
;
DIGIT_ENTRY_END CALL	DISPLAY_ENTRIES
	GOTO	GET_NEXT_KEY
;********************************************************************
;KEY_PI : LOAD CONSTANT Pi TO X-REG.
KEY_PI	BCF	_2ND_BIT	
	BTFSC	LIFT_BIT	;SKIP IF LIFT_BIT=0 -> STACK-LIFT DISABLED
	CALL	ENTER
;X := 3,1415.9265.3589 -> NUMBER_PI
	LOAD_CONST_2_X	CONST_PI
	CALL	DISPLAY_X
;
	STACK_LIFT_ENABLE	;???????
	GOTO	START_ENTRY
;********************************************************************
;KEY_TRIG_FUNCTION
KEY_TRIG_FUNCTION
	BTFSS	NEW_ENTRY_BIT
	CALL	COPY_ASCII_2_X
;
	BTFSC	_2ND_BIT
	GOTO	ARCUS_FUNCTION
;
	GOTO	TRIG_FUNCTION
;********************************************************************
;KEY_SQUARE_ROOT
;NEWTON-RAPHSON ITERATION METHOD
;Rn+1 = [Rn + N/Rn] / 2
;N = THE NUMBER WHOSE SQUARE ROOT IS DESIRED
;Rn = INITIAL VALUE, WHERE n=0
;~192 msec @ 32MHz
KEY_SQUARE_ROOT	BTFSS	NEW_ENTRY_BIT
	CALL	COPY_ASCII_2_X
;CHECK X_SIGN
	BTFSS	X_SIGN
	BRA	SQUARE_ROOT_10
;
	CLRF	ERROR_REG
	BSF	ERROR_BIT5
	GOTO	_ERROR
;
SQUARE_ROOT_10	CALL	SAVE_ORI_Y	;ORIGINAL Y_y -> Y_ORI_y
;CHECK X REGISTER
	CALL	CHECK_X_0?
	BTFSS	X_0_BIT	;SKIP IF X_x=0 -> SQR0=0
	BRA	SQUARE_ROOT_END
;
	CALL	SQUARE_ROOT
;
SQUARE_ROOT_END	CALL	RELOAD_ORI_Y
	CALL	DISPLAY_X
;
	STACK_LIFT_ENABLE
	GOTO	START_ENTRY
;********************************************************************
;KEY_RECIPROCAL
KEY_RECIPROCAL	BTFSS	NEW_ENTRY_BIT
	CALL	COPY_ASCII_2_X
;
	CALL	CHECK_X_0?	;CHECK DIVISOR =?= 0
	BTFSC	X_0_BIT
	BRA	RECIPROCAL_5
;DIVISION BY 0 IS NOT ALLOWED
	CLRF	ERROR_REG
	BSF	DIV0_BIT
	GOTO	_ERROR
;
RECIPROCAL_5	CALL	SAVE_ORI_Y
;Y = 1,0000.0000.0000 * 10^00
	CALL	CLEAR_Y
	MOVLF	H'01',Y_6
;
	CALL	DIV_YREG_BY_XREG
;
	CALL	DISPLAY_X
	CALL	RELOAD_ORI_Y
;
	STACK_LIFT_ENABLE
	GOTO	START_ENTRY
;********************************************************************
;KEY_ : KEY_E_AD_X
;
; t --------------> T
; z --------------> Z
; y --------------> Y
; x --- e^x ------> X
;
; x --> LastX
;
;KEY_E_AD_X : SUM X^N/N! WHER N=0, 1, 2, 3 ......
KEY_E_AD_X	CALL	SAVE_ORI_Y
	BTFSS	NEW_ENTRY_BIT
	CALL	COPY_ASCII_2_X
;
	CALL	COPY_X_2_LASTX
	CALL	e_AD_X
	BTFSC	ERROR_BIT
	GOTO	_ERROR
;
	CALL	RELOAD_ORI_Y
	CALL	DISPLAY_X
;
	STACK_LIFT_ENABLE
	GOTO	START_ENTRY
;********************************************************************
;KEY_LN_X : NATURAL LOGARITHM
;
; t --------------> T
; z --------------> Z
; y --------------> Y
; x --- LNx ------> X
;
; x --> LastX
;
KEY_LN_X	CALL	SAVE_ORI_Y
	BTFSS	NEW_ENTRY_BIT
	CALL	COPY_ASCII_2_X
;CHECK X_x -> 	X > 0	
	BTFSC	X_SIGN	;SKIP IF X_x IS POSITIVE
	BRA	LN_X_ERROR
	CALL	CHECK_X_0?
	BTFSS	X_0_BIT	;SKIP IF X_x =/= 0
	BRA	LN_X_ERROR
;0 < X_x
	CALL	LN_X
;
	CALL	RELOAD_ORI_Y
	CALL	DISPLAY_ANNS
	CALL	DISPLAY_X
;
	STACK_LIFT_ENABLE
	GOTO	START_ENTRY
;
LN_X_ERROR	CLRF	ERROR_REG
	BSF	ERROR_BIT3	;INVALID x ENTRY!
	GOTO	_ERROR	
;********************************************************************
;KEY_LOG_X
;LOG(x) = LN(x) / LN(10)
;
; t --------------> T
; z --------------> Z
; y --------------> Y
; x --- LOGx------> X
;
; x --> LastX
;
KEY_LOG_X	CALL	SAVE_ORI_Y
	BTFSS	NEW_ENTRY_BIT
	CALL	COPY_ASCII_2_X
;CHECK X_x -> 	X > 0	
	BTFSC	X_SIGN	;SKIP IF X_x IS POSITIVE
	BRA	LOG_X_ERROR
	CALL	CHECK_X_0?
	BTFSS	X_0_BIT	;SKIP IF X_x =/= 0
	BRA	LOG_X_ERROR
;
LOG_X	CALL	LN_X	;X_x = LN(x)
	CALL	COPY_X_2_Y	;Y_y = LN(x)
	LOAD_CONST_2_X	CONST_1PLN10	;X_x = 1/LN10 = 4,3429.4481.9032 * 10^-1
	CALL	MUL_YREG_BY_XREG
;
	CALL	RELOAD_ORI_Y
	CALL	DISPLAY_ANNS
	CALL	DISPLAY_X
;
	STACK_LIFT_ENABLE
	GOTO	START_ENTRY
;
LOG_X_ERROR	CLRF	ERROR_REG
	BSF	ERROR_BIT3	;INVALID x ENTRY!
	GOTO	_ERROR
;********************************************************************
;KEY_10_AD_X 
;
; t --------------> T
; z --------------> Z
; y --------------> Y
; x --- 10^x -----> X
;
; x --> LastX
;
KEY_10_AD_X	CALL	SAVE_ORI_Y
	BTFSS	NEW_ENTRY_BIT
	CALL	COPY_ASCII_2_X
;
	CALL	TEN_AD_X
	BTFSC	ERROR_BIT
	GOTO	_ERROR
;
	CALL	RELOAD_ORI_Y
	CALL	DISPLAY_X
;
	STACK_LIFT_ENABLE
	GOTO	START_ENTRY
;********************************************************************
;KEY_Y_AD_X : y^x = e^(x * LN(y))
;EXCEPTION: IF X_x IS INTEGER -> DIRECT POWER CALCULATION
;
; t --------------> T
; z --------------> Z
; y --------------> Y
; x --- y^x ------> X
;
; x --> LastX
;
KEY_Y_AD_X	BTFSS	NEW_ENTRY_BIT
	CALL	COPY_ASCII_2_X
	CALL	SAVE_ORI_X
	CALL	SAVE_ORI_Y
;
KEY_Y_AD_X_0?	CALL	CHECK_X_0?
	BTFSC	X_0_BIT	;SKIP IF X_x = 0
	BRA	KEY_Y_AD_X_0
;X=0 -> y^0 = 1
	CALL	CLEAR_X
	MOVLF	H'01',X_6
	BRA	KEY_Y_AD_X_END
;
KEY_Y_AD_X_0	CALL	CHECK_X_INT?
	BTFSS	INT_BIT	;SKIP IF X_x IS INTEGER
	BRA	KEY_Y_AD_X_5
;X_x IS INTEGER & THIS NUMBER IS IN N_REG -> PACKED/BCD!!
	CALL	COPY_X_2_M	;SAVE X_x IN M_m	
	MOVF	N_REG,W
	CALL	BCD2_2_BIN8
	MOVWF	N_REG	;NOW, OUR INTEGER IN BIARY FORM
;N_REG =?= 1
	MOVLW	H'01'
	XORWF	N_REG,W
	BNZ	N_REG_2?
	CALL	RELOAD_ORI_Y_2_X;X_x = Y_ORI_y	
	BRA	KEY_Y_AD_X_END
;N_REG =?= 2
N_REG_2?	MOVLW	H'02'
	XORWF	N_REG,W
	BNZ	N_REG_23456789	;SKIP IF N_REG => 2
;
	CALL	RELOAD_ORI_Y	;X_x = Y_ORI_y
	CALL	COPY_Y_2_X	;X_x = Y_ORI_y	
	CALL	MUL_YREG_BY_XREG;X_x = Y_ORI_y ^ 2
	BRA	KEY_Y_AD_X_END
;
N_REG_23456789	MOVFF	N_REG,LOOP_CNT
	DECF	LOOP_CNT,F
;
	CALL	RELOAD_ORI_Y	;Y_y = Y_ORI_y
	CALL	COPY_Y_2_X	;X_x = Y_ORI_y
;
Y_AD_N_LOOP	CALL	RELOAD_ORI_Y	;Y_y = Y_ORI_y
	CALL	MUL_YREG_BY_XREG
	BTFSC	ERROR_BIT
	BRA	KEY_Y_AD_X_ERR
	DECFSZ	LOOP_CNT,F
	BRA	Y_AD_N_LOOP
;
	BRA	KEY_Y_AD_X_END	;X_x = Y^N
;
KEY_Y_AD_X_5	CALL	RELOAD_ORI_Y_2_X;X_x = Y_ORI_y
	CALL	LN_X	;X_x = LN(y)

	CALL	COPY_X_2_Y	;Y_y = LN(y)
	CALL	RELOAD_ORI_X	;X_x = X_ORI_x =x
	CALL	MUL_YREG_BY_XREG;X_x = x * LN(y)
	CALL	e_AD_X	;X_x = e^(x * LN(y))
	BTFSC	ERROR_BIT
	BRA	KEY_Y_AD_X_ERR	
;
KEY_Y_AD_X_END	CALL	RELOAD_ORI_Y
;####
;	RETURN		;IN SIMULATOR TESTING ONLY
;####
	CALL	DISPLAY_X
;
	STACK_LIFT_ENABLE
	GOTO	START_ENTRY
;
KEY_Y_AD_X_ERR	CALL	RELOAD_ORI_Y
	GOTO	_ERROR
;********************************************************************
;MEMORY_OPS : MEMORY RELATED OPERATIONS
;MS -> STO -> STOre  -> COPY X_x INTO M_0	CODE: "S"
;MR -> RCL -> ReCalL -> COPY M_0 INTO X_x	CODE: "R"
MEMORY_OPS	MOVLW	"S"
	XORWF	KEYREG,W
	BZ	KEYIN_MEM_STO
;
	MOVLW	"R"
	XORWF	KEYREG,W
	BZ	KEYIN_MEM_RCL
	GOTO	GET_NEXT_KEY	;NEITHER "R" NOR "S" WAS IN KEYREG
;STORE REGISTER, DESTINATION: FSR0 -> M_m
KEYIN_MEM_STO	BTFSS	NEW_ENTRY_BIT
	CALL	COPY_ASCII_2_X
;
	MOVLF	HIGH MEM_STO_RCL,FSR0H
	CLRF	FSR0L
;SET OR RESET SIGN BITS
	MOVLW	H'0F'	;CLEAR HIGH NIBBLE OF X_6
	ANDWF	X_6,F
;		
	BTFSC	X_SIGN	;SET SIN_SIGN ACCORDING TO X_SIGN
	BSF	X_6,6	
;
	BTFSC	X_EXP_SIGN	;SET SIN_EXP_SIGN ACCORDING TO X_EXP_SIGN
	BSF	X_6,7
;
	MOVFF	X_0,POSTINC0
	MOVFF	X_1,POSTINC0
	MOVFF	X_2,POSTINC0
	MOVFF	X_3,POSTINC0
	MOVFF	X_4,POSTINC0
	MOVFF	X_5,POSTINC0
	MOVFF	X_6,POSTINC0
	MOVFF	X_EXP,POSTINC0	
;CLEAR HIGH NIBBLE OF X_6, AGAIN
	MOVLW	H'0F'
	ANDWF	X_6,F
;
	GOTO	START_ENTRY
;RECALL REGISTER
KEYIN_MEM_RCL	MOVLF	HIGH MEM_STO_RCL,FSR0H
	CLRF	FSR0L
;
	MOVFF	POSTINC0,X_0
	MOVFF	POSTINC0,X_1
	MOVFF	POSTINC0,X_2
	MOVFF	POSTINC0,X_3
	MOVFF	POSTINC0,X_4
	MOVFF	POSTINC0,X_5
	MOVFF	POSTINC0,X_6
	MOVFF	POSTINC0,X_EXP
;X_6 HIGH NIBBLE CONTAINS THE SIGNS!
	BCF	X_SIGN
	BTFSC	X_6,6
	BSF	X_SIGN
;
	BCF	X_EXP_SIGN
	BTFSC	X_6,7
	BSF	X_EXP_SIGN
;CLEAR HIGH NIBBLE OF X_6
	MOVLW	H'0F'
	ANDWF	X_6,F
;
	CALL	DISPLAY_X
;
	GOTO	START_ENTRY
;********************************************************************
;NEW_ENTRY : PREPARE REGISTERS FOR A NEW ENTRY
NEW_ENTRY	MOVLF	D'8',DIGIT_CNT
	MOVLF	B'00000000',DP_REG
	MOVLF	B'00000000',DP_POS
	CALL	CLEAR_X
	CLRF	OP_BITS
	CLRF	ENTRY_BITS	;MAX_NUM, DP_OK, _1ST_DIGIT_BIT  
	CLRF	ERROR_REG
	BCF	_2ND_BIT
	BSF	NEW_ENTRY_BIT
	MOVLW	"0"	;H'30'
	MOVWF	DISP_1ST
	CLRF	DISP_2ND
	CLRF	DISP_3RD
	CLRF	DISP_4TH
	CLRF	DISP_5TH
	CLRF	DISP_6TH
	CLRF	DISP_7TH
	CLRF	DISP_8TH
;
	MOVLW	" "
	MOVWF	DISP_EXP_SIGN
	CLRF	DISP_EXP_10S
	CLRF	DISP_EXP_1S
	LFSR	0,DISP_1ST	;1ST DIGIT ADDRESS -> DISP_1ST
	CALL	DISPLAY_ENTRIES
;
	RETURN
;********************************************************************
;HARDWARE INDEPENDENT KEY ENTRY & DISPLAY ROUTINES
;********************************************************************
;COPY_ASCII_2_X
COPY_ASCII_2_X	MOVFF	DP_POS,DP_REG
;
	CLRF	X_6
	CLRF	X_5
	CLRF	X_4
	CLRF	X_3
	CLRF	X_2
	CLRF	X_1
	CLRF	X_0
;SAVE THE ENTERED EXPONENT
	MOVF	DISP_EXP_10S,W
	ANDLW	H'0F'
	MOVWF	X_EXP_TEMP
	SWAPF	X_EXP_TEMP,F	;LOW NIBBLE <-> HIGH NIBBLE
	MOVF	DISP_EXP_1S,W
	ANDLW	H'0F'
	IORWF	X_EXP_TEMP,F
;SAVE THE ENTERED EXPONENT-SIGN
	BCF	X_SAVE_EXP_SIGN	;DEFAULT
	BTFSC	X_EXP_SIGN
	BSF	X_SAVE_EXP_SIGN
;
	BCF	X_EXP_SIGN	;DEFAULT
;LOCATE DECIMAL POINT POSITION
	BTFSC	DP_REG,7
	GOTO	_1INT_7DEC
	BTFSC	DP_REG,6
	GOTO	_2INT_6DEC
	BTFSC	DP_REG,5
	GOTO	_3INT_5DEC
	BTFSC	DP_REG,4
	GOTO	_4INT_4DEC
	BTFSC	DP_REG,3
	GOTO	_5INT_3DEC
	BTFSC	DP_REG,2
	GOTO	_6INT_2DEC
	BTFSC	DP_REG,1
	GOTO	_7INT_1DEC
;
	GOTO	_8INT_0DEC	;NO DP ENTERED -> ALL NUMBERS ARE INTEGERS
;_1INT_7DEC : ONLY ONE INTEGER (MAYBE ZERO) & 7 DECIMALS
_1INT_7DEC	MOVLW	"0"
	XORWF	DISP_1ST,W
	BTFSS	Z
	GOTO	_1INT_7DEC_NOTZ	;INTEGER IS NOT ZERO
;INTEGER IS ZERO, LET'S CHECK THE DECIMALS
;NOTE: N = 1....9 (NOT ZERO)
CHECK_DISP_2	MOVLW	"0"
	XORWF	DISP_2ND,W
	BZ	CHECK_DISP_3
;X_x -> 0,Nxxxxxx
	MOVLW	D'1'
	MOVWF	X_EXP
	BSF	X_EXP_SIGN
;
	MOVFF	DISP_2ND,NUM1
	MOVFF	DISP_3RD,NUM2
	MOVFF	DISP_4TH,NUM3
	MOVFF	DISP_5TH,NUM4
	MOVFF	DISP_6TH,NUM5
	MOVFF	DISP_7TH,NUM6
	MOVFF	DISP_8TH,NUM7
	CLRF	NUM8
;
	BRA	COPY_NUM_2_X	
;
CHECK_DISP_3	MOVLW	"0"
	XORWF	DISP_3RD,W
	BZ	CHECK_DISP_4
;X_x -> 0,0Nxxxxx
	MOVLW	D'2'
	MOVWF	X_EXP
	BSF	X_EXP_SIGN
;
	MOVFF	DISP_3RD,NUM1
	MOVFF	DISP_4TH,NUM2
	MOVFF	DISP_5TH,NUM3
	MOVFF	DISP_6TH,NUM4
	MOVFF	DISP_7TH,NUM5
	MOVFF	DISP_8TH,NUM6
	CLRF	NUM7
	CLRF	NUM8
;
	BRA	COPY_NUM_2_X
;
CHECK_DISP_4	MOVLW	"0"
	XORWF	DISP_4TH,W
	BZ	CHECK_DISP_5
;X_x -> 0,00Nxxxx
	MOVLW	D'3'
	MOVWF	X_EXP
	BSF	X_EXP_SIGN
;
	MOVFF	DISP_4TH,NUM1
	MOVFF	DISP_5TH,NUM2
	MOVFF	DISP_6TH,NUM3
	MOVFF	DISP_7TH,NUM4
	MOVFF	DISP_8TH,NUM5
	CLRF	NUM6
	CLRF	NUM7
	CLRF	NUM8
;
	BRA	COPY_NUM_2_X	
;
CHECK_DISP_5	MOVLW	"0"
	XORWF	DISP_5TH,W
	BZ	CHECK_DISP_6
;X_x -> 0,000Nxxx
	MOVLW	D'4'
	MOVWF	X_EXP
	BSF	X_EXP_SIGN
;
	MOVFF	DISP_5TH,NUM1
	MOVFF	DISP_6TH,NUM2
	MOVFF	DISP_7TH,NUM3
	MOVFF	DISP_8TH,NUM4
	CLRF	NUM5
	CLRF	NUM6
	CLRF	NUM7
	CLRF	NUM8
;
	BRA	COPY_NUM_2_X
;
CHECK_DISP_6	MOVLW	"0"
	XORWF	DISP_6TH,W
	BZ	CHECK_DISP_7
;X_x N -> 0,0000Nxx
	MOVLW	D'5'
	MOVWF	X_EXP
	BSF	X_EXP_SIGN
;
	MOVFF	DISP_6TH,NUM1
	MOVFF	DISP_7TH,NUM2
	MOVFF	DISP_8TH,NUM3
	CLRF	NUM4
	CLRF	NUM5
	CLRF	NUM6
	CLRF	NUM7
	CLRF	NUM8
;
	BRA	COPY_NUM_2_X
;
CHECK_DISP_7	MOVLW	"0"	
	XORWF	DISP_7TH,W	
	BZ	CHECK_DISP_8
;X_x -> 0,00000Nx
	MOVLW	D'6'
	MOVWF	X_EXP
	BSF	X_EXP_SIGN
;
	MOVFF	DISP_7TH,NUM1
	MOVFF	DISP_8TH,NUM2
	CLRF	NUM3
	CLRF	NUM4
	CLRF	NUM5
	CLRF	NUM6
	CLRF	NUM7
	CLRF	NUM8
;
	BRA	COPY_NUM_2_X
;
CHECK_DISP_8	MOVLW	"0"
	XORWF	DISP_8TH,W
	BZ	ALL_ZEROES
;X_x -> 0,000000N
	MOVLW	D'7'
	MOVWF	X_EXP
	BSF	X_EXP_SIGN
;
	MOVFF	DISP_8TH,NUM1
	CLRF	NUM2
	CLRF	NUM3
	CLRF	NUM4
	CLRF	NUM5
	CLRF	NUM6
	CLRF	NUM7
	CLRF	NUM8
;
	BRA	COPY_NUM_2_X
;0,0000000
ALL_ZEROES	CALL	CLEAR_X
	BRA	COPY_ASCII_2_X_END
;1 INTEGER & 7 DECIMALS (INTEGER NOT ZERO)
_1INT_7DEC_NOTZ	MOVLW	D'0'
	MOVWF	X_EXP
	GOTO	COPY_NUM_2_X_0
;_2INT_6DEC
_2INT_6DEC	MOVLW	D'1'
	MOVWF	X_EXP
	BRA	COPY_NUM_2_X_0
;_3INT_5DEC
_3INT_5DEC	MOVLW	D'2'
	MOVWF	X_EXP
	BRA	COPY_NUM_2_X_0
;_4INT_4DEC
_4INT_4DEC	MOVLW	D'3'
	MOVWF	X_EXP
	BRA	COPY_NUM_2_X_0
;_5INT_3DEC
_5INT_3DEC	MOVLW	D'4'
	MOVWF	X_EXP
	BRA	COPY_NUM_2_X_0
;_6INT_2DEC
_6INT_2DEC	MOVLW	D'5'
	MOVWF	X_EXP
	BRA	COPY_NUM_2_X_0
;_7INT_1DEC
_7INT_1DEC	MOVLW	D'6'
	MOVWF	X_EXP
	BRA	COPY_NUM_2_X_0
;_8INT_0DEC
_8INT_0DEC	MOVLW	D'7'
	MOVWF	X_EXP
	BRA	COPY_NUM_2_X_0
;?????
COPY_NUM_2_X_0	MOVFF	DISP_1ST,NUM1
	MOVFF	DISP_2ND,NUM2
	MOVFF	DISP_3RD,NUM3
	MOVFF	DISP_4TH,NUM4
	MOVFF	DISP_5TH,NUM5
	MOVFF	DISP_6TH,NUM6
	MOVFF	DISP_7TH,NUM7
	MOVFF	DISP_8TH,NUM8
;COPY_NUM_2_X
COPY_NUM_2_X	MOVF	NUM1,W
	ANDLW	H'0F'
	MOVWF	X_6
;
	MOVF	NUM2,W
	ANDLW	H'0F'
	MOVWF	X_5
	SWAPF	X_5,F
	MOVF	NUM3,W
	ANDLW	H'0F'
	IORWF	X_5,F
;
	MOVF	NUM4,W
	ANDLW	H'0F'
	MOVWF	X_4
	SWAPF	X_4,F
	MOVF	NUM5,W
	ANDLW	H'0F'
	IORWF	X_4,F
;
	MOVF	NUM6,W
	ANDLW	H'0F'
	MOVWF	X_3
	SWAPF	X_3,F
	MOVF	NUM7,W
	ANDLW	H'0F'
	IORWF	X_3,F
;
	MOVF	NUM8,W
	ANDLW	H'0F'
	MOVWF	X_2
	SWAPF	X_2,F
;NOW, CALCULATE THE NEW EXPONENT.
;THE CALCULATED EXPONENT FROM THE MANTISSA IS IN X_EXP, THE SIGN IS IN X_EXP_SIGN
;THE ENTERED EXPONENT IS IN X_EXP_TEMP, THE SIGN IS IN X_SAVE_EXP_SIGN
	NOP
	BTFSC	X_EXP_SIGN	;SKIP IF X_EXP_SIGN = 0 -> POSITIVE
	BRA	EXP_X_EXP_NEG
;X-EXPONENT IS POSITIVE
EXP_X_EXP_POS	BTFSC	X_SAVE_EXP_SIGN	;SKIP IF X_SAVE_EXP_SIGN = 0 -> POSITIVE
	BRA	EXP_X_EXP_P_X_SAVE_EXP_N
;BOTH EXPONENT SIGNS ARE POSITIVE -> ADDITION
	CALL	ADD_X_EXP_TEMP_2_X_EXP
	BRA	COPY_ASCII_2_X_END
;X-EXPONENT IS POSITIVE, X_EXP_TEMP IS NEGATIVE
;SUBTRACT X_EXP_TEMP FROM X_EXP
EXP_X_EXP_P_X_SAVE_EXP_N
	CALL	SUB_X_EXP_TEMP_FROM_X_EXP
	BRA	COPY_ASCII_2_X_END
;X-EXPONENT IS NEGATIVE
EXP_X_EXP_NEG	BTFSC	X_SAVE_EXP_SIGN	;SKIP IF X_SAVE_EXP_SIGN = 0 -> POSITIVE
	BRA	EXP_X_EXP_N_X_SAVE_EXP_N	
;X-EXPONENT IS NEGATIVE, X_EXP_TEMP IS POSITIVE
	CALL	SUB_X_EXP_FROM_X_EXP_TEMP
	BRA	COPY_ASCII_2_X_END
;BOTH EXPONENT SIGNS ARE NEGATIVE -> ADDITION
EXP_X_EXP_N_X_SAVE_EXP_N
	CALL	ADD_X_EXP_TEMP_2_X_EXP
;
COPY_ASCII_2_X_END

;######
;	CALL	DISPLAY_REGS
;######
	CALL	DISPLAY_X
;
	RETURN
;	BCF	X_EXP_SIGN
;********************************************************************
;ADD_X_EXP_TEMP_2_X_EXP
ADD_X_EXP_TEMP_2_X_EXP
	BCF	C	;NO INCOMING OVERFLOW
	CLRF	ERROR_REG	;DEFAULT
	MOVF	X_EXP_TEMP,W
	ADDWFC	X_EXP,W
	DAW	
	MOVWF	X_EXP
;
	BTFSS	C	;SKIP IF OVERFLOW
	RETURN
	BSF	ERROR_BIT
	BSF	OVFL_BIT
	RETURN
;********************************************************************
;SUB_X_EXP_TEMP_FROM_X_EXP
SUB_X_EXP_TEMP_FROM_X_EXP
	BCF	X_EXP_SIGN
	BCF	X_SAVE_EXP_SIGN
;10'S COMPLEMENT
	GET_10S_COMP	X_EXP_TEMP,X_EXP_TEMP
;NOW ADD TEN'S COMPLEMENT OF X_EXP_TEMP TO X-EXPONENT
	BCF	C
	MOVF	X_EXP,W
	ADDWFC	X_EXP_TEMP,W
	DAW
	MOVWF	X_EXP
;
	BTFSC	C
	RETURN
;RESULT OF SUBTRACTION IS NEGATIVE
	GET_10S_COMP	X_EXP,X_EXP
	BSF	X_EXP_SIGN
;
	RETURN
;********************************************************************
;SUB_X_EXP_FROM_X_EXP_TEMP
SUB_X_EXP_FROM_X_EXP_TEMP
	BCF	X_EXP_SIGN
	BCF	X_SAVE_EXP_SIGN
;10'S COMPLEMENT
	GET_10S_COMP	X_EXP,X_EXP
;NOW ADD TEN'S COMPLEMENT OF X-EXPONENT TO X_EXP_TEMP
	BCF	C
	MOVF	X_EXP,W
	ADDWFC	X_EXP_TEMP,W
	DAW
	MOVWF	X_EXP
;
	BTFSC	C
	RETURN
;RESULT OF SUBTRACTION IS NEGATIVE
	GET_10S_COMP	X_EXP,X_EXP
	BSF	X_EXP_SIGN
;
	RETURN
;********************************************************************
	ORG	H'05340'	
	#INCLUDE	<ASMD_ROUTINES.INC>
;********************************************************************
	ORG	H'07340'
	#INCLUDE	<TRIGONOMETRIC_CORDIC.INC>
;********************************************************************
	ORG	H'09340'
	#INCLUDE	<SQ_ROOT_LOG_EXP.INC>
;********************************************************************
	ORG	H'18000'
	#INCLUDE	<SIMPLE_ROUTINES.INC>
;********************************************************************
;HARDWARE PENDING PROGRAMS & SUBROUTINES
	ORG	H'1C000'
;********************************************************************
;NUMTBL
NUMTBL	MOVWF	TBLOFFSET
	BCF	C
	RLCF	TBLOFFSET,F
;
	MOVLW	HIGH TABLE1
	BTFSC	C
	INCF	WREG,W
	MOVWF	PCLATH
;
	MOVLW	LOW TABLE1
	ADDWF	TBLOFFSET,W
	BTFSC	C
	INCF	PCLATH,F
	MOVWF	PCL
;
TABLE1	RETLW	"0"
	RETLW	"1"
	RETLW	"2"
	RETLW	"3"
	RETLW	"4"
	RETLW	"5"
	RETLW	"6"
	RETLW	"7"
	RETLW	"8"
	RETLW	"9"
	RETLW	"A"
	RETLW	"B"
	RETLW	"C"
	RETLW	"D"
	RETLW	"E"
	RETLW	"F"
;********************************************************************
;DISPLAY_X : DISPLAY THE NUMBER IN X-REISTER. X-REGISTER MUST BE UNCHANGED!
;DISPLAYED NUMBER IS LEFT JUSTIFIED
;TRAILING ZEROES ARE SUPRESSED
DISPLAY_X	MOVLF	UPPER LED_CHAR_TABLE,TBLPTRU
	MOVLF	HIGH LED_CHAR_TABLE,TBLPTRH	
;
;#####
;	BRA	DISPLAY_X_NORM
;#####	
;CHECK THE EXPONENT OF X
	BTFSS	X_EXP_SIGN	;SKIP IF EXPONENT IS NEGATIVE
	BRA	DISPLAY_X_EXP_P
;EXPONENT SIGN OF X-REGISTER IS NEGATIVE
DISPLAY_X_EXP_N	NOP
X_EXP_M1?	MOVLW	D'01'
	XORWF	X_EXP,W
	BNZ	X_EXP_M2?
;X_EXP = -1 -> DISPLAY 0,Nxxxxxx
	MOVLF	B'10000000',DP_REG
	BCF	LED_1,2	;NO X_EXP_SIGN
;
	MOVLW	"0"
	MOVWF	TBLPTRL
	TBLRD*
	MOVFF	TABLAT,LED_2
;
	MOVF	X_6,W
	ANDLW	H'0F'
	IORLW	"0"
	MOVWF	TBLPTRL
	TBLRD*
	MOVFF	TABLAT,LED_3
;
	SWAPF	X_5,W
	ANDLW	H'0F'
	IORLW	"0"
	MOVWF	TBLPTRL
	TBLRD*
	MOVFF	TABLAT,LED_4
;
	MOVF	X_5,W
	ANDLW	H'0F'
	IORLW	"0"
	MOVWF	TBLPTRL
	TBLRD*
	MOVFF	TABLAT,LED_5	
;
	SWAPF	X_4,W
	ANDLW	H'0F'
	IORLW	"0"
	MOVWF	TBLPTRL
	TBLRD*
	MOVFF	TABLAT,LED_6	
;
	MOVF	X_4,W
	ANDLW	H'0F'
	IORLW	"0"
	MOVWF	TBLPTRL
	TBLRD*
	MOVFF	TABLAT,LED_7
;
	SWAPF	X_3,W
	ANDLW	H'0F'
	IORLW	"0"
	MOVWF	TBLPTRL
	TBLRD*
	MOVFF	TABLAT,LED_8
;
	MOVF	X_3,W
	ANDLW	H'0F'
	IORLW	"0"
	MOVWF	TBLPTRL
	TBLRD*
	MOVFF	TABLAT,LED_9
;
	BRA	X_EXP_N_12_END
;
X_EXP_M2?	MOVLW	D'02'
	XORWF	X_EXP,W
	BNZ	DISPLAY_X_NORM
;X_EXP = -2 -> DISPLAY 0,0Nxxxxx
	MOVLF	B'10000000',DP_REG
	BCF	LED_1,2	;NO X_EXP_SIGN
;
	MOVLW	"0"
	MOVWF	TBLPTRL
	TBLRD*
	MOVFF	TABLAT,LED_2
	MOVFF	TABLAT,LED_3
;
	MOVF	X_6,W
	ANDLW	H'0F'
	IORLW	"0"
	MOVWF	TBLPTRL
	TBLRD*
	MOVFF	TABLAT,LED_4	
;
	SWAPF	X_5,W
	ANDLW	H'0F'
	IORLW	"0"
	MOVWF	TBLPTRL
	TBLRD*
	MOVFF	TABLAT,LED_5
;
	MOVF	X_5,W
	ANDLW	H'0F'
	IORLW	"0"
	MOVWF	TBLPTRL
	TBLRD*
	MOVFF	TABLAT,LED_6
;
	SWAPF	X_4,W
	ANDLW	H'0F'
	IORLW	"0"
	MOVWF	TBLPTRL
	TBLRD*
	MOVFF	TABLAT,LED_7
;
	MOVF	X_4,W
	ANDLW	H'0F'
	IORLW	"0"
	MOVWF	TBLPTRL
	TBLRD*
	MOVFF	TABLAT,LED_8
;
	SWAPF	X_3,W
	ANDLW	H'0F'
	IORLW	"0"
	MOVWF	TBLPTRL
	TBLRD*
	MOVFF	TABLAT,LED_9
;
X_EXP_N_12_END	CLRF	LED_EXP_10S
	CLRF	LED_EXP_1S
	CALL	TRAILING_0_BLANKING
;
	RETURN
;EXPONENT SIGN OF X-REGISTER IS POSITIVE
DISPLAY_X_EXP_P	MOVLW	D'8'
	CPFSLT	X_EXP	;SKIP IF X_EXP < 8  -> NO EXPONENT DISPLAYING
	BRA	DISPLAY_X_NORM
;DISPLAY THE MANTISSA ONLY
DISPLAY_X_MAN	CLRF	LED_EXP_10S
	CLRF	LED_EXP_1S
	BCF	LED_1,2	;NO X_EXP_SIGN
;SET DP_REG ACCORDING TO X-EXPONENT: X_EXP=0 -> SET DP_REG,7    X_EXP=1 -> SET DP_REG,6 etc.
;X_EXP = 0 -> DP_REG = B'1000 0000'
;X_EXP = 1 -> DP_REG = B'0100 0000'
;X_EXP = 2 -> DP_REG = B'0010 0000'
;X_EXP = 3 -> DP_REG = B'0001 0000'
;X_EXP = 4 -> DP_REG = B'0000 1000'
;X_EXP = 5 -> DP_REG = B'0000 0100'
;X_EXP = 6 -> DP_REG = B'0000 0010'
;X_EXP = 7 -> DP_REG = B'0000 0001'
	MOVLF	H'80',DP_REG	;B'1000 0000'
;
	MOVF	X_EXP,F
	BZ	DISPLAY_X_MAN_5
;
	RRNCF	DP_REG,F	;B'0100 0000'
	MOVLW	D'1'
	XORWF	X_EXP,W	
	BZ	DISPLAY_X_MAN_5
;
	RRNCF	DP_REG,F	;B'0010 0000'
	MOVLW	D'2'
	XORWF	X_EXP,W	
	BZ	DISPLAY_X_MAN_5
;
	RRNCF	DP_REG,F	;B'0001 0000'
	MOVLW	D'3'
	XORWF	X_EXP,W	
	BZ	DISPLAY_X_MAN_5
;
	RRNCF	DP_REG,F	;B'0000 1000'
	MOVLW	D'4'
	XORWF	X_EXP,W	
	BZ	DISPLAY_X_MAN_5
;
	RRNCF	DP_REG,F	;B'0000 0100'
	MOVLW	D'5'
	XORWF	X_EXP,W	
	BZ	DISPLAY_X_MAN_5
;

	RRNCF	DP_REG,F	;B'0000 0010'
	MOVLW	D'6'
	XORWF	X_EXP,W	
	BZ	DISPLAY_X_MAN_5
;
	RRNCF	DP_REG,F	;B'0000 0001'
	MOVLW	D'7'
	XORWF	X_EXP,W	
	BZ	DISPLAY_X_MAN_5
;
DISPLAY_X_MAN_5	NOP
	CALL	DISPLAY_X_MANTISSA
;CLEARS EXPONENT
	CLRF	LED_EXP_10S
	CLRF	LED_EXP_1S
	BCF	LED_1,2	;NO X_EXP_SIGN
;####
;	CALL	DISPLAY_REGS
;####
	CALL	TRAILING_0_BLANKING
	RETURN
;DISPLAY X REGISTER IN NORMALIZED FORM
DISPLAY_X_NORM	CALL	DISPLAY_X_MANTISSA
	CALL	DISPLAY_X_EXPONENT
	CALL	TRAILING_0_BLANKING
	RETURN
;********************************************************************
;DISPLAY_X_MANTISSA : CONVERTS MANTISSA DIGITS INTO LED-SEGMENT CODES
DISPLAY_X_MANTISSA
	CLRF	LED_1	;DEFAULT
	BTFSC	X_SIGN
	BSF	LED_1,5
	BTFSC	_2ND_BIT
	BSF	LED_1,6
;
	MOVF	X_6,W
	ANDLW	H'0F'
	IORLW	"0"
	MOVWF	TBLPTRL
	TBLRD*
	MOVFF	TABLAT,LED_2
;
	SWAPF	X_5,W
	ANDLW	H'0F'
	IORLW	"0"
	MOVWF	TBLPTRL
	TBLRD*
	MOVFF	TABLAT,LED_3	
;
	MOVF	X_5,W
	ANDLW	H'0F'
	IORLW	"0"
	MOVWF	TBLPTRL
	TBLRD*
	MOVFF	TABLAT,LED_4
;
	SWAPF	X_4,W
	ANDLW	H'0F'
	IORLW	"0"
	MOVWF	TBLPTRL
	TBLRD*
	MOVFF	TABLAT,LED_5
;
	MOVF	X_4,W
	ANDLW	H'0F'
	IORLW	"0"
	MOVWF	TBLPTRL
	TBLRD*
	MOVFF	TABLAT,LED_6	
;
	SWAPF	X_3,W
	ANDLW	H'0F'
	IORLW	"0"
	MOVWF	TBLPTRL
	TBLRD*
	MOVFF	TABLAT,LED_7	
;
	MOVF	X_3,W
	ANDLW	H'0F'
	IORLW	"0"
	MOVWF	TBLPTRL
	TBLRD*
	MOVFF	TABLAT,LED_8
;
	SWAPF	X_2,W
	ANDLW	H'0F'
	IORLW	"0"
	MOVWF	TBLPTRL
	TBLRD*
	MOVFF	TABLAT,LED_9
;
	RETURN
;********************************************************************
;DISPLAY_X_EXPONENT : CONVERTS EXPONENT DIGITS INTO LED-SEGMENT CODES
DISPLAY_X_EXPONENT
	BCF	LED_1,2	;DEFAULT -> X_EXP_SIGN=0
	BTFSC	X_EXP_SIGN
	BSF	LED_1,2
;
	SWAPF	X_EXP,W
	ANDLW	H'0F'
	IORLW	"0"
	MOVWF	TBLPTRL
	TBLRD*
	MOVFF	TABLAT,LED_EXP_10S
;
	MOVF	X_EXP,W
	ANDLW	H'0F'
	IORLW	"0"
	MOVWF	TBLPTRL
	TBLRD*	
	MOVFF	TABLAT,LED_EXP_1S
;
	RETURN
;********************************************************************
;TRAILING_0_BLANKING
;CHECK THE NUMBERS BACKWARD FROM RIGHT TO LEFT (FROM LSD TO MSD)
;ACCORDING TO DP_REG
;
;
TRAILING_0_BLANKING NOP
;DIGIT 8TH CHECKING
;	MOVF	DP_REG,F
;	RETURN
;? DP_REG = B'00000001' -> 12345678,
	BTFSC	DP_REG,0
	RETURN		;NO BLANKING
;? DP_REG = B'00000010' -> 1234567,8
	BTFSC	DP_REG,1
	GOTO	TR_0_BL_78
;? DP_REG = B'00000100' -> 123456,78
	BTFSC	DP_REG,2
	GOTO	TR_0_BL_67
;? DP_REG = B'00001000' -> 12345,678
	BTFSC	DP_REG,3
	GOTO	TR_0_BL_56
;? DP_REG = B'00010000' -> 1234,5678
	BTFSC	DP_REG,4
	GOTO	TR_0_BL_45
;? DP_REG = B'00100000' -> 123,45678
	BTFSC	DP_REG,5
	GOTO	TR_0_BL_34
;? DP_REG = B'01000000' -> 12,345678
	BTFSC	DP_REG,6
	GOTO	TR_0_BL_23
;? DP_REG = B'01000000' -> 1,2345678
	BTFSC	DP_REG,7
	GOTO	TR_0_BL_12
;?????
TR_0_BL_78	MOVLW	H'DD'	;SEGMENT CODE OF NULL
	XORWF	LED_9,W
	BTFSS	Z
	RETURN
	CLRF	LED_9
	RETURN
;
TR_0_BL_67	MOVLW	H'DD'	;SEGMENT CODE OF NULL
	XORWF	LED_9,W
	BTFSS	Z
	RETURN
	CLRF	LED_9
	MOVLW	H'DD'
	XORWF	LED_8,W
	BTFSS	Z
	RETURN
	CLRF	LED_8
	RETURN
;
TR_0_BL_56	MOVLW	H'DD'	
	XORWF	LED_9,W
	BTFSS	Z
	RETURN
	CLRF	LED_9
	MOVLW	H'DD'
	XORWF	LED_8,W
	BTFSS	Z
	RETURN
	CLRF	LED_8
	MOVLW	H'DD'
	XORWF	LED_7,W
	BTFSS	Z
	RETURN
	CLRF	LED_7
	RETURN
;
TR_0_BL_45	MOVLW	H'DD'	
	XORWF	LED_9,W
	BTFSS	Z
	RETURN
	CLRF	LED_9
	MOVLW	H'DD'
	XORWF	LED_8,W
	BTFSS	Z
	RETURN
	CLRF	LED_8
	MOVLW	H'DD'
	XORWF	LED_7,W
	BTFSS	Z
	RETURN
	CLRF	LED_7
	MOVLW	H'DD'
	XORWF	LED_6,W
	BTFSS	Z
	RETURN
	CLRF	LED_6
	RETURN
;
TR_0_BL_34	MOVLW	H'DD'	
	XORWF	LED_9,W
	BTFSS	Z
	RETURN
	CLRF	LED_9
	MOVLW	H'DD'
	XORWF	LED_8,W
	BTFSS	Z
	RETURN
	CLRF	LED_8
	MOVLW	H'DD'
	XORWF	LED_7,W
	BTFSS	Z
	RETURN
	CLRF	LED_7
	MOVLW	H'DD'
	XORWF	LED_6,W
	BTFSS	Z
	RETURN
	CLRF	LED_6
	MOVLW	H'DD'
	XORWF	LED_5,W
	BTFSS	Z
	RETURN
	CLRF	LED_5
	RETURN
;
TR_0_BL_23	MOVLW	H'DD'	
	XORWF	LED_9,W
	BTFSS	Z
	RETURN
	CLRF	LED_9
	MOVLW	H'DD'
	XORWF	LED_8,W
	BTFSS	Z
	RETURN
	CLRF	LED_8
	MOVLW	H'DD'
	XORWF	LED_7,W
	BTFSS	Z
	RETURN
	CLRF	LED_7
	MOVLW	H'DD'
	XORWF	LED_6,W
	BTFSS	Z
	RETURN
	CLRF	LED_6
	MOVLW	H'DD'
	XORWF	LED_5,W
	BTFSS	Z
	RETURN
	CLRF	LED_5
	MOVLW	H'DD'
	XORWF	LED_4,W
	BTFSS	Z
	RETURN
	CLRF	LED_4
	RETURN
;
TR_0_BL_12	MOVLW	H'DD'	
	XORWF	LED_9,W
	BTFSS	Z
	RETURN
	CLRF	LED_9
	MOVLW	H'DD'
	XORWF	LED_8,W
	BTFSS	Z
	RETURN
	CLRF	LED_8
	MOVLW	H'DD'
	XORWF	LED_7,W
	BTFSS	Z
	RETURN
	CLRF	LED_7
	MOVLW	H'DD'
	XORWF	LED_6,W
	BTFSS	Z
	RETURN
	CLRF	LED_6
	MOVLW	H'DD'
	XORWF	LED_5,W
	BTFSS	Z
	RETURN
	CLRF	LED_5
	MOVLW	H'DD'
	XORWF	LED_4,W
	BTFSS	Z
	RETURN
	CLRF	LED_4
	MOVLW	H'DD'
	XORWF	LED_3,W
	BTFSS	Z
	RETURN
	CLRF	LED_3
;
	RETURN
;********************************************************************
;DISPLAY_ENTRIES
DISPLAY_ENTRIES	MOVLF	UPPER LED_CHAR_TABLE,TBLPTRU
	MOVLF	HIGH LED_CHAR_TABLE,TBLPTRH	
;
	CLRF	LED_1
	BTFSC	X_SIGN
	BSF	LED_1,5	;SEG-G -> SIGN	
	BTFSC	X_EXP_SIGN
	BSF	LED_1,2	;SEG-A -> EXP-SIGN
	BTFSC	_2ND_BIT
	BSF	LED_1,6	;SEG-B -> DOT
;
	MOVFF	DISP_1ST,TBLPTRL
	TBLRD*
	MOVFF	TABLAT,LED_2	
;
	MOVFF	DISP_2ND,TBLPTRL
	TBLRD*
	MOVFF	TABLAT,LED_3	
;
	MOVFF	DISP_3RD,TBLPTRL
	TBLRD*
	MOVFF	TABLAT,LED_4	
;
	MOVFF	DISP_4TH,TBLPTRL
	TBLRD*
	MOVFF	TABLAT,LED_5
;
	MOVFF	DISP_5TH,TBLPTRL
	TBLRD*
	MOVFF	TABLAT,LED_6
;
	MOVFF	DISP_6TH,TBLPTRL
	TBLRD*
	MOVFF	TABLAT,LED_7
;
	MOVFF	DISP_7TH,TBLPTRL
	TBLRD*
	MOVFF	TABLAT,LED_8
;
	MOVFF	DISP_8TH,TBLPTRL
	TBLRD*
	MOVFF	TABLAT,LED_9
;
	MOVFF	DISP_EXP_10S,TBLPTRL
	TBLRD*
	MOVFF	TABLAT,LED_EXP_10S
;
	MOVFF	DISP_EXP_1S,TBLPTRL
	TBLRD*
	MOVFF	TABLAT,LED_EXP_1S
;
	RETURN
;********************************************************************
;KEYIN : READS THE KEYS INTO KEYREG
;KEY_ON = 1 IF A KEY WAS PRESSED
;REL_BIT = 1 IF KEYS ARE RELEASED
;INPUT : KEY PRESSING AT KEYBOARD
;OUTPUT : ASCII KEYCODE IN KEYREG
KEYIN	BTFSS	IT_BIT
	BRA	KEYIN
;
	CLRF	OP_BITS
	BCF	KEY_ON
	BCF	IT_BIT
;
	BTFSC	REL_BIT	;SKIP IF REL_BIT IS 0, WAIT FOR RELEASE KEYS
	BRA	KEYIN_15
;
KEYIN_5	CLRF	REL_CNT
;WAIT N DIGIT TIMES WHEN ALL KEYS ARE RELEASED
KEYIN_10	BTFSS	IT_BIT
	BRA	KEYIN_10
;
	CALL	SCAN_KEYS
	MOVF	KEYREG,F	;ZERO CHECKING
	BTFSS	Z	;SKIP IF NO KEY WAS PRESSED
	BRA	KEYIN_5
;
	INCF	REL_CNT,F
	MOVLW	D'2'
	CPFSGT	REL_CNT	;SKIP IF f > W
	BRA	KEYIN_10
;
	BSF	REL_BIT	;ALL KEYS ARE RELEASED
	RETURN
;
KEYIN_15	CALL	SCAN_KEYS
	MOVF	KEYREG,F
	BTFSC	Z	;SKIP IF KEY WAS PRESSED
	RETURN
	BSF	KEY_ON	;SET KEY_ON BIT
;
	RETURN	
;********************************************************************
;SCAN_KEYS
SCAN_KEYS	NOP
	BTFSS	START_BIT
	BRA	SCAN_KEYS
;
	BCF	START_BIT
	CLRF	KEYREG
	BRA	SCAN_KEYS_10
;
SCAN_KEYS_5	NOP
	BTFSS	IT_BIT
	BRA	SCAN_KEYS_5
	BCF	IT_BIT
;Dx (WHERE x=1,2,3,4,5,6,7,8,9,11,12) ARE THE DIGIT SCAN LINES
;K1, K2, K3 & K4 ARE THE KEY INPUT LINES
;WHAT IS THE CURRENT DIGIT_x_CODE
SCAN_KEYS_10	MOVLW	DIGIT1_CODE
	XORWF	DIGIT_CODE,W
	BTFSC	Z
	GOTO	D1_SELECTED
;
	MOVLW	DIGIT2_CODE
	XORWF	DIGIT_CODE,W
	BTFSC	Z
	GOTO	D2_SELECTED
;
	MOVLW	DIGIT3_CODE
	XORWF	DIGIT_CODE,W
	BTFSC	Z
	GOTO	D3_SELECTED
;
	MOVLW	DIGIT4_CODE
	XORWF	DIGIT_CODE,W
	BTFSC	Z
	GOTO	D4_SELECTED
;
	MOVLW	DIGIT5_CODE
	XORWF	DIGIT_CODE,W
	BTFSC	Z
	GOTO	D5_SELECTED
;
	MOVLW	DIGIT6_CODE
	XORWF	DIGIT_CODE,W
	BTFSC	Z
	GOTO	D6_SELECTED
;
	MOVLW	DIGIT7_CODE
	XORWF	DIGIT_CODE,W
	BTFSC	Z
	GOTO	D7_SELECTED
;
	MOVLW	DIGIT8_CODE
	XORWF	DIGIT_CODE,W
	BTFSC	Z
	GOTO	D8_SELECTED
;
	MOVLW	DIGIT9_CODE
	XORWF	DIGIT_CODE,W
	BTFSC	Z
	GOTO	D9_SELECTED
;
	MOVLW	DIGIT11_CODE
	XORWF	DIGIT_CODE,W
	BTFSC	Z
	GOTO	D11_SELECTED
;
	MOVLW	DIGIT12_CODE
	XORWF	DIGIT_CODE,W
	BTFSC	Z
	GOTO	D12_SELECTED
;
	RETURN
;
D1_SELECTED	BTFSS	K1		
	BRA	KEY_D1_K1	
	BTFSS	K2
	BRA	KEY_D1_K2
	BRA	SCAN_KEYS_5
;
KEY_D1_K1	MOVLF	"0",KEYREG	;0
	BRA	KEY_NUMBER
;
KEY_D1_K2	MOVLF	"+",KEYREG	;ADD
	BRA	SCAN_KEYS_5
;
D2_SELECTED	BTFSS	K2
	BRA	KEY_D2_K2
	BTFSS	K3
	BRA	KEY_D2_K3
	BTFSS	K4
	BRA	KEY_D2_K4
	BRA	SCAN_KEYS_5
;
KEY_D2_K2	MOVLF	"H",KEYREG	;CHS
	BRA	SCAN_KEYS_5
;
KEY_D2_K3	MOVLF	"P",KEYREG	;PI
	BRA	SCAN_KEYS_5
;
KEY_D2_K4	MOVLF	"t",KEYREG	;TAN
	BRA	SCAN_KEYS_5
;
D3_SELECTED	BTFSS	K1
	BRA	KEY_D3_K1
	BTFSS	K2
	BRA	KEY_D3_K2
	BTFSS	K4
	BRA	KEY_D3_K4
	BRA	SCAN_KEYS_5
;
KEY_D3_K1	MOVLF	"9",KEYREG	;9
	BRA	KEY_NUMBER
;
KEY_D3_K2	MOVLF	"S",KEYREG	;STO
	BSF	MEM_BIT
	BRA	SCAN_KEYS_5
;
KEY_D3_K4	MOVLF	"s",KEYREG	;SIN
	BRA	SCAN_KEYS_5
;
D4_SELECTED	BTFSS	K1
	BRA	KEY_D4_K1
	BTFSS	K2
	BRA	KEY_D4_K2
	BTFSS	K3
	BRA	KEY_D4_K3
	BTFSS	K4
	BRA	KEY_D4_K4
	BRA	SCAN_KEYS_5
;
KEY_D4_K1	MOVLF	"8",KEYREG	;8
	BRA	KEY_NUMBER
;
KEY_D4_K2	MOVLF	"r",KEYREG	;1/x
	BRA	SCAN_KEYS_5
;
KEY_D4_K3	MOVLF	",",KEYREG	;,
	BRA	SCAN_KEYS_5
;
KEY_D4_K4	MOVLF	"c",KEYREG	;COS
	BRA	SCAN_KEYS_5
;
D5_SELECTED	BTFSS	K1
	BRA	KEY_D5_K1
	BTFSS	K2
	BRA	KEY_D5_K2
	BTFSS	K3
	BRA	KEY_D5_K3
	BRA	SCAN_KEYS_5
;
KEY_D5_K1	MOVLF	"7",KEYREG	;7
	BRA	KEY_NUMBER
;
KEY_D5_K2	MOVLF	"a",KEYREG	;x<>y
	BRA	SCAN_KEYS_5
;
KEY_D5_K3	MOVLF	"R",KEYREG	;RCL
	BSF	MEM_BIT
	BRA	SCAN_KEYS_5
;
D6_SELECTED	BTFSS	K1
	BRA	KEY_D6_K1
	BTFSS	K2
	BRA	KEY_D6_K2
	BTFSS	K3
	BRA	KEY_D6_K3
	BTFSS	K4
	BRA	KEY_D6_K4
	BRA	SCAN_KEYS_5
;
KEY_D6_K1	MOVLF	"6",KEYREG	;6
	BRA	KEY_NUMBER
;
KEY_D6_K2	MOVLF	"C",KEYREG	;C
	BRA	SCAN_KEYS_5
;
KEY_D6_K3	MOVLF	"L",KEYREG	;ARC
	BRA	SCAN_KEYS_5
;
KEY_D6_K4	MOVLF	"G",KEYREG	;LOG
	BRA	SCAN_KEYS_5
;
D7_SELECTED	BTFSS	K1
	BRA	KEY_D7_K1
	BTFSS	K2
	BRA	KEY_D7_K2
	BTFSS	K3
	BRA	KEY_D7_K3
	BTFSS	K4
	BRA	KEY_D7_K4
	BRA	SCAN_KEYS_5
;
KEY_D7_K1	MOVLF	"5",KEYREG	;5
	BRA	KEY_NUMBER
;
KEY_D7_K2	MOVLF	"E",KEYREG	;ENTER
	BRA	SCAN_KEYS_5
;
KEY_D7_K3	MOVLF	"O",KEYREG	;ROLL
	BRA	SCAN_KEYS_5
;
KEY_D7_K4	MOVLF	"y",KEYREG	;y^x
	BRA	SCAN_KEYS_5
;
D8_SELECTED	BTFSS	K1
	BRA	KEY_D8_K1
	BTFSS	K2
	BRA	KEY_D8_K2
	BTFSS	K4
	BRA	KEY_D8_K4
	BRA	SCAN_KEYS_5
;
KEY_D8_K1	MOVLF	"4",KEYREG	;4
	BRA	KEY_NUMBER
;
KEY_D8_K2	MOVLF	"Q",KEYREG	;SQR
	BRA	SCAN_KEYS_5
;
KEY_D8_K4	MOVLF	"l",KEYREG	;LN
	BRA	SCAN_KEYS_5
;
D9_SELECTED	BTFSS	K1
	BRA	KEY_D9_K1
	BTFSS	K2
	BRA	KEY_D9_K2
	BTFSS	K4
	BRA	KEY_D9_K4
	BRA	SCAN_KEYS_5
;
KEY_D9_K1	MOVLF	"3",KEYREG	;3
	BRA	KEY_NUMBER
;
KEY_D9_K2	MOVLF	"/",KEYREG	;DIV
	BSF	OP_BIT
	BRA	SCAN_KEYS_5
;
KEY_D9_K4	MOVLF	"e",KEYREG	;e^x
	BRA	SCAN_KEYS_5
;
D11_SELECTED	BTFSS	K1
	BRA	KEY_D11_K1
	BTFSS	K2
	BRA	KEY_D11_K2
	BRA	SCAN_KEYS_5
;
KEY_D11_K1	MOVLF	"2",KEYREG	;2
	BRA	KEY_NUMBER
;
KEY_D11_K2	MOVLF	"*",KEYREG	;MUL
	BSF	OP_BIT
	BRA	SCAN_KEYS_5
;
D12_SELECTED	BTFSS	K1
	BRA	KEY_D12_K1
	BTFSS	K2
	BRA	KEY_D12_K2
	BTFSS	K3
	BRA	KEY_D12_K3
	BTFSS	K4
	BRA	KEY_D12_K4
	RETURN
;
KEY_D12_K1	MOVLF	"1",KEYREG	;1
	BSF	DIGIT_BIT
	RETURN
;
KEY_D12_K2	MOVLF	"-",KEYREG	;SUB
	BSF	OP_BIT
	RETURN
;
KEY_D12_K3	MOVLF	"X",KEYREG	;EEX
	RETURN
;
KEY_D12_K4	MOVLF	"x",KEYREG	;10^x
	RETURN
;
KEY_NUMBER	BSF	DIGIT_BIT
	GOTO	SCAN_KEYS_5
;********************************************************************
;READING TWICE THE USART > CLEARING THE FIFO & ERROR BITS
;CLR_USART1 : CLEARS USART #1
CLR_USART1	BCF	CREN
	NOP
	NOP
	BSF	CREN
	MOVF	RCREG,W
	NOP
	NOP
;
	BCF	CREN
	NOP
	NOP
	BSF	CREN
	MOVF	RCREG,W
;
	RETURN
;********************************************************************
;_ERROR : ERROR OCCURED DURING OPERATION OR ENTRIES ARE INVALID
_ERROR	BSF	ERROR_BIT
	CALL	CLEAR_DISPLAY
;CHECK THE OTHER ERROR BITS
	BTFSC	DIV0_BIT	;SKIP IF NO ERROR #0		
	BRA	ERROR_0	
	BTFSC	OVFL_BIT	;SKIP IF NO ERROR #1		
	BRA	ERROR_1
	BTFSC	UNDRUN_BIT	;SKIP IF NO ERROR #2		
	BRA	ERROR_2
	BTFSC	ERROR_BIT3	;SKIP IF NO ERROR #3		
	BRA	ERROR_3
	BTFSC	TOO_BIG_BIT	;SKIP IF NO ERROR #4		
	BRA	ERROR_4
	BTFSC	ERROR_BIT5	;SKIP IF NO ERROR #5		
	BRA	ERROR_5
	BTFSC	n_ERROR_BIT	;SKIP IF NO ERROR #6		
	BRA	ERROR_6
	GOTO	GET_NEXT_KEY
;ERROR_0 -> DIVIDE BY ZERO
ERROR_0	LED_TXT	LED_ERROR_0	;DIVIDE BY ZERO!
	GOTO	GET_NEXT_KEY
;ERROR_1
ERROR_1	LED_TXT	LED_ERROR_1
	GOTO	GET_NEXT_KEY
;ERROR_2
ERROR_2	LED_TXT	LED_ERROR_2
	GOTO	GET_NEXT_KEY
;ERROR_3
ERROR_3	LED_TXT	LED_ERROR_3
	GOTO	GET_NEXT_KEY
;ERROR_4
ERROR_4	LED_TXT	LED_ERROR_4	
	GOTO	GET_NEXT_KEY
;ERROR_5
ERROR_5	LED_TXT	LED_ERROR_5
	GOTO	GET_NEXT_KEY
;ERROR_6
ERROR_6	LED_TXT	LED_ERROR_6
	GOTO	GET_NEXT_KEY
;ERROR_7
ERROR_7	LED_TXT	LED_ERROR_7
	GOTO	GET_NEXT_KEY
;********************************************************************
;DISPLAY_ANNS
;DUMMY SUBROUTINE FOR COMPATIBILITY ONLY
DISPLAY_ANNS	NOP
	RETURN
;********************************************************************
;CI : CONSOLE INPUT. 
;RETURNS WITH AN ASCII CHARACTER-CODE IN CMDREG. (CMDREG -> CoMmanD REGister)
;IF NO CONSOL INPUT : CMDREG=0
;INPUT : ASCII CODE FROM TERMINAL
;OUTPUT : CHARACTER CODE IN WREG, LAST_X & CMDREG
;CALLS : CLR_USART1 (IF ERROR)
;AFFECTS : W, TEMP, CMDREG, STATUS
CI	CLRF	CMDREG
	BCF	RX_BIT
	BTFSC	FERR	;SKIP IF NO FRAMING ERROR
	BRA	CI1_ERROR
	NOP
	BTFSC	OERR	;SKIP IF NO OVERRUN ERROR
	BRA	CI1_ERROR
;
	BTFSS	RC1IF	;SKIP IF RCREG IS FULL
	RETURN
;CHANGE CHAR. CODE TO CAPITALS
GET_CAPS_CI	MOVF	RCREG,W
;	MOVWF	ASCII_REG	;SAVE THE ORIGINAL INCOMING CHARACTER IN ASCII_REG
	ADDLW	D'255' - 'z'	;GET THE HIGH LIMIT
	ADDLW	'z' - 'a' + 1	;ADD LOWER LIMIT TO SET CARRY
	BTFSS	C	;If Carry Set, then Lower Case
	ADDLW 	H'20'	;Carry NOT Set, Restore Character
	ADDLW 	'A'	;Add 'A' to restore the Character
;
	BSF	RX_BIT
	MOVWF	CMDREG
;
	RETURN
;
CI1_ERROR	CALL	CLR_USART1
	MOVLW	"!"
	CALL	CO
	RETURN
;********************************************************************
;CO : CONSOLE OUTPUT
;INPUT : CHARACTER CODE IN W-REG.
;OUTPUT : ASCII REPRESENTATION TO CONSOLE
;CALLS : NOTHING
;AFFECTS : W, TXREG, STATUS
CO	BTFSS	TXEN
	RETURN
	BTFSS	TRMT	;TXREG IS EMPTY?
	BRA	CO	;NO, TRY AGAIN
	MOVWF	TXREG
	RETURN
;********************************************************************
;NMOUT : SENDS THE ASCII REPRESENTATIONS OF A 8 BIT BINARY
;NUMBER IN W-REG. INTO THE TERMINAL
;INPUT : BINARY NUMBER IN W-REG.
;OUTPUT : ASCII REPRESENTATION TO CONSOLE
;CALLS : NUMTBL, CO
NMOUT	MOVWF	TEMP2	;SAVE 8 BIT BINARY NUMBER
	SWAPF	TEMP2,W	;HI NIBBLE SWAPPED TO LO NIBBLE
	ANDLW	H'0F'	;MASK OUT "HI" NIBBLE
	CALL	NUMTBL
	CALL	CO
	MOVF	TEMP2,W
NMOUT_L	ANDLW	H'0F'	;MASK OUT THE REAL HI NIBBLE
	CALL	NUMTBL
	CALL	CO
	RETURN
;********************************************************************
;WAIT & DELAY ROUTINES
;********************************************************************
W1S	CALL	W250MS
	CALL	W250MS
	CALL	W250MS
	CALL	W250MS
	RETURN
;********************************************************************
W250MS	MOVLW	D'250'
	MOVWF	DELAY_CNT
	BRA	DELAY
;
W100MS	MOVLW	D'100'
	MOVWF	DELAY_CNT
	BRA	DELAY	
;
W50MS	MOVLW	D'50'
	MOVWF	DELAY_CNT
	BRA	DELAY
;
W20MS	MOVLW	D'20'
	MOVWF	DELAY_CNT
	BRA	DELAY
;
W10MS	MOVLW	D'10'
	MOVWF	DELAY_CNT
	BRA	DELAY
;
W5MS	MOVLW	D'05'
	MOVWF	DELAY_CNT
	BRA	DELAY
;	
DELAY	CALL	W1MS
	DECFSZ	DELAY_CNT,F
	BRA	DELAY			
	RETURN
;
W1MS	MOVLW	HIGH OSCFREQ10
	MOVWF	DELAY_HI
	MOVLW	LOW OSCFREQ10
	MOVWF	DELAY_LO	
;
WAIT_01	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	DECF	DELAY_LO,F
	BNZ	WAIT_01
	MOVF	DELAY_HI,F
	BTFSC	Z
	RETURN
	DECF	DELAY_HI,F
	BRA	WAIT_01
;********************************************************************
;CLEAR_DISPLAY
CLEAR_DISPLAY	CLRF	DP_REG
	CLRF	LED_1
	CLRF	LED_2
	CLRF	LED_3
	CLRF	LED_4
	CLRF	LED_5
	CLRF	LED_6
	CLRF	LED_7
	CLRF	LED_8
	CLRF	LED_9
	CLRF	LED_10
	CLRF	LED_11
	CLRF	LED_12
	CLRF	LED_EXP_10S
	CLRF	LED_EXP_1S
	CLRF	LED_15
;
	RETURN
;********************************************************************
;LED_TEXT_OUT
LED_TEXT_OUT	NOP
;COPY ASCII CODES OF THE TEXT-STRING INTO RAM. ! 10 CHARACTERS !
	TBLRD*+
	MOVFF	TABLAT,H'00'
	TBLRD*+
	MOVFF	TABLAT,H'01'	
	TBLRD*+
	MOVFF	TABLAT,H'02'
	TBLRD*+
	MOVFF	TABLAT,H'03'
	TBLRD*+
	MOVFF	TABLAT,H'04'
	TBLRD*+
	MOVFF	TABLAT,H'05'
	TBLRD*+
	MOVFF	TABLAT,H'06'
	TBLRD*+
	MOVFF	TABLAT,H'07'
	TBLRD*+
	MOVFF	TABLAT,H'08'
	TBLRD*+
	MOVFF	TABLAT,H'09'
;
	MOVLF	UPPER LED_CHAR_TABLE,TBLPTRU
	MOVLF	HIGH LED_CHAR_TABLE,TBLPTRH
;
	MOVFF	H'00',TBLPTRL
	TBLRD*
	MOVFF	TABLAT,LED_2
;
	MOVFF	H'01',TBLPTRL
	TBLRD*
	MOVFF	TABLAT,LED_3
;
	MOVFF	H'02',TBLPTRL
	TBLRD*
	MOVFF	TABLAT,LED_4
;
	MOVFF	H'03',TBLPTRL
	TBLRD*
	MOVFF	TABLAT,LED_5
;
	MOVFF	H'04',TBLPTRL
	TBLRD*
	MOVFF	TABLAT,LED_6
;
	MOVFF	H'05',TBLPTRL
	TBLRD*
	MOVFF	TABLAT,LED_7
;
	MOVFF	H'06',TBLPTRL
	TBLRD*
	MOVFF	TABLAT,LED_8
;
	MOVFF	H'07',TBLPTRL
	TBLRD*
	MOVFF	TABLAT,LED_9
;
	MOVFF	H'08',TBLPTRL
	TBLRD*
	MOVFF	TABLAT,LED_EXP_10S
;
	MOVFF	H'09',TBLPTRL
	TBLRD*
	MOVFF	TABLAT,LED_EXP_1S
;
	RETURN
;********************************************************************
	ORG	H'1D500'
;********************************************************************
;TEXT DEFINITIONS FOR 7-segment LED DISPLAY
LED_HELLO	DB	"  HELL0   "
LED_ERROR	DB	"  ERROR   "
LED_ERROR_0	DB	" ERROR 0  "	;DIVIDED BY 0
LED_ERROR_1	DB	" ERROR 1  "
LED_ERROR_2	DB	" ERROR 2  "
LED_ERROR_3	DB	" ERROR 3  "
LED_ERROR_4	DB	" ERROR 4  "
LED_ERROR_5	DB	" ERROR 5  "
LED_ERROR_6	DB	" ERROR 6  "
LED_ERROR_7	DB	" ERROR 7  "
LED_FULL	DB	"8888888888"
;********************************************************************
	ORG	H'1D600'
;********************************************************************
;LED_CHAR_TABLE
LED_CHAR_TABLE
;
;   7   6   5   4   3   2   1   0
;
;   f   b   g   d   e   a   dp  c
;
;0: 1   1   0   1   1   1   0   1 -> DD
;1: 0   1   0   0   0   0   0   1 -> 41
;2: 0   1   1   1   1   1   0   0 -> 7C
;3: 0   1   1   1   0   1   0   1 -> 75
;4: 1   1   1   0   0   0   0   1 -> E1
;5: 1   0   1   1   0   1   0   1 -> B5
;6: 1   0   1   1   1   1   0   1 -> BD
;7: 0   1   0   0   0   1   0   1 -> 45
;8: 1   1   1   1   1   1   0   1 -> FD
;9: 1   1   1   1   0   1   0   1 -> F5
;
;@: 0   1   1   1   1   1   0   1 -> 7D
;A: 1   1   1   0   0   1   0   1 -> E5
;
;b: 1   0   1   1   1   0   0   1 -> B9
;C: 1   0   0   1   1   1   0   0 -> 9C
;
;d: 0   1   1   1   1   0   0   1 -> 79
;E: 1   0   1   1   1   1   0   0 -> BC
;
;F: 1   0   0   1   0   1   0   1 -> 
;G: 1   0   1   1   1   1   0   1 -> 
;
;H: 1   1   1   0   1   0   0   1 -> E9
;I: 0   1   0   0   0   0   0   1 -> 41
;
;J: 0   0   1   1   1   0   0   0 -> 
;K:
;
;L: 1   0   0   1   1   0   0   0 -> 98
;M: 1   1   0   0   1   1   0   1 -> CD
;
;   7   6   5   4   3   2   0   0
;
;   f   b   g   d   e   a   dp  c
;
;n: 0   0   1   0   1   0   0   1 -> 29
;o: 0   0   1   1   1   0   0   1 -> 39
;
;P: 1   1   1   0   1   1   0   0 -> EC
;Q:
;
;r: 0   0   1   0   1   0   0   0 -> 28
;S: 1   0   1   1   0   1   0   1 -> B5
;
;t: 0   0   0   1   1   1   0   1 -> 
;u: 0   0   1   1   1   0   0   0 -> 
;
;V:
;W:
;
;X:
;Y:
;
;Z:
;
;H'00' - H'0F'
	DW	H'0000'
	DW	H'0000'
	DW	H'0000'
	DW	H'0000'
	DW	H'0000'
	DW	H'0000'
	DW	H'0000'
	DW	H'0000'
;H'10' - H'1F'
	DW	H'0000'
	DW	H'0000'
	DW	H'0000'
	DW	H'0000'
	DW	H'0000'
	DW	H'0000'
	DW	H'0000'
	DW	H'0000'
;H'20' - H'2F'
	DW	H'0000'
	DW	H'0000'
	DW	H'0000'
	DW	H'0000'
	DW	H'0000'
	DW	H'0000'
	DW	H'4000'	;-
	DW	H'0000'
;H'30' - H'3F'
	DW	H'41DD'	;10
	DW	H'757C'	;32
	DW	H'B5E1'	;54
	DW	H'45BD'	;76
	DW	H'F5FD'	;98
	DW	H'0000'
	DW	H'0000'
	DW	H'0000'
;H'40' - H'4F'
	DW	H'E57D'	;A@
	DW	H'9CB9'	;Cb
	DW	H'BC79'	;Ed
	DW	H'0000'	;GF
	DW	H'41E9'	;IH
	DW	H'0000'	;KJ
	DW	H'CD98'	;ML
	DW	H'3929'	;ON
;H'50' - H'5F'
	DW	H'0000'	;QP
	DW	H'B528'	;Sr
	DW	H'0000'	;UT
	DW	H'0000'	;WV
	DW	H'0000'	;YZ
	DW	H'0000'	;
	DW	H'0000'	;
	DW	H'1000'	;_
;********************************************************************
	END
