;REGISTERS.INC
;********************************************************************
;FREQUENTLY USED REGISTERS. ALL OF THEM HAVE DEDICATED SIGN & EXP_SIGN BIT
;********************************************************************
;T-REGISTER : TOP OF THE STACK
T_0	EQU	H'170'
T_1	EQU	H'171'
T_2	EQU	H'172'
T_3	EQU	H'173'
T_4	EQU	H'174'
T_5	EQU	H'175'
T_6	EQU	H'176'
T_EXP	EQU	H'177'
;Z-REGISTER
Z_0	EQU	H'178'
Z_1	EQU	H'179'
Z_2	EQU	H'17A'
Z_3	EQU	H'17B'
Z_4	EQU	H'17C'
Z_5	EQU	H'17D'
Z_6	EQU	H'17E'
Z_EXP	EQU	H'17F'
;Y-REGISTER
Y_0	EQU	H'180'
Y_1	EQU	H'181'
Y_2	EQU	H'182'
Y_3	EQU	H'183'
Y_4	EQU	H'184'
Y_5	EQU	H'185'
Y_6	EQU	H'186'
Y_EXP	EQU	H'187'
;X REGISTER : BOTTOM OF THE STACK
X_0	EQU	H'188'
X_1	EQU	H'189'
X_2	EQU	H'18A'
X_3	EQU	H'18B'
X_4	EQU	H'18C'
X_5	EQU	H'18D'
X_6	EQU	H'18E'
X_EXP	EQU	H'18F'
;********************************************************************
;P-REGISTER -> PRODUCT REGISTER
P_0	EQU	H'190'
P_1	EQU	H'191'
P_2	EQU	H'192'
P_3	EQU	H'193'
P_4	EQU	H'194'
P_5	EQU	H'195'
P_6	EQU	H'196'
P_7	EQU	H'197'
P_8	EQU	H'198'
P_9	EQU	H'199'
P_A	EQU	H'19A'
P_B	EQU	H'19B'
P_C	EQU	H'19C'
P_D	EQU	H'19D'
;
OP_REG	EQU	H'19E'
;OPERATION RELATED BITS -> CLEARED BEFORE EVERY KEY ENTRY
OP_BITS	EQU	H'19F'	
;#DEFINE		OP_BITS,7
;#DEFINE		OP_BITS,6
;#DEFINE		OP_BITS,5	;
;#DEFINE		OP_BITS,4	;
;#DEFINE		OP_BITS,3	;
#DEFINE	MEM_BIT	OP_BITS,2	;MEMORY RELATED OPERATIONS
#DEFINE	OP_BIT	OP_BITS,1	;OPERAND (+, -, *, /, SQR, etc.)
#DEFINE	DIGIT_BIT	OP_BITS,0	;INCOMING ENTRY = DIGIT
;********************************************************************
;R-REGISTER : REMAINDER REGISTER
R_0	EQU	H'1A0'
R_1	EQU	H'1A1'
R_2	EQU	H'1A2'
R_3	EQU	H'1A3'
R_4	EQU	H'1A4'
R_5	EQU	H'1A5'
R_6	EQU	H'1A6'
R_7	EQU	H'1A7'
R_8	EQU	H'1A8'
R_9	EQU	H'1A9'
R_A	EQU	H'1AA'
R_B	EQU	H'1AB'
R_C	EQU	H'1AC'
R_D	EQU	H'1AD'
TEMP_SAVE	EQU	H'1AE'
CORDIC_BITS	EQU	H'1AF'
#DEFINE	OLD_D_BIT	CORDIC_BITS,1
#DEFINE	D_BIT	CORDIC_BITS,0
;********************************************************************
X_TEMP0_0	EQU	H'1B0'
X_TEMP0_1	EQU	H'1B1'
X_TEMP0_2	EQU	H'1B2'
X_TEMP0_3	EQU	H'1B3'
X_TEMP0_4	EQU	H'1B4'
X_TEMP0_5	EQU	H'1B5'
X_TEMP0_6	EQU	H'1B6'
X_TEMP0_EXP	EQU	H'1B7'
;
Y_TEMP0_0	EQU	H'1B8'
Y_TEMP0_1	EQU	H'1B9'
Y_TEMP0_2	EQU	H'1BA'
Y_TEMP0_3	EQU	H'1BB'
Y_TEMP0_4	EQU	H'1BC'
Y_TEMP0_5	EQU	H'1BD'
Y_TEMP0_6	EQU	H'1BE'
Y_TEMP0_EXP	EQU	H'1BF'
;********************************************************************
;B-REG
B_0	EQU	H'1C0'
B_1	EQU	H'1C1'
B_2	EQU	H'1C2'
B_3	EQU	H'1C3'
B_4	EQU	H'1C4'
B_5	EQU	H'1C5'
B_6	EQU	H'1C6'
B_EXP	EQU	H'1C7'
;
S_0	EQU	H'1C8'
S_1	EQU	H'1C9'
S_2	EQU	H'1CA'
S_3	EQU	H'1CB'
S_4	EQU	H'1CC'
S_5	EQU	H'1CD'
S_6	EQU	H'1CE'
S_EXP	EQU	H'1CF'
;********************************************************************
;Q-REGISTER -> QUOTIENT
Q_0	EQU	H'1D0'
Q_1	EQU	H'1D1'
Q_2	EQU	H'1D2'
Q_3	EQU	H'1D3'
Q_4	EQU	H'1D4'
Q_5	EQU	H'1D5'
Q_6	EQU	H'1D6'
;
QUARTER_REG	EQU	H'1D7'
#DEFINE	_4TH_Q_BIT	QUARTER_REG,3
#DEFINE	_3RD_Q_BIT	QUARTER_REG,2
#DEFINE	_2ND_Q_BIT	QUARTER_REG,1
#DEFINE	_1ST_Q_BIT	QUARTER_REG,0
;
EXP_SHIFT_REG	EQU	H'1D8'
N_REGISTER	EQU	H'1D9'
LOOP_NUM	EQU	H'1DA'
K_REG	EQU	H'1DB'
DIGIT_CNT	EQU	H'1DC'
ENTRY_BITS	EQU	H'1DD'
#DEFINE	EEX_BIT	ENTRY_BITS,3	;ENTER EXPONENT BIT -> 1 = EXPONENT ENTRY IN PROGRESS
#DEFINE	MAX_NUM	ENTRY_BITS,2	;1 = MAXIMUM NUMBER OF DIGITS REACHED -> 8 or 2
#DEFINE	DP_OK	ENTRY_BITS,1	;1 = DECIMAL POINT HAS BEEN ENTERED YET  
#DEFINE	_1ST_DIGIT_BIT	ENTRY_BITS,0	;0 = NO NUMBER ENTERED YET, 1 = NUMBER(S) HAS(HAVE) BEEN ENTERED
;	EQU	H'1DE'
;	EQU	H'1DF'
;********************************************************************
X_EXP_TEMP	EQU	H'1E0'
Y_EXP_TEMP	EQU	H'1E1'
X_EXP_BIN	EQU	H'1E2'
Y_EXP_BIN	EQU	H'1E3'
X_EXP_SAVE	EQU	H'1E4'
Y_EXP_SAVE	EQU	H'1E5'
BCD_UP	EQU	H'1E6'
BCD_HI	EQU	H'1E7'
BCD_LO	EQU	H'1E8'
SQRT_REG_HI	EQU	H'1E9'
SQRT_REG_LO	EQU	H'1EA'
NEW_ENTRY_REG	EQU	H'1EB'
#DEFINE	NEW_ENTRY_BIT	NEW_ENTRY_REG,0	;NEW_ENTRY_BIT=1 -> NO NUMBERS ENTERED
DP_REG	EQU	H'1EC'
DP_POS	EQU	H'1ED'	;DECIMAL POINT POSITION -> USED AT DISPLAY
INNER_LOOP_CNT	EQU	H'1EF'
;********************************************************************
SIGN_REG	EQU	H'1F0'
#DEFINE	M_SIGN	SIGN_REG,7
#DEFINE	R_SIGN	SIGN_REG,6
#DEFINE	Q_SIGN	SIGN_REG,5
#DEFINE	P_SIGN	SIGN_REG,4
#DEFINE	T_SIGN	SIGN_REG,3
#DEFINE	Z_SIGN	SIGN_REG,2
#DEFINE	Y_SIGN	SIGN_REG,1
#DEFINE	X_SIGN	SIGN_REG,0
;
EXP_SIGN_REG	EQU	H'1F1'
#DEFINE	M_EXP_SIGN	EXP_SIGN_REG,7
#DEFINE	R_EXP_SIGN	EXP_SIGN_REG,6
#DEFINE	Q_EXP_SIGN	EXP_SIGN_REG,5
#DEFINE	P_EXP_SIGN	EXP_SIGN_REG,4
#DEFINE	T_EXP_SIGN	EXP_SIGN_REG,3
#DEFINE	Z_EXP_SIGN	EXP_SIGN_REG,2
#DEFINE	Y_EXP_SIGN	EXP_SIGN_REG,1
#DEFINE	X_EXP_SIGN	EXP_SIGN_REG,0
;
SIGN_REG2	EQU	H'1F2'
#DEFINE	Y_TEMP0_SIGN	SIGN_REG2,7
#DEFINE	X_TEMP0_SIGN	SIGN_REG2,6
#DEFINE	Y_TEMP_SIGN	SIGN_REG2,5
#DEFINE	X_TEMP_SIGN	SIGN_REG2,4
#DEFINE	T_ORI_SIGN	SIGN_REG2,3
#DEFINE	Z_ORI_SIGN	SIGN_REG2,2
#DEFINE	Y_ORI_SIGN	SIGN_REG2,1
#DEFINE	X_ORI_SIGN	SIGN_REG2,0
;
EXP_SIGN_REG2	EQU	H'1F3'
#DEFINE	Y_TEMP0_EXP_SIGN EXP_SIGN_REG2,7
#DEFINE	X_TEMP0_EXP_SIGN EXP_SIGN_REG2,6
#DEFINE	Y_TEMP_EXP_SIGN	EXP_SIGN_REG2,5
#DEFINE	X_TEMP_EXP_SIGN	EXP_SIGN_REG2,4
#DEFINE	T_ORI_EXP_SIGN	EXP_SIGN_REG2,3
#DEFINE	Z_ORI_EXP_SIGN	EXP_SIGN_REG2,2
#DEFINE	Y_ORI_EXP_SIGN	EXP_SIGN_REG2,1
#DEFINE	X_ORI_EXP_SIGN	EXP_SIGN_REG2,0
;
SIGN_REG3	EQU	H'1F4'
#DEFINE	SIGN_SAVE_BIT	SIGN_REG3,7
#DEFINE	X_SIGN_TEMP	SIGN_REG3,6
#DEFINE	Y_SIGN_SAVE	SIGN_REG3,5
#DEFINE	X_SIGN_SAVE	SIGN_REG3,4
#DEFINE	LASTX_SIGN	SIGN_REG3,3
#DEFINE	TEMP_SIGN	SIGN_REG3,2
#DEFINE	B_SIGN	SIGN_REG3,1
#DEFINE	S_SIGN	SIGN_REG3,0
;
EXP_SIGN_REG3	EQU	H'1F5'
;#DEFINE		EXP_SIGN_REG3,7
;#DEFINE		EXP_SIGN_REG3,6
#DEFINE	Y_EXP_SIGN_SAVE	EXP_SIGN_REG3,5
#DEFINE	X_EXP_SIGN_SAVE	EXP_SIGN_REG3,4
#DEFINE	LASTX_EXP_SIGN	EXP_SIGN_REG3,3
#DEFINE	TEMP_EXP_SIGN	EXP_SIGN_REG3,2
#DEFINE	B_EXP_SIGN	EXP_SIGN_REG3,1
#DEFINE	S_EXP_SIGN	EXP_SIGN_REG3,0
;
SIGN_REG4	EQU	H'1F6'
;#DEFINE		SIGN_REG4,7
;#DEFINE		SIGN_REG4,6
;#DEFINE		SIGN_REG4,5
;#DEFINE		SIGN_REG4,4
#DEFINE	Y_SAVE_SIGN	SIGN_REG4,3
#DEFINE	X_SAVE_SIGN	SIGN_REG4,2
#DEFINE	NEW_Y_SIGN	SIGN_REG4,1
#DEFINE	NEW_X_SIGN	SIGN_REG4,0
;
EXP_SIGN_REG4	EQU	H'1F7'
#DEFINE	Y_SAVE_EXP_SIGN	EXP_SIGN_REG4,7
#DEFINE	X_SAVE_EXP_SIGN	EXP_SIGN_REG4,6
#DEFINE	Y_EXP_SAVE_SIGN	EXP_SIGN_REG4,5
#DEFINE	X_EXP_SAVE_SIGN	EXP_SIGN_REG4,4
#DEFINE	Y_EXP_TEMP_SIGN	EXP_SIGN_REG4,3
#DEFINE	X_EXP_TEMP_SIGN	EXP_SIGN_REG4,2
#DEFINE	NEW_Y_EXP_SIGN	EXP_SIGN_REG4,1
#DEFINE	NEW_X_EXP_SIGN	EXP_SIGN_REG4,0
;TRIG SIGNS
TRIG_SIGN_REG	EQU	H'1F8'
;#DEFINE	_SIGN	TRIG_SIGN_REG,7
;#DEFINE	_SIGN	TRIG_SIGN_REG,6
#DEFINE	ATAN_SIGN	TRIG_SIGN_REG,5
#DEFINE	ACOS_SIGN	TRIG_SIGN_REG,4
#DEFINE	ASIN_SIGN	TRIG_SIGN_REG,3
#DEFINE	TAN_SIGN	TRIG_SIGN_REG,2
#DEFINE	COS_SIGN	TRIG_SIGN_REG,1
#DEFINE	SINE_SIGN	TRIG_SIGN_REG,0
;
TRIG_EXP_SIGN_REG EQU	H'1F9'
;#DEFINE	_SIGN	TRIG_EXP_SIGN_REG,7
;#DEFINE	_SIGN	TRIG_EXP_SIGN_REG,6
#DEFINE	ATAN_EXP_SIGN	TRIG_EXP_SIGN_REG,5
#DEFINE	ACOS_EXP_SIGN	TRIG_EXP_SIGN_REG,4
#DEFINE	ASIN_EXP_SIGN	TRIG_EXP_SIGN_REG,3
#DEFINE	TAN_EXP_SIGN	TRIG_EXP_SIGN_REG,2
#DEFINE	COS_EXP_SIGN	TRIG_EXP_SIGN_REG,1
#DEFINE	SIN_EXP_SIGN	TRIG_EXP_SIGN_REG,0
;
N_REG	EQU	H'1FA'
N_REG_SAVE	EQU	H'1FB'
MODE_REG	EQU	H'1FC'
#DEFINE	GRAD_BIT	MODE_REG,7	;GRADIENT
#DEFINE	RAD_BIT	MODE_REG,6	;RADIAN
#DEFINE	DEG_BIT	MODE_REG,5	;DEGREE
#DEFINE	INT_BIT	MODE_REG,4	;INTEGER BIT
#DEFINE	ENG_BIT	MODE_REG,3	;
#DEFINE	_2ND_BIT	MODE_REG,2	;2nd FUNCTION
#DEFINE	FIX_BIT	MODE_REG,1	;
#DEFINE	SCI_BIT	MODE_REG,0	;
;
ERROR_REG	EQU	H'1FD'
#DEFINE	ERROR_BIT	ERROR_REG,7	;IF ERROR_BIT=1, ERROR OCCURED DURING EXECUTION
#DEFINE	n_ERROR_BIT	ERROR_REG,6	;n IS NOT A NATURAL NUMBER (USED AT "COUNTING" FACTORIAL)
#DEFINE	ERROR_BIT5	ERROR_REG,5	;
#DEFINE	TOO_BIG_BIT	ERROR_REG,4	;ANGLE IS TOO BIG
#DEFINE	ERROR_BIT3	ERROR_REG,3	;INVALID x ENTRY!
#DEFINE	UNDRUN_BIT	ERROR_REG,2	;UNDERRUN
#DEFINE	OVFL_BIT	ERROR_REG,1	;OVERFLOW
#DEFINE	DIV0_BIT	ERROR_REG,0	;DIVIDE BY ZERO
;
;	EQU	H'1FE'
;
ZERO_BITS_REG	EQU	H'1FF'
#DEFINE	EQU_BIT	ZERO_BITS_REG,7	;EQU_BIT=1 if |X_x|=|Y_y|, else EQU_BIT=0
#DEFINE	R_0_BIT	ZERO_BITS_REG,6
#DEFINE	Q_0_BIT	ZERO_BITS_REG,5
#DEFINE	P_0_BIT	ZERO_BITS_REG,4
#DEFINE	T_0_BIT	ZERO_BITS_REG,3
#DEFINE	Z_0_BIT	ZERO_BITS_REG,2
#DEFINE	Y_0_BIT	ZERO_BITS_REG,1
#DEFINE	X_0_BIT	ZERO_BITS_REG,0
;********************************************************************
MEM_ADDR	EQU	H'200'
;********************************************************************
X_SAVE_0	EQU	MEM_ADDR+H'00'
X_SAVE_1	EQU	MEM_ADDR+H'01'
X_SAVE_2	EQU	MEM_ADDR+H'02'
X_SAVE_3	EQU	MEM_ADDR+H'03'
X_SAVE_4	EQU	MEM_ADDR+H'04'
X_SAVE_5	EQU	MEM_ADDR+H'05'
X_SAVE_6	EQU	MEM_ADDR+H'06'
X_SAVE_EXP	EQU	MEM_ADDR+H'07'
;
Y_SAVE_0	EQU	MEM_ADDR+H'08'
Y_SAVE_1	EQU	MEM_ADDR+H'09'
Y_SAVE_2	EQU	MEM_ADDR+H'0A'
Y_SAVE_3	EQU	MEM_ADDR+H'0B'
Y_SAVE_4	EQU	MEM_ADDR+H'0C'
Y_SAVE_5	EQU	MEM_ADDR+H'0D'
Y_SAVE_6	EQU	MEM_ADDR+H'0E'
Y_SAVE_EXP	EQU	MEM_ADDR+H'0F'
;
X_ORI_0	EQU	MEM_ADDR+H'10'
X_ORI_1	EQU	MEM_ADDR+H'11'
X_ORI_2	EQU	MEM_ADDR+H'12'
X_ORI_3	EQU	MEM_ADDR+H'13'
X_ORI_4	EQU	MEM_ADDR+H'14'
X_ORI_5	EQU	MEM_ADDR+H'15'
X_ORI_6	EQU	MEM_ADDR+H'16'
X_ORI_EXP	EQU	MEM_ADDR+H'17'
;
Y_ORI_0	EQU	MEM_ADDR+H'18'
Y_ORI_1	EQU	MEM_ADDR+H'19'
Y_ORI_2	EQU	MEM_ADDR+H'1A'
Y_ORI_3	EQU	MEM_ADDR+H'1B'
Y_ORI_4	EQU	MEM_ADDR+H'1C'
Y_ORI_5	EQU	MEM_ADDR+H'1D'
Y_ORI_6	EQU	MEM_ADDR+H'1E'
Y_ORI_EXP	EQU	MEM_ADDR+H'1F'
;
Z_ORI_0	EQU	MEM_ADDR+H'20'
Z_ORI_1	EQU	MEM_ADDR+H'21'
Z_ORI_2	EQU	MEM_ADDR+H'22'
Z_ORI_3	EQU	MEM_ADDR+H'23'
Z_ORI_4	EQU	MEM_ADDR+H'24'
Z_ORI_5	EQU	MEM_ADDR+H'25'
Z_ORI_6	EQU	MEM_ADDR+H'26'
Z_ORI_EXP	EQU	MEM_ADDR+H'27'
;
T_ORI_0	EQU	MEM_ADDR+H'28'
T_ORI_1	EQU	MEM_ADDR+H'29'
T_ORI_2	EQU	MEM_ADDR+H'2A'
T_ORI_3	EQU	MEM_ADDR+H'2B'
T_ORI_4	EQU	MEM_ADDR+H'2C'
T_ORI_5	EQU	MEM_ADDR+H'2D'
T_ORI_6	EQU	MEM_ADDR+H'2E'
T_ORI_EXP	EQU	MEM_ADDR+H'2F'
;
MEM_0	EQU	MEM_ADDR+H'30'
MEM_1	EQU	MEM_ADDR+H'31'
MEM_2	EQU	MEM_ADDR+H'32'
MEM_3	EQU	MEM_ADDR+H'33'
MEM_4	EQU	MEM_ADDR+H'34'
MEM_5	EQU	MEM_ADDR+H'35'
MEM_6	EQU	MEM_ADDR+H'36'
MEM_EXP	EQU	MEM_ADDR+H'37'
;
NUM_0	EQU	MEM_ADDR+H'38'
NUM_1	EQU	MEM_ADDR+H'39'
NUM_2	EQU	MEM_ADDR+H'3A'
NUM_3	EQU	MEM_ADDR+H'3B'
NUM_4	EQU	MEM_ADDR+H'3C'
NUM_5	EQU	MEM_ADDR+H'3D'
NUM_6	EQU	MEM_ADDR+H'3E'
NUM_EXP	EQU	MEM_ADDR+H'3F'
;REGISTERS USED BY "CORDIC" & "TAYLOR" PROGRAMS
SIN_0	EQU	MEM_ADDR+H'40'	
SIN_1	EQU	MEM_ADDR+H'41'
SIN_2	EQU	MEM_ADDR+H'42'
SIN_3	EQU	MEM_ADDR+H'43'	
SIN_4	EQU	MEM_ADDR+H'44'
SIN_5	EQU	MEM_ADDR+H'45'
SIN_6	EQU	MEM_ADDR+H'46'
SIN_EXP	EQU	MEM_ADDR+H'47'
;
SIN_NEW_0	EQU	MEM_ADDR+H'48'
SIN_NEW_1	EQU	MEM_ADDR+H'49'
SIN_NEW_2	EQU	MEM_ADDR+H'4A'	
SIN_NEW_3	EQU	MEM_ADDR+H'4B'
SIN_NEW_4	EQU	MEM_ADDR+H'4C'
SIN_NEW_5	EQU	MEM_ADDR+H'4D'
SIN_NEW_6	EQU	MEM_ADDR+H'4E'
SIN_NEW_EXP	EQU	MEM_ADDR+H'4F'
;
COS_0	EQU	MEM_ADDR+H'50'
COS_1	EQU	MEM_ADDR+H'51'
COS_2	EQU	MEM_ADDR+H'52'
COS_3	EQU	MEM_ADDR+H'53'
COS_4	EQU	MEM_ADDR+H'54'
COS_5	EQU	MEM_ADDR+H'55'
COS_6	EQU	MEM_ADDR+H'56'
COS_EXP	EQU	MEM_ADDR+H'57'
;
COS_NEW_0	EQU	MEM_ADDR+H'58'
COS_NEW_1	EQU	MEM_ADDR+H'59'
COS_NEW_2	EQU	MEM_ADDR+H'5A'
COS_NEW_3	EQU	MEM_ADDR+H'5B'
COS_NEW_4	EQU	MEM_ADDR+H'5C'
COS_NEW_5	EQU	MEM_ADDR+H'5D'
COS_NEW_6	EQU	MEM_ADDR+H'5E'
COS_NEW_EXP	EQU	MEM_ADDR+H'5F'
;
TAN_0	EQU	MEM_ADDR+H'60'
TAN_1	EQU	MEM_ADDR+H'61'
TAN_2	EQU	MEM_ADDR+H'62'
TAN_3	EQU	MEM_ADDR+H'63'
TAN_4	EQU	MEM_ADDR+H'64'
TAN_5	EQU	MEM_ADDR+H'65'
TAN_6	EQU	MEM_ADDR+H'66'
TAN_EXP	EQU	MEM_ADDR+H'67'
;
ARCTAN_0	EQU	MEM_ADDR+H'68'
ARCTAN_1	EQU	MEM_ADDR+H'69'
ARCTAN_2	EQU	MEM_ADDR+H'6A'
ARCTAN_3	EQU	MEM_ADDR+H'6B'
ARCTAN_4	EQU	MEM_ADDR+H'6C'
ARCTAN_5	EQU	MEM_ADDR+H'6D'
ARCTAN_6	EQU	MEM_ADDR+H'6E'
ARCTAN_EXP	EQU	MEM_ADDR+H'6F'
;
X_NEW_0	EQU	MEM_ADDR+H'70'
X_NEW_1	EQU	MEM_ADDR+H'71'
X_NEW_2	EQU	MEM_ADDR+H'72'
X_NEW_3	EQU	MEM_ADDR+H'73'
X_NEW_4	EQU	MEM_ADDR+H'74'
X_NEW_5	EQU	MEM_ADDR+H'75'
X_NEW_6	EQU	MEM_ADDR+H'76'
X_NEW_EXP	EQU	MEM_ADDR+H'77'
;
Y_NEW_0	EQU	MEM_ADDR+H'78'
Y_NEW_1	EQU	MEM_ADDR+H'79'
Y_NEW_2	EQU	MEM_ADDR+H'7A'
Y_NEW_3	EQU	MEM_ADDR+H'7B'
Y_NEW_4	EQU	MEM_ADDR+H'7C'
Y_NEW_5	EQU	MEM_ADDR+H'7D'
Y_NEW_6	EQU	MEM_ADDR+H'7E'
Y_NEW_EXP	EQU	MEM_ADDR+H'7F'
;
ANGLE_0	EQU	MEM_ADDR+H'80'
ANGLE_1	EQU	MEM_ADDR+H'81'
ANGLE_2	EQU	MEM_ADDR+H'82'
ANGLE_3	EQU	MEM_ADDR+H'83'
ANGLE_4	EQU	MEM_ADDR+H'84'
ANGLE_5	EQU	MEM_ADDR+H'85'
ANGLE_6	EQU	MEM_ADDR+H'86'
ANGLE_EXP	EQU	MEM_ADDR+H'87'
;
NEW_ANGLE_0	EQU	MEM_ADDR+H'88'
NEW_ANGLE_1	EQU	MEM_ADDR+H'89'
NEW_ANGLE_2	EQU	MEM_ADDR+H'8A'
NEW_ANGLE_3	EQU	MEM_ADDR+H'8B'
NEW_ANGLE_4	EQU	MEM_ADDR+H'8C'
NEW_ANGLE_5	EQU	MEM_ADDR+H'8D'
NEW_ANGLE_6	EQU	MEM_ADDR+H'8E'
NEW_ANGLE_EXP	EQU	MEM_ADDR+H'8F'
;
X_TEMP_0	EQU	MEM_ADDR+H'90'
X_TEMP_1	EQU	MEM_ADDR+H'91'
X_TEMP_2	EQU	MEM_ADDR+H'92'
X_TEMP_3	EQU	MEM_ADDR+H'93'
X_TEMP_4	EQU	MEM_ADDR+H'94'
X_TEMP_5	EQU	MEM_ADDR+H'95'
X_TEMP_6	EQU	MEM_ADDR+H'96'
X_TEMP_EXP	EQU	MEM_ADDR+H'97'
;
Y_TEMP_0	EQU	MEM_ADDR+H'98'
Y_TEMP_1	EQU	MEM_ADDR+H'99'
Y_TEMP_2	EQU	MEM_ADDR+H'9A'
Y_TEMP_3	EQU	MEM_ADDR+H'9B'
Y_TEMP_4	EQU	MEM_ADDR+H'9C'
Y_TEMP_5	EQU	MEM_ADDR+H'9D'
Y_TEMP_6	EQU	MEM_ADDR+H'9E'
Y_TEMP_EXP	EQU	MEM_ADDR+H'9F'
;
TARGET_ANGLE_0	EQU	MEM_ADDR+H'A0'
TARGET_ANGLE_1	EQU	MEM_ADDR+H'A1'
TARGET_ANGLE_2	EQU	MEM_ADDR+H'A2'
TARGET_ANGLE_3	EQU	MEM_ADDR+H'A3'
TARGET_ANGLE_4	EQU	MEM_ADDR+H'A4'
TARGET_ANGLE_5	EQU	MEM_ADDR+H'A5'
TARGET_ANGLE_6	EQU	MEM_ADDR+H'A6'
TARGET_ANGLE_EXP EQU	MEM_ADDR+H'A7'
;
SUM_ANGLE_0	EQU	MEM_ADDR+H'A8'
SUM_ANGLE_1	EQU	MEM_ADDR+H'A9'
SUM_ANGLE_2	EQU	MEM_ADDR+H'AA'
SUM_ANGLE_3	EQU	MEM_ADDR+H'AB'
SUM_ANGLE_4	EQU	MEM_ADDR+H'AC'
SUM_ANGLE_5	EQU	MEM_ADDR+H'AD'
SUM_ANGLE_6	EQU	MEM_ADDR+H'AE'
SUM_ANGLE_EXP	EQU	MEM_ADDR+H'AF'
;
SAVE_HI	EQU	MEM_ADDR+H'B0'
SAVE_LO	EQU	MEM_ADDR+H'B1'
;
LNX_0	EQU	MEM_ADDR+H'C0'
LNX_1	EQU	MEM_ADDR+H'C1'
LNX_2	EQU	MEM_ADDR+H'C2'
LNX_3	EQU	MEM_ADDR+H'C3'
LNX_4	EQU	MEM_ADDR+H'C4'
LNX_5	EQU	MEM_ADDR+H'C5'
LNX_6	EQU	MEM_ADDR+H'C6'
LNX_EXP	EQU	MEM_ADDR+H'C7'
;
SUM_LNX_0	EQU	MEM_ADDR+H'C8'
SUM_LNX_1	EQU	MEM_ADDR+H'C9'
SUM_LNX_2	EQU	MEM_ADDR+H'CA'
SUM_LNX_3	EQU	MEM_ADDR+H'CB'
SUM_LNX_4	EQU	MEM_ADDR+H'CC'
SUM_LNX_5	EQU	MEM_ADDR+H'CD'
SUM_LNX_6	EQU	MEM_ADDR+H'CE'
SUM_LNX_EXP	EQU	MEM_ADDR+H'CF'
;
SAVE_LNX_0	EQU	MEM_ADDR+H'D0'
SAVE_LNX_1	EQU	MEM_ADDR+H'D1'
SAVE_LNX_2	EQU	MEM_ADDR+H'D2'
SAVE_LNX_3	EQU	MEM_ADDR+H'D3'
SAVE_LNX_4	EQU	MEM_ADDR+H'D4'
SAVE_LNX_5	EQU	MEM_ADDR+H'D5'
SAVE_LNX_6	EQU	MEM_ADDR+H'D6'
SAVE_LNX_EXP	EQU	MEM_ADDR+H'D7'
;
STORE_X_0	EQU	MEM_ADDR+H'D8'
STORE_X_1	EQU	MEM_ADDR+H'D9'
STORE_X_2	EQU	MEM_ADDR+H'DA'
STORE_X_3	EQU	MEM_ADDR+H'DB'
STORE_X_4	EQU	MEM_ADDR+H'DC'
STORE_X_5	EQU	MEM_ADDR+H'DD'
STORE_X_6	EQU	MEM_ADDR+H'DE'
STORE_X_EXP	EQU	MEM_ADDR+H'DF'
;
TEMP_0	EQU	MEM_ADDR+H'F0'
TEMP_1	EQU	MEM_ADDR+H'F1'
TEMP_2	EQU	MEM_ADDR+H'F2'
TEMP_3	EQU	MEM_ADDR+H'F3'
TEMP_4	EQU	MEM_ADDR+H'F4'
TEMP_5	EQU	MEM_ADDR+H'F5'
TEMP_6	EQU	MEM_ADDR+H'F6'
TEMP_EXP	EQU	MEM_ADDR+H'F7'
;
LASTX_0	EQU	MEM_ADDR+H'F8'
LASTX_1	EQU	MEM_ADDR+H'F9'
LASTX_2	EQU	MEM_ADDR+H'FA'
LASTX_3	EQU	MEM_ADDR+H'FB'
LASTX_4	EQU	MEM_ADDR+H'FC'
LASTX_5	EQU	MEM_ADDR+H'FD'
LASTX_6	EQU	MEM_ADDR+H'FE'
LASTX_EXP	EQU	MEM_ADDR+H'FF'
;********************************************************************







