;SIMPLE_ROUTINES.INC
;LAST REVISION: 2018. 01. 04.
;********************************************************************
;
;SUBROUTINES ASSOCIATED TO X-REGISTER
;
;********************************************************************
;CLEAR_X
CLEAR_X	CLRF	X_0
	CLRF	X_1
	CLRF	X_2
	CLRF	X_3
	CLRF	X_4
	CLRF	X_5
	CLRF	X_6
	CLRF	X_EXP
;
	BCF	X_SIGN
	BCF	X_EXP_SIGN
;
	CLRF	X_EXP_TEMP
	BCF	X_SAVE_EXP_SIGN
;
	RETURN
;*************************************************************
;CHECK_X_0?
;X_0_BIT = 0 IF ALL OF DECIMALS ARE ZERO
CHECK_X_0?	BCF	X_0_BIT	;DEFAULT -> X_x = 0
;X_6
	MOVF	X_6,F
	BNZ	X_NOZERO
;X_5
	MOVF	X_5,F
	BNZ	X_NOZERO
;X_4
	MOVF	X_4,F
	BNZ	X_NOZERO
;X_3
	MOVF	X_3,F
	BNZ	X_NOZERO
;X_2
	MOVF	X_2,F
	BNZ	X_NOZERO
;X_1
	MOVF	X_1,F
	BNZ	X_NOZERO
;X_0
	MOVF	X_0,F
	BNZ	X_NOZERO
;X MANTISSA &  ALL DECIMALS ARE ZERO -> SET EXPONENT TO ZERO, AS WELL
	CLRF	X_EXP
	BCF	X_EXP_SIGN
;
	RETURN		;[X_x] = 0
;
X_NOZERO	BSF	X_0_BIT
;
	RETURN
;********************************************************************
;COPY_X_2_Y
COPY_X_2_Y	MOVFF	X_0,Y_0
	MOVFF	X_1,Y_1
	MOVFF	X_2,Y_2
	MOVFF	X_3,Y_3
	MOVFF	X_4,Y_4
	MOVFF	X_5,Y_5
	MOVFF	X_6,Y_6
	MOVFF	X_EXP,Y_EXP
;
	BCF	Y_SIGN
	BTFSC	X_SIGN
	BSF	Y_SIGN
;
	BCF	Y_EXP_SIGN
	BTFSC	X_EXP_SIGN
	BSF	Y_EXP_SIGN
;
	RETURN
;********************************************************************
;COPY_Y_2_X
COPY_Y_2_X	MOVFF	Y_0,X_0
	MOVFF	Y_1,X_1
	MOVFF	Y_2,X_2
	MOVFF	Y_3,X_3
	MOVFF	Y_4,X_4
	MOVFF	Y_5,X_5
	MOVFF	Y_6,X_6
	MOVFF	Y_EXP,X_EXP
;
	BCF	X_SIGN
	BTFSC	Y_SIGN
	BSF	X_SIGN
;
	BCF	X_EXP_SIGN
	BTFSC	Y_EXP_SIGN
	BSF	X_EXP_SIGN
;
	RETURN
;********************************************************************
;COPY_X_2_Z
COPY_X_2_Z	MOVFF	X_0,Z_0
	MOVFF	X_1,Z_1
	MOVFF	X_2,Z_2
	MOVFF	X_3,Z_3
	MOVFF	X_4,Z_4
	MOVFF	X_5,Z_5
	MOVFF	X_6,Z_6
	MOVFF	X_EXP,Z_EXP
;
	BCF	Z_SIGN
	BTFSC	X_SIGN
	BSF	Z_SIGN
;
	BCF	Z_EXP_SIGN
	BTFSC	X_EXP_SIGN
	BSF	Z_EXP_SIGN
;
	RETURN
;********************************************************************
;COPY_Z_2_X
COPY_Z_2_X	MOVFF	Z_0,X_0
	MOVFF	Z_1,X_1
	MOVFF	Z_2,X_2
	MOVFF	Z_3,X_3
	MOVFF	Z_4,X_4
	MOVFF	Z_5,X_5
	MOVFF	Z_6,X_6
	MOVFF	Z_EXP,X_EXP
;
	BCF	X_SIGN
	BTFSC	Z_SIGN
	BSF	X_SIGN
;
	BCF	X_EXP_SIGN
	BTFSC	Z_EXP_SIGN
	BSF	X_EXP_SIGN
;
	RETURN
;********************************************************************
;COPY_X_2_T
COPY_X_2_T	MOVFF	X_0,T_0
	MOVFF	X_1,T_1
	MOVFF	X_2,T_2
	MOVFF	X_3,T_3
	MOVFF	X_4,T_4
	MOVFF	X_5,T_5
	MOVFF	X_6,T_6
	MOVFF	X_EXP,T_EXP
;
	BCF	T_SIGN
	BTFSC	X_SIGN
	BSF	T_SIGN
;
	BCF	T_EXP_SIGN
	BTFSC	X_EXP_SIGN
	BSF	T_EXP_SIGN
;
	RETURN
;********************************************************************
;COPY_T_2_X
COPY_T_2_X	MOVFF	T_0,X_0
	MOVFF	T_1,X_1
	MOVFF	T_2,X_2
	MOVFF	T_3,X_3
	MOVFF	T_4,X_4
	MOVFF	T_5,X_5
	MOVFF	T_6,X_6
	MOVFF	T_EXP,X_EXP
;
	BCF	X_SIGN
	BTFSC	T_SIGN
	BSF	X_SIGN
;
	BCF	X_EXP_SIGN
	BTFSC	T_EXP_SIGN
	BSF	X_EXP_SIGN
;
	RETURN
;********************************************************************
;COPY_X_SAVE_2_T : USED AT ROLL-DOWN
COPY_X_SAVE_2_T	MOVFF	X_SAVE_0,T_0
	MOVFF	X_SAVE_1,T_1
	MOVFF	X_SAVE_2,T_2
	MOVFF	X_SAVE_3,T_3
	MOVFF	X_SAVE_4,T_4
	MOVFF	X_SAVE_5,T_5
	MOVFF	X_SAVE_6,T_6
	MOVFF	X_SAVE_EXP,T_EXP
;
	BCF	T_SIGN
	BTFSC	X_SAVE_SIGN
	BSF	T_SIGN
;
	BCF	T_EXP_SIGN
	BTFSC	X_SAVE_EXP_SIGN
	BSF	T_EXP_SIGN
;
	RETURN
;********************************************************************
;COPY_X_2_TEMP
COPY_X_2_TEMP	MOVFF	X_0,TEMP_0
	MOVFF	X_1,TEMP_1
	MOVFF	X_2,TEMP_2
	MOVFF	X_3,TEMP_3
	MOVFF	X_4,TEMP_4
	MOVFF	X_5,TEMP_5
	MOVFF	X_6,TEMP_6
	MOVFF	X_EXP,TEMP_EXP
;
	BCF	TEMP_SIGN
	BTFSC	X_SIGN
	BSF	TEMP_SIGN
;
	BCF	TEMP_EXP_SIGN
	BTFSC	X_EXP_SIGN
	BSF	TEMP_EXP_SIGN
;
	RETURN
;********************************************************************
;COPY_TEMP_2_X
COPY_TEMP_2_X
	MOVFF	TEMP_0,X_0
	MOVFF	TEMP_1,X_1
	MOVFF	TEMP_2,X_2
	MOVFF	TEMP_3,X_3
	MOVFF	TEMP_4,X_4
	MOVFF	TEMP_5,X_5
	MOVFF	TEMP_6,X_6
	MOVFF	TEMP_EXP,X_EXP
;
	BCF	X_SIGN
	BTFSC	TEMP_SIGN
	BSF	X_SIGN
;
	BCF	X_EXP_SIGN
	BTFSC	TEMP_EXP_SIGN
	BSF	X_EXP_SIGN
;
	RETURN
;*************************************************************
;COPY_X_2_R
COPY_X_2_R	MOVFF	X_0,R_0
	MOVFF	X_1,R_1
	MOVFF	X_2,R_2
	MOVFF	X_3,R_3
	MOVFF	X_4,R_4
	MOVFF	X_5,R_5
	MOVFF	X_6,R_6
;
	RETURN
;********************************************************************
;COPY_X_2_S
COPY_X_2_S	MOVFF	X_0,S_0
	MOVFF	X_1,S_1
	MOVFF	X_2,S_2
	MOVFF	X_3,S_3
	MOVFF	X_4,S_4
	MOVFF	X_5,S_5
	MOVFF	X_6,S_6
	MOVFF	X_EXP,S_EXP
;
	BCF	S_SIGN
	BTFSC	X_SIGN
	BSF	S_SIGN
;
	BCF	S_EXP_SIGN
	BTFSC	X_EXP_SIGN
	BSF	S_EXP_SIGN
;
	RETURN
;********************************************************************
;COPY_S_2_X
COPY_S_2_X	MOVFF	S_0,X_0
	MOVFF	S_1,X_1
	MOVFF	S_2,X_2
	MOVFF	S_3,X_3
	MOVFF	S_4,X_4
	MOVFF	S_5,X_5
	MOVFF	S_6,X_6
	MOVFF	S_EXP,X_EXP
;
	BCF	X_SIGN
	BTFSC	S_SIGN
	BSF	X_SIGN
;
	BCF	X_EXP_SIGN
	BTFSC	S_EXP_SIGN
	BSF	X_EXP_SIGN
;
	RETURN
;********************************************************************
;SAVE_ORI_X ; SAVE X_x INTO X ORIGINAL REGISTERS
SAVE_ORI_X
	MOVFF	X_0,X_ORI_0
	MOVFF	X_1,X_ORI_1
	MOVFF	X_2,X_ORI_2
	MOVFF	X_3,X_ORI_3
	MOVFF	X_4,X_ORI_4
	MOVFF	X_5,X_ORI_5
	MOVFF	X_6,X_ORI_6
	MOVFF	X_EXP,X_ORI_EXP
;
	BCF	X_ORI_SIGN
	BTFSC	X_SIGN
	BSF	X_ORI_SIGN
;
	BCF	X_ORI_EXP_SIGN
	BTFSC	X_EXP_SIGN
	BSF	X_ORI_EXP_SIGN
;
	RETURN
;********************************************************************
;RELOAD_ORI_X
RELOAD_ORI_X	MOVFF	X_ORI_0,X_0
	MOVFF	X_ORI_1,X_1
	MOVFF	X_ORI_2,X_2
	MOVFF	X_ORI_3,X_3
	MOVFF	X_ORI_4,X_4
	MOVFF	X_ORI_5,X_5
	MOVFF	X_ORI_6,X_6
	MOVFF	X_ORI_EXP,X_EXP
;
	BCF	X_SIGN
	BTFSC	X_ORI_SIGN
	BSF	X_SIGN
;
	BCF	X_EXP_SIGN
	BTFSC	X_ORI_EXP_SIGN
	BSF	X_EXP_SIGN
;
	RETURN
;********************************************************************
;RELOAD_ORI_X_2_Y
RELOAD_ORI_X_2_Y
	MOVFF	X_ORI_0,Y_0
	MOVFF	X_ORI_1,Y_1
	MOVFF	X_ORI_2,Y_2
	MOVFF	X_ORI_3,Y_3
	MOVFF	X_ORI_4,Y_4
	MOVFF	X_ORI_5,Y_5
	MOVFF	X_ORI_6,Y_6
	MOVFF	X_ORI_EXP,Y_EXP
;
	BCF	Y_SIGN
	BTFSC	X_ORI_SIGN
	BSF	Y_SIGN
;
	BCF	Y_EXP_SIGN
	BTFSC	X_ORI_EXP_SIGN
	BSF	Y_EXP_SIGN
;
	RETURN
;********************************************************************
;COPY_X_2_M
COPY_X_2_M	MOVFF	X_0,MEM_0
	MOVFF	X_1,MEM_1
	MOVFF	X_2,MEM_2
	MOVFF	X_3,MEM_3
	MOVFF	X_4,MEM_4
	MOVFF	X_5,MEM_5
	MOVFF	X_6,MEM_6
	MOVFF	X_EXP,MEM_EXP
;
	BCF	M_SIGN
	BTFSC	X_SIGN
	BSF	M_SIGN
;
	BCF	M_EXP_SIGN
	BTFSC	X_EXP_SIGN
	BSF	M_EXP_SIGN
;
	RETURN
;********************************************************************
;COPY_M_2_X
COPY_M_2_X	MOVFF	MEM_0,X_0
	MOVFF	MEM_1,X_1
	MOVFF	MEM_2,X_2
	MOVFF	MEM_3,X_3
	MOVFF	MEM_4,X_4
	MOVFF	MEM_5,X_5
	MOVFF	MEM_6,X_6
	MOVFF	MEM_EXP,X_EXP
;
	BCF	X_SIGN
	BTFSC	M_SIGN
	BSF	X_SIGN
;
	BCF	X_EXP_SIGN
	BTFSC	M_EXP_SIGN
	BSF	X_EXP_SIGN
;
	RETURN
;********************************************************************
;COPY_M_2_Y
COPY_M_2_Y	MOVFF	MEM_0,Y_0
	MOVFF	MEM_1,Y_1
	MOVFF	MEM_2,Y_2
	MOVFF	MEM_3,Y_3
	MOVFF	MEM_4,Y_4
	MOVFF	MEM_5,Y_5
	MOVFF	MEM_6,Y_6
	MOVFF	MEM_EXP,Y_EXP
;
	BCF	Y_SIGN
	BTFSC	M_SIGN
	BSF	Y_SIGN
;
	BCF	Y_EXP_SIGN
	BTFSC	M_EXP_SIGN
	BSF	Y_EXP_SIGN
;
	RETURN
;********************************************************************
;SAVE_X ; SAVE X_x INTO X SHADOW REGISTERS
SAVE_X	MOVFF	X_0,X_SAVE_0
	MOVFF	X_1,X_SAVE_1
	MOVFF	X_2,X_SAVE_2
	MOVFF	X_3,X_SAVE_3
	MOVFF	X_4,X_SAVE_4
	MOVFF	X_5,X_SAVE_5
	MOVFF	X_6,X_SAVE_6
	MOVFF	X_EXP,X_SAVE_EXP
;
	BCF	X_SAVE_SIGN
	BTFSC	X_SIGN
	BSF	X_SAVE_SIGN
;
	BCF	X_SAVE_EXP_SIGN
	BTFSC	X_EXP_SIGN
	BSF	X_SAVE_EXP_SIGN
;
	RETURN
;********************************************************************
;RELOAD_X ; RELOAD X_x FROM X SHADOW REGISTERS
RELOAD_X	MOVFF	X_SAVE_0,X_0
	MOVFF	X_SAVE_1,X_1
	MOVFF	X_SAVE_2,X_2
	MOVFF	X_SAVE_3,X_3
	MOVFF	X_SAVE_4,X_4
	MOVFF	X_SAVE_5,X_5
	MOVFF	X_SAVE_6,X_6
	MOVFF	X_SAVE_EXP,X_EXP
;
	BCF	X_SIGN
	BTFSC	X_SAVE_SIGN
	BSF	X_SIGN
;
	BCF	X_EXP_SIGN
	BTFSC	X_SAVE_EXP_SIGN
	BSF	X_EXP_SIGN
;
	RETURN
;********************************************************************
;SAVE_X_TEMP0 : SAVE ONLY THE X_x MANTISSA!
SAVE_X_TEMP0	MOVFF	X_0,X_TEMP0_0
	MOVFF	X_1,X_TEMP0_1
	MOVFF	X_2,X_TEMP0_2
	MOVFF	X_3,X_TEMP0_3
	MOVFF	X_4,X_TEMP0_4
	MOVFF	X_5,X_TEMP0_5
	MOVFF	X_6,X_TEMP0_6
;
	RETURN
;********************************************************************
;RELOAD_X_TEMP0 ; RELOAD X_x MANTISSA FROM X_TEMP0 REGISTERS
RELOAD_X_TEMP0	MOVFF	X_TEMP0_0,X_0
	MOVFF	X_TEMP0_1,X_1
	MOVFF	X_TEMP0_2,X_2
	MOVFF	X_TEMP0_3,X_3
	MOVFF	X_TEMP0_4,X_4
	MOVFF	X_TEMP0_5,X_5
	MOVFF	X_TEMP0_6,X_6
;
	RETURN
;********************************************************************
;SAVE_X_TEMP0_SIGN
SAVE_X_TEMP0_SIGN BCF	X_TEMP0_SIGN
	BTFSC	X_SIGN
	BSF	X_TEMP0_SIGN
;
	RETURN
;********************************************************************
;SAVE_X_TEMP0_EXP
SAVE_X_TEMP0_EXP MOVFF	X_EXP,X_TEMP0_EXP
	BCF	X_TEMP0_EXP_SIGN
	BTFSC	X_EXP_SIGN
	BSF	X_TEMP0_EXP_SIGN
;
	RETURN
;********************************************************************
;RELOAD_X_EXP
RELOAD_X_EXP	MOVFF	X_SAVE_EXP,X_EXP
;
	BCF	X_EXP_SIGN
	BTFSC	X_SAVE_EXP_SIGN
	BSF	X_EXP_SIGN
;
	RETURN
;********************************************************************
;RELOAD_X_TEMP0_SIGN
RELOAD_X_TEMP0_SIGN BCF	X_SIGN
	BTFSC	X_TEMP0_SIGN
	BSF	X_SIGN
;
	RETURN
;********************************************************************
;RELOAD_X_TEMP0_EXP
RELOAD_X_TEMP0_EXP
	MOVFF	X_TEMP0_EXP,X_EXP
	BCF	X_EXP_SIGN
	BTFSC	X_TEMP0_EXP_SIGN
	BSF	X_EXP_SIGN
;
	RETURN
;********************************************************************
;SAVE_X_TEMP
SAVE_X_TEMP	MOVFF	X_0,X_TEMP_0
	MOVFF	X_1,X_TEMP_1
	MOVFF	X_2,X_TEMP_2
	MOVFF	X_3,X_TEMP_3
	MOVFF	X_4,X_TEMP_4
	MOVFF	X_5,X_TEMP_5
	MOVFF	X_6,X_TEMP_6
	MOVFF	X_EXP,X_TEMP_EXP
;
	BCF	X_TEMP_SIGN
	BTFSC	X_SIGN
	BSF	X_TEMP_SIGN
;
	BCF	X_TEMP_EXP_SIGN
	BTFSC	X_EXP_SIGN
	BSF	X_TEMP_EXP_SIGN
;
	RETURN
;********************************************************************
;RELOAD_X_TEMP ; RELOAD X_x FROM X_TEMP REGISTERS
RELOAD_X_TEMP	MOVFF	X_TEMP_0,X_0
	MOVFF	X_TEMP_1,X_1
	MOVFF	X_TEMP_2,X_2
	MOVFF	X_TEMP_3,X_3
	MOVFF	X_TEMP_4,X_4
	MOVFF	X_TEMP_5,X_5
	MOVFF	X_TEMP_6,X_6
	MOVFF	X_TEMP_EXP,X_EXP
;
	BCF	X_SIGN
	BTFSC	X_TEMP_SIGN
	BSF	X_SIGN
;
	BCF	X_EXP_SIGN
	BTFSC	X_TEMP_EXP_SIGN
	BSF	X_EXP_SIGN
;
	RETURN
;********************************************************************
;RELOAD_X_TEMP_2_Y
RELOAD_X_TEMP_2_Y MOVFF	X_TEMP_0,Y_0
	MOVFF	X_TEMP_1,Y_1
	MOVFF	X_TEMP_2,Y_2
	MOVFF	X_TEMP_3,Y_3
	MOVFF	X_TEMP_4,Y_4
	MOVFF	X_TEMP_5,Y_5
	MOVFF	X_TEMP_6,Y_6
	MOVFF	X_TEMP_EXP,Y_EXP
;
	BCF	Y_SIGN
	BTFSC	X_TEMP_SIGN
	BSF	Y_SIGN
;
	BCF	Y_EXP_SIGN
	BTFSC	X_TEMP_EXP_SIGN
	BSF	Y_EXP_SIGN
;
	RETURN
;********************************************************************
;COPY_X_2_LASTX
COPY_X_2_LASTX	MOVFF	X_0,LASTX_0
	MOVFF	X_1,LASTX_1
	MOVFF	X_2,LASTX_2
	MOVFF	X_3,LASTX_3
	MOVFF	X_4,LASTX_4
	MOVFF	X_5,LASTX_5
	MOVFF	X_6,LASTX_6
	MOVFF	X_EXP,LASTX_EXP
;
	BCF	LASTX_SIGN
	BTFSC	X_SIGN
	BSF	LASTX_SIGN
;
	BCF	LASTX_EXP_SIGN
	BTFSC	X_EXP_SIGN
	BSF	LASTX_EXP_SIGN
;
	RETURN
;********************************************************************
;COPY_LASTX_2_X
COPY_LASTX_2_X	MOVFF	LASTX_0,X_0
	MOVFF	LASTX_1,X_1
	MOVFF	LASTX_2,X_2
	MOVFF	LASTX_3,X_3
	MOVFF	LASTX_4,X_4
	MOVFF	LASTX_5,X_5
	MOVFF	LASTX_6,X_6
	MOVFF	LASTX_EXP,X_EXP
;
	BCF	X_SIGN
	BTFSC	LASTX_SIGN
	BSF	X_SIGN
;
	BCF	X_EXP_SIGN
	BTFSC	LASTX_EXP_SIGN
	BSF	X_EXP_SIGN
;
	RETURN
;********************************************************************
;COPY_X_2_LNX
COPY_X_2_LNX
;SET OR RESET SIGN BITS
	MOVLW	H'0F'	;CLEAR HIGH NIBBLE OF X_6
	ANDWF	X_6,F
;		
	BTFSC	X_SIGN	;SET X_6,6 ACCORDING TO X_SIGN
	BSF	X_6,6	
;
	BTFSC	X_EXP_SIGN	;SET X_6,7 ACCORDING TO X_EXP_SIGN
	BSF	X_6,7
;
	MOVFF	X_0,LNX_0
	MOVFF	X_1,LNX_1
	MOVFF	X_2,LNX_2
	MOVFF	X_3,LNX_3
	MOVFF	X_4,LNX_4
	MOVFF	X_5,LNX_5
	MOVFF	X_6,LNX_6
	MOVFF	X_EXP,LNX_EXP
;CLEAR HIGH NIBBLE OF X_6, AGAIN
	MOVLW	H'0F'
	ANDWF	X_6,F
;
	RETURN
;********************************************************************
;COPY_LNX_2_X
COPY_LNX_2_X	MOVFF	LNX_0,X_0
	MOVFF	LNX_1,X_1
	MOVFF	LNX_2,X_2
	MOVFF	LNX_3,X_3
	MOVFF	LNX_4,X_4
	MOVFF	LNX_5,X_5
	MOVFF	LNX_6,X_6
	MOVFF	LNX_EXP,X_EXP
;X_6 HIGH NIBBLE CONTAINS THE SIGNS!
	BCF	X_SIGN
	BTFSC	X_6,6
	BSF	X_SIGN
;
	BCF	X_EXP_SIGN
	BTFSC	X_6,7
	BSF	X_EXP_SIGN
;CLEAR HIGH NIBBLE OF X_6
	MOVLW	H'0F'
	ANDWF	X_6,F
;
	RETURN
;********************************************************************
;COPY_X_2_SUM_LNX
COPY_X_2_SUM_LNX
;SET OR RESET SIGN BITS
	MOVLW	H'0F'	;CLEAR HIGH NIBBLE OF X_6
	ANDWF	X_6,F
;		
	BTFSC	X_SIGN	;SET X_6,6 ACCORDING TO X_SIGN
	BSF	X_6,6	
;
	BTFSC	X_EXP_SIGN	;SET X_6,7 ACCORDING TO X_EXP_SIGN
	BSF	X_6,7
;
	MOVFF	X_0,SUM_LNX_0
	MOVFF	X_1,SUM_LNX_1
	MOVFF	X_2,SUM_LNX_2
	MOVFF	X_3,SUM_LNX_3
	MOVFF	X_4,SUM_LNX_4
	MOVFF	X_5,SUM_LNX_5
	MOVFF	X_6,SUM_LNX_6
	MOVFF	X_EXP,SUM_LNX_EXP
;CLEAR HIGH NIBBLE OF X_6, AGAIN
	MOVLW	H'0F'
	ANDWF	X_6,F
;
	RETURN
;********************************************************************
;COPY_SUM_LNX_2_X
COPY_SUM_LNX_2_X
	MOVFF	SUM_LNX_0,X_0
	MOVFF	SUM_LNX_1,X_1
	MOVFF	SUM_LNX_2,X_2
	MOVFF	SUM_LNX_3,X_3
	MOVFF	SUM_LNX_4,X_4
	MOVFF	SUM_LNX_5,X_5
	MOVFF	SUM_LNX_6,X_6
	MOVFF	SUM_LNX_EXP,X_EXP
;X_6 HIGH NIBBLE CONTAINS THE SIGNS!
	BCF	X_SIGN
	BTFSC	X_6,6
	BSF	X_SIGN
;
	BCF	X_EXP_SIGN
	BTFSC	X_6,7
	BSF	X_EXP_SIGN
;CLEAR HIGH NIBBLE OF X_6
	MOVLW	H'0F'
	ANDWF	X_6,F
;
	RETURN
;********************************************************************
;SAVE_LNX
SAVE_LNX
;SET OR RESET SIGN BITS
	MOVLW	H'0F'	;CLEAR HIGH NIBBLE OF X_6
	ANDWF	X_6,F
;		
	BTFSC	X_SIGN	;SET X_6,6 ACCORDING TO X_SIGN
	BSF	X_6,6	
;
	BTFSC	X_EXP_SIGN	;SET X_6,7 ACCORDING TO X_EXP_SIGN
	BSF	X_6,7
;
	MOVFF	X_0,SAVE_LNX_0
	MOVFF	X_1,SAVE_LNX_1
	MOVFF	X_2,SAVE_LNX_2
	MOVFF	X_3,SAVE_LNX_3
	MOVFF	X_4,SAVE_LNX_4
	MOVFF	X_5,SAVE_LNX_5
	MOVFF	X_6,SAVE_LNX_6
	MOVFF	X_EXP,SAVE_LNX_EXP
;CLEAR HIGH NIBBLE OF X_6, AGAIN
	MOVLW	H'0F'
	ANDWF	X_6,F
;
	RETURN
;********************************************************************
;RELOAD_LNX
RELOAD_LNX	MOVFF	SAVE_LNX_0,X_0
	MOVFF	SAVE_LNX_1,X_1
	MOVFF	SAVE_LNX_2,X_2
	MOVFF	SAVE_LNX_3,X_3
	MOVFF	SAVE_LNX_4,X_4
	MOVFF	SAVE_LNX_5,X_5
	MOVFF	SAVE_LNX_6,X_6
	MOVFF	SAVE_LNX_EXP,X_EXP
;X_6 HIGH NIBBLE CONTAINS THE SIGNS!
	BCF	X_SIGN
	BTFSC	X_6,6
	BSF	X_SIGN
;
	BCF	X_EXP_SIGN
	BTFSC	X_6,7
	BSF	X_EXP_SIGN
;CLEAR HIGH NIBBLE OF X_6
	MOVLW	H'0F'
	ANDWF	X_6,F
;
	RETURN
;********************************************************************
;STORE_X
STORE_X
;SET OR RESET SIGN BITS
	MOVLW	H'0F'	;CLEAR HIGH NIBBLE OF X_6
	ANDWF	X_6,F
;		
	BTFSC	X_SIGN	;SET X_6,6 ACCORDING TO X_SIGN
	BSF	X_6,6	
;
	BTFSC	X_EXP_SIGN	;SET X_6,7 ACCORDING TO X_EXP_SIGN
	BSF	X_6,7
;
	MOVFF	X_0,STORE_X_0
	MOVFF	X_1,STORE_X_1
	MOVFF	X_2,STORE_X_2
	MOVFF	X_3,STORE_X_3
	MOVFF	X_4,STORE_X_4
	MOVFF	X_5,STORE_X_5
	MOVFF	X_6,STORE_X_6
	MOVFF	X_EXP,STORE_X_EXP
;CLEAR HIGH NIBBLE OF X_6, AGAIN
	MOVLW	H'0F'
	ANDWF	X_6,F
;
	RETURN
;********************************************************************
;RESTORE_X
RESTORE_X	MOVFF	STORE_X_0,X_0
	MOVFF	STORE_X_1,X_1
	MOVFF	STORE_X_2,X_2
	MOVFF	STORE_X_3,X_3
	MOVFF	STORE_X_4,X_4
	MOVFF	STORE_X_5,X_5
	MOVFF	STORE_X_6,X_6
	MOVFF	STORE_X_EXP,X_EXP
;X_6 HIGH NIBBLE CONTAINS THE SIGNS!
	BCF	X_SIGN
	BTFSC	X_6,6
	BSF	X_SIGN
;
	BCF	X_EXP_SIGN
	BTFSC	X_6,7
	BSF	X_EXP_SIGN
;CLEAR HIGH NIBBLE OF X_6
	MOVLW	H'0F'
	ANDWF	X_6,F
;
	RETURN
;********************************************************************
;STORE_X_NEW
STORE_X_NEW
;SET OR RESET SIGN BITS
	MOVLW	H'0F'	;CLEAR HIGH NIBBLE OF X_6
	ANDWF	X_6,F
;		
	BTFSC	X_SIGN	;SET X_6,6 ACCORDING TO X_SIGN
	BSF	X_6,6	
;
	BTFSC	X_EXP_SIGN	;SET X_6,7 ACCORDING TO X_EXP_SIGN
	BSF	X_6,7
;
	MOVFF	X_0,X_NEW_0
	MOVFF	X_1,X_NEW_1
	MOVFF	X_2,X_NEW_2
	MOVFF	X_3,X_NEW_3
	MOVFF	X_4,X_NEW_4
	MOVFF	X_5,X_NEW_5
	MOVFF	X_6,X_NEW_6
	MOVFF	X_EXP,X_NEW_EXP
;CLEAR HIGH NIBBLE OF X_6, AGAIN
	MOVLW	H'0F'
	ANDWF	X_6,F
;
	RETURN
;********************************************************************
;RESTORE_FROM_X_NEW
RESTORE_X_NEW
	MOVFF	X_NEW_0,X_0
	MOVFF	X_NEW_1,X_1
	MOVFF	X_NEW_2,X_2
	MOVFF	X_NEW_3,X_3
	MOVFF	X_NEW_4,X_4
	MOVFF	X_NEW_5,X_5
	MOVFF	X_NEW_6,X_6
	MOVFF	X_NEW_EXP,X_EXP
;X_6 HIGH NIBBLE CONTAINS THE SIGNS!
	BCF	X_SIGN
	BTFSC	X_6,6
	BSF	X_SIGN
;
	BCF	X_EXP_SIGN
	BTFSC	X_6,7
	BSF	X_EXP_SIGN
;CLEAR HIGH NIBBLE OF X_6
	MOVLW	H'0F'
	ANDWF	X_6,F
;
	RETURN
;********************************************************************
;COPY_Q_2_X
COPY_Q_2_X	MOVFF	Q_0,X_0
	MOVFF	Q_1,X_1
	MOVFF	Q_2,X_2
	MOVFF	Q_3,X_3
	MOVFF	Q_4,X_4
	MOVFF	Q_5,X_5
	MOVFF	Q_6,X_6
;
	BCF	X_SIGN
	BTFSC	Q_SIGN
	BSF	X_SIGN
;
	RETURN
;********************************************************************
;COPY_X_2_SIN
COPY_X_2_SIN	MOVLW	H'0F'	;CLEAR HIGH NIBBLE OF X_6
	ANDWF	X_6,F
;		
	BTFSC	X_SIGN	;SET X_6,6 ACCORDING TO X_SIGN
	BSF	X_6,6	
;
	BTFSC	X_EXP_SIGN	;SET X_6,7 ACCORDING TO X_EXP_SIGN
	BSF	X_6,7
;
	MOVFF	X_0,SIN_0
	MOVFF	X_1,SIN_1
	MOVFF	X_2,SIN_2
	MOVFF	X_3,SIN_3
	MOVFF	X_4,SIN_4
	MOVFF	X_5,SIN_5
	MOVFF	X_6,SIN_6
	MOVFF	X_EXP,SIN_EXP
;CLEAR HIGH NIBBLE OF X_6, AGAIN
	MOVLW	H'0F'
	ANDWF	X_6,F
;
	RETURN
;********************************************************************
;COPY_SIN_2_X
COPY_SIN_2_X	MOVFF	SIN_0,X_0
	MOVFF	SIN_1,X_1
	MOVFF	SIN_2,X_2
	MOVFF	SIN_3,X_3
	MOVFF	SIN_4,X_4
	MOVFF	SIN_5,X_5
	MOVFF	SIN_6,X_6	;
	MOVFF	SIN_EXP,X_EXP
;X_6 HIGH NIBBLE CONTAINS THE SIGNS!
	BCF	X_SIGN
	BTFSC	X_6,6
	BSF	X_SIGN
;
	BCF	X_EXP_SIGN
	BTFSC	X_6,7
	BSF	X_EXP_SIGN
;CLEAR HIGH NIBBLE OF X_6
	MOVLW	H'0F'
	ANDWF	X_6,F
;
	RETURN
;********************************************************************
;COPY_X_2_COS
COPY_X_2_COS	MOVLW	H'0F'	;CLEAR HIGH NIBBLE OF X_6
	ANDWF	X_6,F
;		
	BTFSC	X_SIGN	;SET X_6,6 ACCORDING TO X_SIGN
	BSF	X_6,6	
;
	BTFSC	X_EXP_SIGN	;SET X_6,7 ACCORDING TO X_EXP_SIGN
	BSF	X_6,7
;
	MOVFF	X_0,COS_0
	MOVFF	X_1,COS_1
	MOVFF	X_2,COS_2
	MOVFF	X_3,COS_3
	MOVFF	X_4,COS_4
	MOVFF	X_5,COS_5
	MOVFF	X_6,COS_6
	MOVFF	X_EXP,COS_EXP
;CLEAR HIGH NIBBLE OF X_6, AGAIN
	MOVLW	H'0F'
	ANDWF	X_6,F
;
	RETURN
;********************************************************************
;COPY_X_2_SIN_NEW
COPY_X_2_SIN_NEW
	MOVLW	H'0F'	;CLEAR HIGH NIBBLE OF X_6
	ANDWF	X_6,F
;		
	BTFSC	X_SIGN	;SET X_6,6 ACCORDING TO X_SIGN
	BSF	X_6,6	
;
	BTFSC	X_EXP_SIGN	;SET X_6,7 ACCORDING TO X_EXP_SIGN
	BSF	X_6,7
;
	MOVFF	X_0,SIN_NEW_0
	MOVFF	X_1,SIN_NEW_1
	MOVFF	X_2,SIN_NEW_2
	MOVFF	X_3,SIN_NEW_3
	MOVFF	X_4,SIN_NEW_4
	MOVFF	X_5,SIN_NEW_5
	MOVFF	X_6,SIN_NEW_6
	MOVFF	X_EXP,SIN_NEW_EXP
;CLEAR HIGH NIBBLE OF X_6, AGAIN
	MOVLW	H'0F'
	ANDWF	X_6,F
;
	RETURN
;********************************************************************
;COPY_X_2_COS_NEW
COPY_X_2_COS_NEW
	MOVLW	H'0F'	;CLEAR HIGH NIBBLE OF X_6
	ANDWF	X_6,F
;		
	BTFSC	X_SIGN	;SET X_6,6 ACCORDING TO X_SIGN
	BSF	X_6,6	
;
	BTFSC	X_EXP_SIGN	;SET X_6,7 ACCORDING TO X_EXP_SIGN
	BSF	X_6,7
;
	MOVFF	X_0,COS_NEW_0
	MOVFF	X_1,COS_NEW_1
	MOVFF	X_2,COS_NEW_2
	MOVFF	X_3,COS_NEW_3
	MOVFF	X_4,COS_NEW_4
	MOVFF	X_5,COS_NEW_5
	MOVFF	X_6,COS_NEW_6
	MOVFF	X_EXP,COS_NEW_EXP
;CLEAR HIGH NIBBLE OF X_6, AGAIN
	MOVLW	H'0F'
	ANDWF	X_6,F
;
	RETURN
;********************************************************************
;COPY_COS_2_X
COPY_COS_2_X	MOVFF	COS_0,X_0
	MOVFF	COS_1,X_1
	MOVFF	COS_2,X_2
	MOVFF	COS_3,X_3
	MOVFF	COS_4,X_4
	MOVFF	COS_5,X_5
	MOVFF	COS_6,X_6
	MOVFF	COS_EXP,X_EXP
;X_6 HIGH NIBBLE CONTAINS THE SIGNS!
	BCF	X_SIGN
	BTFSC	X_6,6
	BSF	X_SIGN
;
	BCF	X_EXP_SIGN
	BTFSC	X_6,7
	BSF	X_EXP_SIGN
;CLEAR HIGH NIBBLE OF X_6
	MOVLW	H'0F'
	ANDWF	X_6,F
;
	RETURN
;********************************************************************
;COPY_COS_NEW_2_X
COPY_COS_NEW_2_X
	MOVFF	COS_NEW_0,X_0
	MOVFF	COS_NEW_1,X_1
	MOVFF	COS_NEW_2,X_2
	MOVFF	COS_NEW_3,X_3
	MOVFF	COS_NEW_4,X_4
	MOVFF	COS_NEW_5,X_5
	MOVFF	COS_NEW_6,X_6
	MOVFF	COS_NEW_EXP,X_EXP
;X_6 HIGH NIBBLE CONTAINS THE SIGNS!
	BCF	X_SIGN
	BTFSC	X_6,6
	BSF	X_SIGN
;
	BCF	X_EXP_SIGN
	BTFSC	X_6,7
	BSF	X_EXP_SIGN
;CLEAR HIGH NIBBLE OF X_6
	MOVLW	H'0F'
	ANDWF	X_6,F
;
	RETURN
;********************************************************************
;COPY_X_2_TAN
COPY_X_2_TAN	MOVLW	H'0F'	;CLEAR HIGH NIBBLE OF X_6
	ANDWF	X_6,F
;		
	BTFSC	X_SIGN	;SET X_6,6 ACCORDING TO X_SIGN
	BSF	X_6,6	
;
	BTFSC	X_EXP_SIGN	;SET X_6,7 ACCORDING TO X_EXP_SIGN
	BSF	X_6,7
;
	MOVFF	X_0,TAN_0
	MOVFF	X_1,TAN_1
	MOVFF	X_2,TAN_2
	MOVFF	X_3,TAN_3
	MOVFF	X_4,TAN_4
	MOVFF	X_5,TAN_5
	MOVFF	X_6,TAN_6
	MOVFF	X_EXP,TAN_EXP
;CLEAR HIGH NIBBLE OF X_6, AGAIN
	MOVLW	H'0F'
	ANDWF	X_6,F
;
	RETURN
;********************************************************************
;COPY_TAN_2_X
COPY_TAN_2_X	MOVFF	TAN_0,X_0
	MOVFF	TAN_1,X_1
	MOVFF	TAN_2,X_2
	MOVFF	TAN_3,X_3
	MOVFF	TAN_4,X_4
	MOVFF	TAN_5,X_5
	MOVFF	TAN_6,X_6
	MOVFF	TAN_EXP,X_EXP
;X_6 HIGH NIBBLE CONTAINS THE SIGNS!
	BCF	X_SIGN
	BTFSC	X_6,6
	BSF	X_SIGN
;
	BCF	X_EXP_SIGN
	BTFSC	X_6,7
	BSF	X_EXP_SIGN
;CLEAR HIGH NIBBLE OF X_6
	MOVLW	H'0F'
	ANDWF	X_6,F
;
	RETURN
;********************************************************************
;COPY_X_2_TARGET_ANGLE
COPY_X_2_TARGET_ANGLE   
	MOVLW	H'0F'	;CLEAR HIGH NIBBLE OF X_6
	ANDWF	X_6,F
;		
	BTFSC	X_SIGN	;SET X_6,6 ACCORDING TO X_SIGN
	BSF	X_6,6	
;
	BTFSC	X_EXP_SIGN	;SET X_6,7 ACCORDING TO X_EXP_SIGN
	BSF	X_6,7
;
	MOVFF	X_0,TARGET_ANGLE_0
	MOVFF	X_1,TARGET_ANGLE_1
	MOVFF	X_2,TARGET_ANGLE_2
	MOVFF	X_3,TARGET_ANGLE_3
	MOVFF	X_4,TARGET_ANGLE_4
	MOVFF	X_5,TARGET_ANGLE_5
	MOVFF	X_6,TARGET_ANGLE_6
	MOVFF	X_EXP,TARGET_ANGLE_EXP
;CLEAR HIGH NIBBLE OF X_6, AGAIN
	MOVLW	H'0F'
	ANDWF	X_6,F
;
	RETURN
;********************************************************************
;COPY_TARGET_ANGLE_2_X
COPY_TARGET_ANGLE_2_X
	MOVFF	TARGET_ANGLE_0,X_0
	MOVFF	TARGET_ANGLE_1,X_1
	MOVFF	TARGET_ANGLE_2,X_2
	MOVFF	TARGET_ANGLE_3,X_3
	MOVFF	TARGET_ANGLE_4,X_4
	MOVFF	TARGET_ANGLE_5,X_5
	MOVFF	TARGET_ANGLE_6,X_6
	MOVFF	TARGET_ANGLE_EXP,X_EXP
;X_6 HIGH NIBBLE CONTAINS THE SIGNS!
	BCF	X_SIGN
	BTFSC	X_6,6
	BSF	X_SIGN
;
	BCF	X_EXP_SIGN
	BTFSC	X_6,7
	BSF	X_EXP_SIGN
;CLEAR HIGH NIBBLE OF X_6
	MOVLW	H'0F'
	ANDWF	X_6,F
;
	RETURN
;********************************************************************
;COPY_X_2_SUM_ANGLE
COPY_X_2_SUM_ANGLE   
	MOVLW	H'0F'	;CLEAR HIGH NIBBLE OF X_6
	ANDWF	X_6,F
;		
	BTFSC	X_SIGN	;SET X_6,6 ACCORDING TO X_SIGN
	BSF	X_6,6	
;
	BTFSC	X_EXP_SIGN	;SET X_6,7 ACCORDING TO X_EXP_SIGN
	BSF	X_6,7
;
	MOVFF	X_0,SUM_ANGLE_0
	MOVFF	X_1,SUM_ANGLE_1
	MOVFF	X_2,SUM_ANGLE_2
	MOVFF	X_3,SUM_ANGLE_3
	MOVFF	X_4,SUM_ANGLE_4
	MOVFF	X_5,SUM_ANGLE_5
	MOVFF	X_6,SUM_ANGLE_6
	MOVFF	X_EXP,SUM_ANGLE_EXP
;CLEAR HIGH NIBBLE OF X_6, AGAIN
	MOVLW	H'0F'
	ANDWF	X_6,F
;
	RETURN
;********************************************************************
;COPY_SIN_NEW_2_X
COPY_SIN_NEW_2_X
	MOVFF	SIN_NEW_0,X_0
	MOVFF	SIN_NEW_1,X_1
	MOVFF	SIN_NEW_2,X_2
	MOVFF	SIN_NEW_3,X_3
	MOVFF	SIN_NEW_4,X_4
	MOVFF	SIN_NEW_5,X_5
	MOVFF	SIN_NEW_6,X_6
	MOVFF	SIN_NEW_EXP,X_EXP
;X_6 HIGH NIBBLE CONTAINS THE SIGNS!
	BCF	X_SIGN
	BTFSC	X_6,6
	BSF	X_SIGN
;
	BCF	X_EXP_SIGN
	BTFSC	X_6,7
	BSF	X_EXP_SIGN
;CLEAR HIGH NIBBLE OF X_6
	MOVLW	H'0F'
	ANDWF	X_6,F
;
	RETURN
;********************************************************************
;COPY_X_TO_NUM
COPY_X_TO_NUM	MOVLW	H'0F'	;CLEAR HIGH NIBBLE OF X_6
	ANDWF	X_6,F
;		
	BTFSC	X_SIGN	;SET X_6,6 ACCORDING TO X_SIGN
	BSF	X_6,6	
;
	BTFSC	X_EXP_SIGN	;SET X_6,7 ACCORDING TO X_EXP_SIGN
	BSF	X_6,7
;
	MOVFF	X_0,NUM_0
	MOVFF	X_1,NUM_1
	MOVFF	X_2,NUM_2
	MOVFF	X_3,NUM_3
	MOVFF	X_4,NUM_4
	MOVFF	X_5,NUM_5
	MOVFF	X_6,NUM_6
	MOVFF	X_EXP,NUM_EXP
;CLEAR HIGH NIBBLE OF X_6, AGAIN
	MOVLW	H'0F'
	ANDWF	X_6,F
;
	RETURN
;********************************************************************
;COPY_NUM_TO_X
COPY_NUM_TO_X	MOVFF	NUM_0,X_0
	MOVFF	NUM_1,X_1
	MOVFF	NUM_2,X_2
	MOVFF	NUM_3,X_3
	MOVFF	NUM_4,X_4
	MOVFF	NUM_5,X_5
	MOVFF	NUM_6,X_6
	MOVFF	NUM_EXP,X_EXP
;X_6 HIGH NIBBLE CONTAINS THE SIGNS!
	BCF	X_SIGN
	BTFSC	X_6,6
	BSF	X_SIGN
;
	BCF	X_EXP_SIGN
	BTFSC	X_6,7
	BSF	X_EXP_SIGN
;CLEAR HIGH NIBBLE OF X_6
	MOVLW	H'0F'
	ANDWF	X_6,F
;
	RETURN
;********************************************************************
;LOAD_ANGLE_STEP_2_X
;LOOP_NUM SHOULD BE DEFINED PRIOR TO CALLING THIS ROUTINE
LOAD_ANGLE_STEP_2_X
	MOVLF	UPPER TBL_ARCTAN,TBLPTRU
	MOVLF	HIGH TBL_ARCTAN,TBLPTRH
	MOVFF	LOOP_NUM,TBLPTRL
;LOOP_NUM -> TBLPTRL -> MULTIPLY BY 8
	BCF	C
	RLCF	TBLPTRL,F
	RLCF	TBLPTRL,F
	RLCF	TBLPTRL,F
;
	BTFSC	C
	INCF	TBLPTRH,F
;
	TBLRD*+
	MOVFF	TABLAT,X_0
	TBLRD*+
	MOVFF	TABLAT,X_1	
	TBLRD*+
	MOVFF	TABLAT,X_2
	TBLRD*+
	MOVFF	TABLAT,X_3
	TBLRD*+
	MOVFF	TABLAT,X_4
	TBLRD*+
	MOVFF	TABLAT,X_5
	TBLRD*+
	MOVFF	TABLAT,X_6
	TBLRD*
	MOVFF	TABLAT,X_EXP
;
	BCF	X_SIGN
	BTFSC	X_6,6
	BSF	X_SIGN
;
	BCF	X_EXP_SIGN
	BTFSC	X_6,7
	BSF	X_EXP_SIGN
;CLEAR X_6 HIGH NIBBLE
	MOVLW	H'0F'
	ANDWF	X_6,F
;
	RETURN
;********************************************************************
;LOAD_ANGLE_2_X
LOAD_ANGLE_2_X	MOVLF	UPPER TBL_ARCTAN,TBLPTRU
	MOVLF	HIGH TBL_ARCTAN,TBLPTRH
	MOVFF	LOOP_NUM,TBLPTRL
;LOOP_NUM -> TBLPTRL -> MULTIPLY BY 8
	BCF	C
	RLCF	TBLPTRL,F
	RLCF	TBLPTRL,F
	RLCF	TBLPTRL,F
;
	BTFSC	C
	INCF	TBLPTRH,F
;
	TBLRD*+
	MOVFF	TABLAT,X_0
	TBLRD*+
	MOVFF	TABLAT,X_1	
	TBLRD*+
	MOVFF	TABLAT,X_2
	TBLRD*+
	MOVFF	TABLAT,X_3
	TBLRD*+
	MOVFF	TABLAT,X_4
	TBLRD*+
	MOVFF	TABLAT,X_5
	TBLRD*+
	MOVFF	TABLAT,TEMP
	TBLRD*
	MOVFF	TABLAT,X_EXP
;
	MOVF	TEMP,W
	ANDLW	H'0F'
	MOVWF	X_6
;
	BCF	X_SIGN
	BTFSC	TEMP,6
	BSF	X_SIGN
;
	BCF	X_EXP_SIGN
	BTFSC	TEMP,7
	BSF	X_EXP_SIGN
;
	RETURN
;********************************************************************
;COPY_X_2_ARCTAN
COPY_X_2_ARCTAN	MOVLW	H'0F'	;CLEAR HIGH NIBBLE OF X_6
	ANDWF	X_6,F
;		
	BTFSC	X_SIGN	;SET X_6,6 ACCORDING TO X_SIGN
	BSF	X_6,6	
;
	BTFSC	X_EXP_SIGN	;SET X_6,7 ACCORDING TO X_EXP_SIGN
	BSF	X_6,7
;
	MOVFF	X_0,ARCTAN_0
	MOVFF	X_1,ARCTAN_1
	MOVFF	X_2,ARCTAN_2
	MOVFF	X_3,ARCTAN_3
	MOVFF	X_4,ARCTAN_4
	MOVFF	X_5,ARCTAN_5
	MOVFF	X_6,ARCTAN_6
	MOVFF	X_EXP,ARCTAN_EXP
;CLEAR HIGH NIBBLE OF X_6, AGAIN
	MOVLW	H'0F'
	ANDWF	X_6,F
;
	RETURN
;********************************************************************
;COPY_ARCTAN_2_X
COPY_ARCTAN_2_X	MOVFF	ARCTAN_0,X_0
	MOVFF	ARCTAN_1,X_1
	MOVFF	ARCTAN_2,X_2
	MOVFF	ARCTAN_3,X_3
	MOVFF	ARCTAN_4,X_4
	MOVFF	ARCTAN_5,X_5
	MOVFF	ARCTAN_6,X_6
	MOVFF	ARCTAN_EXP,X_EXP
;X_6 HIGH NIBBLE CONTAINS THE SIGNS!
	BCF	X_SIGN
	BTFSC	X_6,6
	BSF	X_SIGN
;
	BCF	X_EXP_SIGN
	BTFSC	X_6,7
	BSF	X_EXP_SIGN
;CLEAR HIGH NIBBLE OF X_6
	MOVLW	H'0F'
	ANDWF	X_6,F
;
	RETURN


;********************************************************************
;
;SUBROUTINES ASSOCIATED TO Y-REGISTER
;
;********************************************************************
;CLEAR_Y
CLEAR_Y	CLRF	Y_0
	CLRF	Y_1
	CLRF	Y_2
	CLRF	Y_3
	CLRF	Y_4
	CLRF	Y_5
	CLRF	Y_6
	CLRF	Y_EXP
;
	BCF	Y_SIGN
	BCF	Y_EXP_SIGN
;
	RETURN
;*************************************************************
;CHECK_Y_0?
CHECK_Y_0?	BCF	Y_0_BIT	;DEFAULT
;Y_6
	MOVF	Y_6,F
	BNZ	Y_NOZERO
;Y_5
	MOVF	Y_5,F
	BNZ	Y_NOZERO
;Y_4
	MOVF	Y_4,F
	BNZ	Y_NOZERO
;Y_3
	MOVF	Y_3,F
	BNZ	Y_NOZERO
;Y_2
	MOVF	Y_2,F
	BNZ	Y_NOZERO
;Y_1
	MOVF	Y_1,F
	BNZ	Y_NOZERO
;X_0
	MOVF	Y_0,F
	BNZ	Y_NOZERO
;
Y_ZERO	RETURN		;[Y_y] = 0
;
Y_NOZERO	BSF	Y_0_BIT
;
	RETURN
;********************************************************************
;COPY_Y_2_B
COPY_Y_2_B	MOVFF	Y_0,B_0
	MOVFF	Y_1,B_1
	MOVFF	Y_2,B_2
	MOVFF	Y_3,B_3
	MOVFF	Y_4,B_4
	MOVFF	Y_5,B_5
	MOVFF	Y_6,B_6
	MOVFF	Y_EXP,B_EXP
;
	BCF	B_SIGN
	BTFSC	Y_SIGN
	BSF	B_SIGN
;
	BCF	B_EXP_SIGN
	BTFSC	Y_EXP_SIGN
	BSF	B_EXP_SIGN
;
	RETURN
;********************************************************************
;COPY_Y_2_Z
COPY_Y_2_Z	MOVFF	Y_0,Z_0
	MOVFF	Y_1,Z_1
	MOVFF	Y_2,Z_2
	MOVFF	Y_3,Z_3
	MOVFF	Y_4,Z_4
	MOVFF	Y_5,Z_5
	MOVFF	Y_6,Z_6
	MOVFF	Y_EXP,Z_EXP
;
	BCF	Z_SIGN
	BTFSC	Y_SIGN
	BSF	Z_SIGN
;
	BCF	Z_EXP_SIGN
	BTFSC	Y_EXP_SIGN
	BSF	Z_EXP_SIGN
;
	RETURN
;********************************************************************
;COPY_Z_2_Y
COPY_Z_2_Y	MOVFF	Z_0,Y_0
	MOVFF	Z_1,Y_1
	MOVFF	Z_2,Y_2
	MOVFF	Z_3,Y_3
	MOVFF	Z_4,Y_4
	MOVFF	Z_5,Y_5
	MOVFF	Z_6,Y_6
	MOVFF	Z_EXP,Y_EXP
;
	BCF	Y_SIGN
	BTFSC	Z_SIGN
	BSF	Y_SIGN
;
	BCF	Y_EXP_SIGN
	BTFSC	Z_EXP_SIGN
	BSF	Y_EXP_SIGN
;
	RETURN
;********************************************************************
;COPY_Y_2_T
COPY_Y_2_T	MOVFF	Y_0,T_0
	MOVFF	Y_1,T_1
	MOVFF	Y_2,T_2
	MOVFF	Y_3,T_3
	MOVFF	Y_4,T_4
	MOVFF	Y_5,T_5
	MOVFF	Y_6,T_6
	MOVFF	Y_EXP,T_EXP
;
	BCF	T_SIGN
	BTFSC	Y_SIGN
	BSF	T_SIGN
;
	BCF	T_EXP_SIGN
	BTFSC	Y_EXP_SIGN
	BSF	T_EXP_SIGN
;
	RETURN
;********************************************************************
;COPY_T_2_Y
COPY_T_2_Y	MOVFF	T_0,Y_0
	MOVFF	T_1,Y_1
	MOVFF	T_2,Y_2
	MOVFF	T_3,Y_3
	MOVFF	T_4,Y_4
	MOVFF	T_5,Y_5
	MOVFF	T_6,Y_6
	MOVFF	T_EXP,Y_EXP
;
	BCF	Y_SIGN
	BTFSC	T_SIGN
	BSF	Y_SIGN
;
	BCF	Y_EXP_SIGN
	BTFSC	T_EXP_SIGN
	BSF	Y_EXP_SIGN
;
	RETURN
;********************************************************************
;SAVE_ORI_Y ; SAVE Y_y IN Y_ORI_y
SAVE_ORI_Y	MOVFF	Y_0,Y_ORI_0
	MOVFF	Y_1,Y_ORI_1
	MOVFF	Y_2,Y_ORI_2
	MOVFF	Y_3,Y_ORI_3
	MOVFF	Y_4,Y_ORI_4
	MOVFF	Y_5,Y_ORI_5
	MOVFF	Y_6,Y_ORI_6
	MOVFF	Y_EXP,Y_ORI_EXP
;
	BCF	Y_ORI_SIGN
	BTFSC	Y_SIGN
	BSF	Y_ORI_SIGN
;
	BCF	Y_ORI_EXP_SIGN
	BTFSC	Y_EXP_SIGN
	BSF	Y_ORI_EXP_SIGN
;
	RETURN
;********************************************************************
;RELOAD_ORI_Y
RELOAD_ORI_Y	MOVFF	Y_ORI_0,Y_0
	MOVFF	Y_ORI_1,Y_1
	MOVFF	Y_ORI_2,Y_2
	MOVFF	Y_ORI_3,Y_3
	MOVFF	Y_ORI_4,Y_4
	MOVFF	Y_ORI_5,Y_5
	MOVFF	Y_ORI_6,Y_6
	MOVFF	Y_ORI_EXP,Y_EXP
;
	BCF	Y_SIGN
	BTFSC	Y_ORI_SIGN
	BSF	Y_SIGN
;
	BCF	Y_EXP_SIGN
	BTFSC	Y_ORI_EXP_SIGN
	BSF	Y_EXP_SIGN
;
	RETURN
;********************************************************************
;RELOAD_ORI_Y_2_X
RELOAD_ORI_Y_2_X
	MOVFF	Y_ORI_0,X_0
	MOVFF	Y_ORI_1,X_1
	MOVFF	Y_ORI_2,X_2
	MOVFF	Y_ORI_3,X_3
	MOVFF	Y_ORI_4,X_4
	MOVFF	Y_ORI_5,X_5
	MOVFF	Y_ORI_6,X_6
	MOVFF	Y_ORI_EXP,X_EXP
;
	BCF	X_SIGN
	BTFSC	Y_ORI_SIGN
	BSF	X_SIGN
;
	BCF	X_EXP_SIGN
	BTFSC	Y_ORI_EXP_SIGN
	BSF	X_EXP_SIGN
;
	RETURN
;********************************************************************
;SAVE_Y ; SAVE Y_y INTO Y_SAVE_y
SAVE_Y	MOVFF	Y_0,Y_SAVE_0
	MOVFF	Y_1,Y_SAVE_1
	MOVFF	Y_2,Y_SAVE_2
	MOVFF	Y_3,Y_SAVE_3
	MOVFF	Y_4,Y_SAVE_4
	MOVFF	Y_5,Y_SAVE_5
	MOVFF	Y_6,Y_SAVE_6
	MOVFF	Y_EXP,Y_SAVE_EXP
;
	BCF	Y_SAVE_SIGN
	BTFSC	Y_SIGN
	BSF	Y_SAVE_SIGN
;
	BCF	Y_SAVE_EXP_SIGN
	BTFSC	Y_EXP_SIGN
	BSF	Y_SAVE_EXP_SIGN
;
	RETURN
;********************************************************************
;RELOAD_Y ; RELOAD Y_y FROM Y_SAVE_y
RELOAD_Y	MOVFF	Y_SAVE_0,Y_0
	MOVFF	Y_SAVE_1,Y_1
	MOVFF	Y_SAVE_2,Y_2
	MOVFF	Y_SAVE_3,Y_3
	MOVFF	Y_SAVE_4,Y_4
	MOVFF	Y_SAVE_5,Y_5
	MOVFF	Y_SAVE_6,Y_6
	MOVFF	Y_SAVE_EXP,Y_EXP
;
	BCF	Y_SIGN
	BTFSC	Y_SAVE_SIGN
	BSF	Y_SIGN
;
	BCF	Y_EXP_SIGN
	BTFSC	Y_SAVE_EXP_SIGN
	BSF	Y_EXP_SIGN
;
	RETURN
;********************************************************************
;SAVE_Y_TEMP
SAVE_Y_TEMP	MOVFF	Y_0,Y_TEMP_0
	MOVFF	Y_1,Y_TEMP_1
	MOVFF	Y_2,Y_TEMP_2
	MOVFF	Y_3,Y_TEMP_3
	MOVFF	Y_4,Y_TEMP_4
	MOVFF	Y_5,Y_TEMP_5
	MOVFF	Y_6,Y_TEMP_6
	MOVFF	Y_EXP,Y_TEMP_EXP
;
	BCF	Y_TEMP_SIGN
	BTFSC	Y_SIGN
	BSF	Y_TEMP_SIGN
;
	BCF	Y_TEMP_EXP_SIGN
	BTFSC	Y_EXP_SIGN
	BSF	Y_TEMP_EXP_SIGN
;
	RETURN
;********************************************************************
;RELOAD_Y_TEMP ; RELOAD Y_y FROM Y_TEMP REGISTERS
RELOAD_Y_TEMP	MOVFF	Y_TEMP_0,Y_0
	MOVFF	Y_TEMP_1,Y_1
	MOVFF	Y_TEMP_2,Y_2
	MOVFF	Y_TEMP_3,Y_3
	MOVFF	Y_TEMP_4,Y_4
	MOVFF	Y_TEMP_5,Y_5
	MOVFF	Y_TEMP_6,Y_6
	MOVFF	Y_TEMP_EXP,Y_EXP
;
	BCF	Y_SIGN
	BTFSC	Y_TEMP_SIGN
	BSF	Y_SIGN
;
	BCF	Y_EXP_SIGN
	BTFSC	Y_TEMP_EXP_SIGN
	BSF	Y_EXP_SIGN
;
	RETURN
;********************************************************************
;SAVE_Y_TEMP0 : SAVE ONLY Y_y MANTISSA
SAVE_Y_TEMP0	MOVFF	Y_0,Y_TEMP0_0
	MOVFF	Y_1,Y_TEMP0_1
	MOVFF	Y_2,Y_TEMP0_2
	MOVFF	Y_3,Y_TEMP0_3
	MOVFF	Y_4,Y_TEMP0_4
	MOVFF	Y_5,Y_TEMP0_5
	MOVFF	Y_6,Y_TEMP0_6
;
	RETURN
;********************************************************************
;RELOAD_Y_TEMP0 ; RELOAD Y_y MANTISSA FROM Y_TEMP0_y REGISTERS
RELOAD_Y_TEMP0	MOVFF	Y_TEMP0_0,Y_0
	MOVFF	Y_TEMP0_1,Y_1
	MOVFF	Y_TEMP0_2,Y_2
	MOVFF	Y_TEMP0_3,Y_3
	MOVFF	Y_TEMP0_4,Y_4
	MOVFF	Y_TEMP0_5,Y_5
	MOVFF	Y_TEMP0_6,Y_6
;
	RETURN
;********************************************************************
;COPY_S_2_Y
COPY_S_2_Y	MOVFF	S_0,Y_0
	MOVFF	S_1,Y_1
	MOVFF	S_2,Y_2
	MOVFF	S_3,Y_3
	MOVFF	S_4,Y_4
	MOVFF	S_5,Y_5
	MOVFF	S_6,Y_6
	MOVFF	S_EXP,Y_EXP
;
	BCF	Y_SIGN
	BTFSC	S_SIGN
	BSF	Y_SIGN
;
	BCF	Y_EXP_SIGN
	BTFSC	S_EXP_SIGN
	BSF	Y_EXP_SIGN
;
	RETURN
;********************************************************************
;RELOAD_Y_EXP
RELOAD_Y_EXP	MOVFF	Y_SAVE_EXP,Y_EXP
;
	BCF	Y_EXP_SIGN
	BTFSC	Y_SAVE_EXP_SIGN
	BSF	Y_EXP_SIGN
;
	RETURN

;********************************************************************
;SAVE_Y_TEMP0_SIGN
SAVE_Y_TEMP0_SIGN BCF	Y_TEMP0_SIGN
	BTFSC	Y_SIGN
	BSF	Y_TEMP0_SIGN
;
	RETURN
;********************************************************************
;SAVE_Y_TEMP0_EXP
SAVE_Y_TEMP0_EXP MOVFF	Y_EXP,Y_TEMP0_EXP
	BCF	Y_TEMP0_EXP_SIGN
	BTFSC	Y_EXP_SIGN
	BSF	Y_TEMP0_EXP_SIGN
;
	RETURN

;********************************************************************
;RELOAD_Y_TEMP0_SIGN
RELOAD_Y_TEMP0_SIGN BCF	Y_SIGN
	BTFSC	Y_TEMP0_SIGN
	BSF	Y_SIGN
;
	RETURN
;********************************************************************
;RELOAD_Y_TEMP0_EXP
RELOAD_Y_TEMP0_EXP MOVFF	Y_TEMP0_EXP,Y_EXP
	BCF	Y_EXP_SIGN
	BTFSC	Y_TEMP0_EXP_SIGN
	BSF	Y_EXP_SIGN
;
	RETURN
;********************************************************************
;COPY_Y_2_SIN
COPY_Y_2_SIN	MOVLW	H'0F'	;CLEAR HIGH NIBBLE OF Y_6
	ANDWF	Y_6,F
;		
	BTFSC	Y_SIGN	;SET Y_6,6 ACCORDING TO Y_SIGN
	BSF	Y_6,6	
;
	BTFSC	Y_EXP_SIGN	;SET Y_6,7 ACCORDING TO Y_EXP_SIGN
	BSF	Y_6,7
;
	MOVFF	Y_0,SIN_0
	MOVFF	Y_1,SIN_1
	MOVFF	Y_2,SIN_2
	MOVFF	Y_3,SIN_3
	MOVFF	Y_4,SIN_4
	MOVFF	Y_5,SIN_5
	MOVFF	Y_6,SIN_6
	MOVFF	Y_EXP,SIN_EXP
;CLEAR HIGH NIBBLE OF Y_6, AGAIN
	MOVLW	H'0F'
	ANDWF	Y_6,F
;
	RETURN
;********************************************************************
;COPY_SIN_2_Y
COPY_SIN_2_Y	MOVFF	SIN_0,Y_0
	MOVFF	SIN_1,Y_1
	MOVFF	SIN_2,Y_2
	MOVFF	SIN_3,Y_3
	MOVFF	SIN_4,Y_4
	MOVFF	SIN_5,Y_5
	MOVFF	SIN_6,Y_6	;
	MOVFF	SIN_EXP,Y_EXP
;Y_6 HIGH NIBBLE CONTAINS THE SIGNS!
	BCF	Y_SIGN
	BTFSC	Y_6,6
	BSF	Y_SIGN
;
	BCF	Y_EXP_SIGN
	BTFSC	Y_6,7
	BSF	Y_EXP_SIGN
;CLEAR HIGH NIBBLE OF Y_6
	MOVLW	H'0F'
	ANDWF	Y_6,F
;
	RETURN
;********************************************************************
;COPY_SIN_NEW_2_Y
COPY_SIN_NEW_2_Y
	MOVFF	SIN_NEW_0,Y_0
	MOVFF	SIN_NEW_1,Y_1
	MOVFF	SIN_NEW_2,Y_2
	MOVFF	SIN_NEW_3,Y_3
	MOVFF	SIN_NEW_4,Y_4
	MOVFF	SIN_NEW_5,Y_5
	MOVFF	SIN_NEW_6,Y_6	;
	MOVFF	SIN_NEW_EXP,Y_EXP
;Y_6 HIGH NIBBLE CONTAINS THE SIGNS!
	BCF	Y_SIGN
	BTFSC	Y_6,6
	BSF	Y_SIGN
;
	BCF	Y_EXP_SIGN
	BTFSC	Y_6,7
	BSF	Y_EXP_SIGN
;CLEAR HIGH NIBBLE OF Y_6
	MOVLW	H'0F'
	ANDWF	Y_6,F
;
	RETURN
;********************************************************************
;COPY_COS_2_Y
COPY_COS_2_Y	MOVFF	COS_0,Y_0
	MOVFF	COS_1,Y_1
	MOVFF	COS_2,Y_2
	MOVFF	COS_3,Y_3
	MOVFF	COS_4,Y_4
	MOVFF	COS_5,Y_5
	MOVFF	COS_6,Y_6
	MOVFF	COS_EXP,Y_EXP
;Y_6 HIGH NIBBLE CONTAINS THE SIGNS!
	BCF	Y_SIGN
	BTFSC	Y_6,6
	BSF	Y_SIGN
;
	BCF	Y_EXP_SIGN
	BTFSC	Y_6,7
	BSF	Y_EXP_SIGN
;CLEAR HIGH NIBBLE OF Y_6
	MOVLW	H'0F'
	ANDWF	Y_6,F
;
	RETURN
;********************************************************************
;COPY_SUM_ANGLE_2_Y
COPY_SUM_ANGLE_2_Y
	MOVFF	SUM_ANGLE_0,Y_0
	MOVFF	SUM_ANGLE_1,Y_1
	MOVFF	SUM_ANGLE_2,Y_2
	MOVFF	SUM_ANGLE_3,Y_3
	MOVFF	SUM_ANGLE_4,Y_4
	MOVFF	SUM_ANGLE_5,Y_5
	MOVFF	SUM_ANGLE_6,Y_6
	MOVFF	SUM_ANGLE_EXP,Y_EXP
;Y_6 HIGH NIBBLE CONTAINS THE SIGNS!
	BCF	Y_SIGN
	BTFSC	Y_6,6
	BSF	Y_SIGN
;
	BCF	Y_EXP_SIGN
	BTFSC	Y_6,7
	BSF	Y_EXP_SIGN
;CLEAR HIGH NIBBLE OF Y_6
	MOVLW	H'0F'
	ANDWF	Y_6,F
;
	RETURN
;********************************************************************
;LOAD_2_AD_MINUS_n_2_Y
LOAD_2_AD_MINUS_n_2_Y
	MOVLF	UPPER TBL_2_AD_MINUS_n,TBLPTRU
	MOVLF	HIGH TBL_2_AD_MINUS_n,TBLPTRH
	MOVFF	LOOP_NUM,TBLPTRL
;LOOP_NUM -> TBLPTRL -> MULTIPLY BY 8
	BCF	C
	RLCF	TBLPTRL,F
	RLCF	TBLPTRL,F
	RLCF	TBLPTRL,F
;
	BTFSC	C
	INCF	TBLPTRH,F
;
	TBLRD*+
	MOVFF	TABLAT,Y_0
	TBLRD*+
	MOVFF	TABLAT,Y_1	
	TBLRD*+
	MOVFF	TABLAT,Y_2
	TBLRD*+
	MOVFF	TABLAT,Y_3
	TBLRD*+
	MOVFF	TABLAT,Y_4
	TBLRD*+
	MOVFF	TABLAT,Y_5
	TBLRD*+
	MOVFF	TABLAT,TEMP
	TBLRD*
	MOVFF	TABLAT,Y_EXP
;
	MOVF	TEMP,W
	ANDLW	H'0F'
	MOVWF	Y_6
;
	BCF	Y_SIGN
	BTFSC	TEMP,6
	BSF	Y_SIGN
;
	BCF	Y_EXP_SIGN
	BTFSC	TEMP,7
	BSF	Y_EXP_SIGN
;
	BCF	Y_SIGN	;?????
;
	RETURN
;********************************************************************
;COPY_ANGLE_2_Y
COPY_ANGLE_2_Y	MOVFF	SIN_NEW_0,Y_0
	MOVFF	SIN_NEW_1,Y_1
	MOVFF	SIN_NEW_2,Y_2
	MOVFF	SIN_NEW_3,Y_3
	MOVFF	SIN_NEW_4,Y_4
	MOVFF	SIN_NEW_5,Y_5
	MOVFF	SIN_NEW_6,Y_6
	MOVFF	SIN_NEW_EXP,Y_EXP
;Y_6 HIGH NIBBLE CONTAINS THE SIGNS!
	BCF	Y_SIGN
	BTFSC	Y_6,6
	BSF	Y_SIGN
;
	BCF	Y_EXP_SIGN
	BTFSC	Y_6,7
	BSF	Y_EXP_SIGN
;CLEAR HIGH NIBBLE OF Y_6
	MOVLW	H'0F'
	ANDWF	Y_6,F
;
	RETURN
;********************************************************************
;COPY_ARCTAN_2_Y
COPY_ARCTAN_2_Y	MOVFF	ARCTAN_0,Y_0
	MOVFF	ARCTAN_1,Y_1
	MOVFF	ARCTAN_2,Y_2
	MOVFF	ARCTAN_3,Y_3
	MOVFF	ARCTAN_4,Y_4
	MOVFF	ARCTAN_5,Y_5
	MOVFF	ARCTAN_6,Y_6
	MOVFF	ARCTAN_EXP,Y_EXP
;Y_6 HIGH NIBBLE CONTAINS THE SIGNS!
	BCF	Y_SIGN
	BTFSC	Y_6,6
	BSF	Y_SIGN
;
	BCF	Y_EXP_SIGN
	BTFSC	Y_6,7
	BSF	Y_EXP_SIGN
;CLEAR HIGH NIBBLE OF Y_6
	MOVLW	H'0F'
	ANDWF	Y_6,F
;
	RETURN
;********************************************************************
;
;SUBROUTINES ASSOCIATED TO Z-REGISTER
;
;********************************************************************
;CLEAR_Z
CLEAR_Z	CLRF	Z_0
	CLRF	Z_1
	CLRF	Z_2
	CLRF	Z_3
	CLRF	Z_4
	CLRF	Z_5
	CLRF	Z_6
	CLRF	Z_EXP
;
	BCF	Z_SIGN
	BCF	Z_EXP_SIGN
;
	RETURN
;********************************************************************
;COPY_Z_2_T
COPY_Z_2_T	MOVFF	Z_0,T_0
	MOVFF	Z_1,T_1
	MOVFF	Z_2,T_2
	MOVFF	Z_3,T_3
	MOVFF	Z_4,T_4
	MOVFF	Z_5,T_5
	MOVFF	Z_6,T_6
	MOVFF	Z_EXP,T_EXP
;
	BCF	T_SIGN
	BTFSC	Z_SIGN
	BSF	T_SIGN
;
	BCF	T_EXP_SIGN
	BTFSC	Z_EXP_SIGN
	BSF	T_EXP_SIGN
;
	RETURN
;********************************************************************
;COPY_T_2_Z
COPY_T_2_Z	MOVFF	T_0,Z_0
	MOVFF	T_1,Z_1
	MOVFF	T_2,Z_2
	MOVFF	T_3,Z_3
	MOVFF	T_4,Z_4
	MOVFF	T_5,Z_5
	MOVFF	T_6,Z_6
	MOVFF	T_EXP,Z_EXP
;
	BCF	Z_SIGN
	BTFSC	T_SIGN
	BSF	Z_SIGN
;
	BCF	Z_EXP_SIGN
	BTFSC	T_EXP_SIGN
	BSF	Z_EXP_SIGN
;
	RETURN
;********************************************************************
;SAVE_ORI_Z ; SAVE Z_z IN Z_ORI_z
SAVE_ORI_Z	MOVFF	Z_0,Z_ORI_0
	MOVFF	Z_1,Z_ORI_1
	MOVFF	Z_2,Z_ORI_2
	MOVFF	Z_3,Z_ORI_3
	MOVFF	Z_4,Z_ORI_4
	MOVFF	Z_5,Z_ORI_5
	MOVFF	Z_6,Z_ORI_6
	MOVFF	Z_EXP,Z_ORI_EXP
;
	BCF	Z_ORI_SIGN
	BTFSC	Z_SIGN
	BSF	Y_ORI_SIGN
;
	BCF	Z_ORI_EXP_SIGN
	BTFSC	Z_EXP_SIGN
	BSF	Z_ORI_EXP_SIGN
;
	RETURN
;********************************************************************
;RELOAD_ORI_Z
RELOAD_ORI_Z	MOVFF	Z_ORI_0,Z_0
	MOVFF	Z_ORI_1,Z_1
	MOVFF	Z_ORI_2,Z_2
	MOVFF	Z_ORI_3,Z_3
	MOVFF	Z_ORI_4,Z_4
	MOVFF	Z_ORI_5,Z_5
	MOVFF	Z_ORI_6,Z_6
	MOVFF	Z_ORI_EXP,Z_EXP
;
	BCF	Z_SIGN
	BTFSC	Z_ORI_SIGN
	BSF	Z_SIGN
;
	BCF	Z_EXP_SIGN
	BTFSC	Z_ORI_EXP_SIGN
	BSF	Z_EXP_SIGN
;
	RETURN
;********************************************************************
;
;SUBROUTINES ASSOCIATED TO T-REGISTER
;
;********************************************************************
;CLEAR_T
CLEAR_T	CLRF	T_0
	CLRF	T_1
	CLRF	T_2
	CLRF	T_3
	CLRF	T_4
	CLRF	T_5
	CLRF	T_6
	CLRF	T_EXP
;
	BCF	T_SIGN
	BCF	T_EXP_SIGN
;
	RETURN

;********************************************************************
;	SHIFT ROUTINES
;********************************************************************
;SHIFT_X_RN
;********************************************************************
;SHIFT_X_R_N : SHIFT Y-MANTISSA RIGHT ACCORDING TO THE NUMBER IN EXP_SHIFT_REG
SHIFT_X_R_N	MOVF	EXP_SHIFT_REG,F	;ZERO CHECKING
	BTFSC	Z	;SKIP IF EXP_SHIFT_REG =/= 0
	RETURN		;NOTHING TO DO
;
	MOVLW	D'1'
	XORWF	EXP_SHIFT_REG,W
	BZ	SHIFT_X_R1
;
	MOVLW	D'2'
	XORWF	EXP_SHIFT_REG,W
	BZ	SHIFT_X_R2
;
	MOVLW	D'3'
	XORWF	EXP_SHIFT_REG,W
	BZ	SHIFT_X_R3
;
	MOVLW	D'4'
	XORWF	EXP_SHIFT_REG,W
	BZ	SHIFT_X_R4
;
	MOVLW	D'5'
	XORWF	EXP_SHIFT_REG,W
	BZ	SHIFT_X_R5
;
	MOVLW	D'6'
	XORWF	EXP_SHIFT_REG,W
	BZ	SHIFT_X_R6
;
	MOVLW	D'7'
	XORWF	EXP_SHIFT_REG,W
	BZ	SHIFT_X_R7
;
	MOVLW	D'8'
	XORWF	EXP_SHIFT_REG,W
	BZ	SHIFT_X_R8
;
	MOVLW	D'9'
	XORWF	EXP_SHIFT_REG,W
	BZ	SHIFT_X_R9
;
	MOVLW	D'10'
	XORWF	EXP_SHIFT_REG,W
	BZ	SHIFT_X_R10
;
	MOVLW	D'11'
	XORWF	EXP_SHIFT_REG,W
	BZ	SHIFT_X_R11
;
	MOVLW	D'12'
	XORWF	EXP_SHIFT_REG,W
	BZ	SHIFT_X_R12
;
	MOVLW	D'13'
	XORWF	EXP_SHIFT_REG,W
	BTFSC	Z
	GOTO	SHIFT_X_R13
;
	GOTO	SHIFT_X_R14_99
;********************************************************************
;SHIFT_X_R1 : SHIFT X_x RIGHT *1 -> DIVIDE X-MANTISSA BY 10
SHIFT_X_R1	BCF	C
	RRCF	X_6,F
	RRCF	X_5,F
	RRCF	X_4,F
	RRCF	X_3,F
	RRCF	X_2,F
	RRCF	X_1,F
	RRCF	X_0,F
;
	BCF	C
	RRCF	X_6,F
	RRCF	X_5,F
	RRCF	X_4,F
	RRCF	X_3,F
	RRCF	X_2,F
	RRCF	X_1,F
	RRCF	X_0,F
;
	BCF	C
	RRCF	X_6,F
	RRCF	X_5,F
	RRCF	X_4,F
	RRCF	X_3,F
	RRCF	X_2,F
	RRCF	X_1,F
	RRCF	X_0,F
;
	BCF	C
	RRCF	X_6,F
	RRCF	X_5,F
	RRCF	X_4,F
	RRCF	X_3,F
	RRCF	X_2,F
	RRCF	X_1,F
	RRCF	X_0,F
;
	RETURN
;********************************************************************
;SHIFT_X_R2 : SHIFT X_x RIGHT *2 -> DIVIDE X-MANTISSA BY 100
;NOTE : X_0 LOST & X_6 CLEARED
SHIFT_X_R2	MOVFF	X_1,X_0
	MOVFF	X_2,X_1
	MOVFF	X_3,X_2
	MOVFF	X_4,X_3
	MOVFF	X_5,X_4
	MOVFF	X_6,X_5
	CLRF	X_6
;
	RETURN
;********************************************************************
;SHIFT_X_R3 : SHIFT X_x RIGHT *3 -> DIVIDE X-MANTISSA BY 1.000
SHIFT_X_R3	CALL	SHIFT_X_R1
	CALL	SHIFT_X_R2
;
	RETURN
;********************************************************************
;SHIFT_X_R4 : SHIFT X_x RIGHT *4 -> DIVIDE X-MANTISSA BY 10.000
SHIFT_X_R4	MOVFF	X_2,X_0
	MOVFF	X_3,X_1
	MOVFF	X_4,X_2
	MOVFF	X_5,X_3
	MOVFF	X_6,X_4
	CLRF	X_5
	CLRF	X_6
;
	RETURN
;********************************************************************
;SHIFT_X_R5 : SHIFT X_x RIGHT *5 -> DIVIDE X-MANTISSA BY 100.000
SHIFT_X_R5	CALL	SHIFT_X_R1
	CALL	SHIFT_X_R4
;
	RETURN
;********************************************************************
;SHIFT_X_R6 : SHIFT X_x RIGHT *6 -> DIVIDE X-MANTISSA BY 1.000.000
SHIFT_X_R6	MOVFF	X_3,X_0
	MOVFF	X_4,X_1
	MOVFF	X_5,X_2
	MOVFF	X_6,X_3
	CLRF	X_4
	CLRF	X_5
	CLRF	X_6
;
	RETURN
;********************************************************************
;SHIFT_X_R7 : SHIFT X_x RIGHT *7 -> DIVIDE X-MANTISSA BY 10.000.000
SHIFT_X_R7	CALL	SHIFT_X_R1
	CALL	SHIFT_X_R6
;
	RETURN
;********************************************************************
;SHIFT_X_R8 : SHIFT X_x RIGHT *8 -> DIVIDE X-MANTISSA BY 100.000.000
SHIFT_X_R8	MOVFF	X_4,X_0
	MOVFF	X_5,X_1
	MOVFF	X_6,X_2
	CLRF	X_3
	CLRF	X_4
	CLRF	X_5
	CLRF	X_6
;
	RETURN
;********************************************************************
;SHIFT_X_R9 : SHIFT X_x RIGHT *9 -> DIVIDE X-MANTISSA BY 1.000.000.000
SHIFT_X_R9	CALL	SHIFT_X_R1
	CALL	SHIFT_X_R8
;
	RETURN
;********************************************************************
;SHIFT_X_R10 : SHIFT X_x RIGHT *10 -> DIVIDE X-MANTISSA BY 10.000.000.000
SHIFT_X_R10	MOVFF	X_5,X_0
	MOVFF	X_6,X_1
	CLRF	X_2
	CLRF	X_3
	CLRF	X_4
	CLRF	X_5
	CLRF	X_6
;
	RETURN
;********************************************************************
;SHIFT_X_R11 : SHIFT X_x RIGHT *11 -> DIVIDE X-MANTISSA BY 100.000.000.000
SHIFT_X_R11	CALL	SHIFT_X_R1
	CALL	SHIFT_X_R10
;
	RETURN
;********************************************************************
;SHIFT_X_R12 : SHIFT X_x RIGHT *12 -> DIVIDE X-MANTISSA BY 1.000.000.000.000
SHIFT_X_R12	MOVFF	X_6,X_0
	CLRF	X_1
	CLRF	X_2
	CLRF	X_3
	CLRF	X_4
	CLRF	X_5
	CLRF	X_6
;
	RETURN
;********************************************************************
;SHIFT_X_R13 : SHIFT X_x RIGHT *13 -> DIVIDE X-MANTISSA BY 10.000.000.000.000
SHIFT_X_R13	CALL	SHIFT_X_R1
	CALL	SHIFT_X_R12
;
	RETURN
;********************************************************************
;SHIFT_X_R14_99 : X_x REGISTERS ARE CLEARED !!!!
SHIFT_X_R14_99	CLRF	X_0
	CLRF	X_1
	CLRF	X_2
	CLRF	X_3
	CLRF	X_4
	CLRF	X_5
	CLRF	X_6
;
	RETURN
;********************************************************************
;SHIFT_Y_RN
;********************************************************************
;SHIFT_Y_R_N : SHIFT Y-MANTISSA RIGHT ACCORDING TO THE NUMBER IN EXP_SHIFT_REG
SHIFT_Y_R_N	MOVF	EXP_SHIFT_REG,F	;ZERO CHECKING
	BTFSC	Z	;SKIP IF EXP_SHIFT_REG =/= 0
	RETURN		;NOTHING TO DO
;
	MOVLW	D'1'
	XORWF	EXP_SHIFT_REG,W
	BZ	SHIFT_Y_R1
;
	MOVLW	D'2'
	XORWF	EXP_SHIFT_REG,W
	BZ	SHIFT_Y_R2
;
	MOVLW	D'3'
	XORWF	EXP_SHIFT_REG,W
	BZ	SHIFT_Y_R3
;
	MOVLW	D'4'
	XORWF	EXP_SHIFT_REG,W
	BZ	SHIFT_Y_R4
;
	MOVLW	D'5'
	XORWF	EXP_SHIFT_REG,W
	BZ	SHIFT_Y_R5
;
	MOVLW	D'6'
	XORWF	EXP_SHIFT_REG,W
	BZ	SHIFT_Y_R6
;
	MOVLW	D'7'
	XORWF	EXP_SHIFT_REG,W
	BZ	SHIFT_Y_R7
;
	MOVLW	D'8'
	XORWF	EXP_SHIFT_REG,W
	BZ	SHIFT_Y_R8
;
	MOVLW	D'9'
	XORWF	EXP_SHIFT_REG,W
	BZ	SHIFT_Y_R9
;
	MOVLW	D'10'
	XORWF	EXP_SHIFT_REG,W
	BZ	SHIFT_Y_R10
;
	MOVLW	D'11'
	XORWF	EXP_SHIFT_REG,W
	BZ	SHIFT_Y_R11
;
	MOVLW	D'12'
	XORWF	EXP_SHIFT_REG,W
	BZ	SHIFT_Y_R12
;
	MOVLW	D'13'
	XORWF	EXP_SHIFT_REG,W
	BTFSC	Z
	GOTO	SHIFT_Y_R13
;
	GOTO	SHIFT_Y_R14_99
;********************************************************************
;SHIFT_Y_R1 : SHIFT Y_y RIGHT *1 -> DIVIDE Y-MANTISSA BY 10
SHIFT_Y_R1	BCF	C
	RRCF	Y_6,F
	RRCF	Y_5,F
	RRCF	Y_4,F
	RRCF	Y_3,F
	RRCF	Y_2,F
	RRCF	Y_1,F
	RRCF	Y_0,F
;
	BCF	C
	RRCF	Y_6,F
	RRCF	Y_5,F
	RRCF	Y_4,F
	RRCF	Y_3,F
	RRCF	Y_2,F
	RRCF	Y_1,F
	RRCF	Y_0,F
;
	BCF	C
	RRCF	Y_6,F
	RRCF	Y_5,F
	RRCF	Y_4,F
	RRCF	Y_3,F
	RRCF	Y_2,F
	RRCF	Y_1,F
	RRCF	Y_0,F
;
	BCF	C
	RRCF	Y_6,F
	RRCF	Y_5,F
	RRCF	Y_4,F
	RRCF	Y_3,F
	RRCF	Y_2,F
	RRCF	Y_1,F
	RRCF	Y_0,F
;
	RETURN
;********************************************************************
;SHIFT_Y_R2 : SHIFT Y_y RIGHT *2 -> DIVIDE Y-MANTISSA BY 100
;NOTE : Y_0 LOST & Y_6 CLEARED
SHIFT_Y_R2	MOVFF	Y_1,Y_0
	MOVFF	Y_2,Y_1
	MOVFF	Y_3,Y_2
	MOVFF	Y_4,Y_3
	MOVFF	Y_5,Y_4
	MOVFF	Y_6,Y_5
	CLRF	Y_6
;
	RETURN
;********************************************************************
;SHIFT_Y_R3 : SHIFT Y_y RIGHT *3 -> DIVIDE Y-MANTISSA BY 1.000
SHIFT_Y_R3	CALL	SHIFT_Y_R1
	CALL	SHIFT_Y_R2
;
	RETURN
;********************************************************************
;SHIFT_Y_R4 : SHIFT Y_y RIGHT *4 -> DIVIDE Y-MANTISSA BY 10.000
SHIFT_Y_R4	MOVFF	Y_2,Y_0
	MOVFF	Y_3,Y_1
	MOVFF	Y_4,Y_2
	MOVFF	Y_5,Y_3
	MOVFF	Y_6,Y_4
	CLRF	Y_5
	CLRF	Y_6
;
	RETURN
;********************************************************************
;SHIFT_Y_R5 : SHIFT Y_y RIGHT *5 -> DIVIDE Y-MANTISSA BY 100.000
SHIFT_Y_R5	CALL	SHIFT_Y_R1
	CALL	SHIFT_Y_R4
;
	RETURN
;********************************************************************
;SHIFT_Y_R6 : SHIFT Y_y RIGHT *6 -> DIVIDE Y-MANTISSA BY 1.000.000
SHIFT_Y_R6	MOVFF	Y_3,Y_0
	MOVFF	Y_4,Y_1
	MOVFF	Y_5,Y_2
	MOVFF	Y_6,Y_3
	CLRF	Y_4
	CLRF	Y_5
	CLRF	Y_6
;
	RETURN
;********************************************************************
;SHIFT_Y_R7 : SHIFT Y_y RIGHT *7 -> DIVIDE Y-MANTISSA BY 10.000.000
SHIFT_Y_R7	CALL	SHIFT_Y_R1
	CALL	SHIFT_Y_R6
;
	RETURN
;********************************************************************
;SHIFT_Y_R8 : SHIFT Y_y RIGHT *8 -> DIVIDE Y-MANTISSA BY 100.000.000
SHIFT_Y_R8	MOVFF	Y_4,Y_0
	MOVFF	Y_5,Y_1
	MOVFF	Y_6,Y_2
	CLRF	Y_3
	CLRF	Y_4
	CLRF	Y_5
	CLRF	Y_6
;
	RETURN
;********************************************************************
;SHIFT_Y_R9 : SHIFT Y_y RIGHT *9 -> DIVIDE Y-MANTISSA BY 1.000.000.000
SHIFT_Y_R9	CALL	SHIFT_Y_R1
	CALL	SHIFT_Y_R8
;
	RETURN
;********************************************************************
;SHIFT_Y_R10 : SHIFT Y_y RIGHT *10 -> DIVIDE Y-MANTISSA BY 10.000.000.000
SHIFT_Y_R10	MOVFF	Y_5,Y_0
	MOVFF	Y_6,Y_1
	CLRF	Y_2
	CLRF	Y_3
	CLRF	Y_4
	CLRF	Y_5
	CLRF	Y_6
;
	RETURN
;********************************************************************
;SHIFT_Y_R11 : SHIFT Y_y RIGHT *11 -> DIVIDE Y-MANTISSA BY 100.000.000.000
SHIFT_Y_R11	CALL	SHIFT_Y_R1
	CALL	SHIFT_Y_R10
;
	RETURN
;********************************************************************
;SHIFT_Y_R12 : SHIFT Y_y RIGHT *12 -> DIVIDE Y-MANTISSA BY 1.000.000.000.000
SHIFT_Y_R12	MOVFF	Y_6,Y_0
	CLRF	Y_1
	CLRF	Y_2
	CLRF	Y_3
	CLRF	Y_4
	CLRF	Y_5
	CLRF	Y_6
;
	RETURN
;********************************************************************
;SHIFT_Y_R13 : SHIFT Y_y RIGHT *13 -> DIVIDE Y-MANTISSA BY 10.000.000.000.000
SHIFT_Y_R13	CALL	SHIFT_Y_R1
	CALL	SHIFT_Y_R12
;
	RETURN
;********************************************************************
;SHIFT_Y_R14_99 : Y_y REGISTERS ARE CLEARED !!!!
SHIFT_Y_R14_99	CLRF	Y_0
	CLRF	Y_1
	CLRF	Y_2
	CLRF	Y_3
	CLRF	Y_4
	CLRF	Y_5
	CLRF	Y_6
;
	RETURN
;********************************************************************
;SHIFT_X_L1
SHIFT_X_L1	BCF	C
	RLCF	X_0,F
	RLCF	X_1,F
	RLCF	X_2,F
	RLCF	X_3,F
	RLCF	X_4,F
	RLCF	X_5,F
	RLCF	X_6,F
;
	BCF	C
	RLCF	X_0,F
	RLCF	X_1,F
	RLCF	X_2,F
	RLCF	X_3,F
	RLCF	X_4,F
	RLCF	X_5,F
	RLCF	X_6,F
;
	BCF	C
	RLCF	X_0,F
	RLCF	X_1,F
	RLCF	X_2,F
	RLCF	X_3,F
	RLCF	X_4,F
	RLCF	X_5,F
	RLCF	X_6,F
;
	BCF	C
	RLCF	X_0,F
	RLCF	X_1,F
	RLCF	X_2,F
	RLCF	X_3,F
	RLCF	X_4,F
	RLCF	X_5,F
	RLCF	X_6,F
;
	RETURN
;********************************************************************
;
;OTHER SIMPLE ROUTINES
;
;********************************************************************
;CLEAR_P
CLEAR_P	CLRF	P_0
	CLRF	P_1
	CLRF	P_2
	CLRF	P_3
	CLRF	P_4
	CLRF	P_5
	CLRF	P_6
	CLRF	P_7
	CLRF	P_8
	CLRF	P_9
	CLRF	P_A
	CLRF	P_B
	CLRF	P_C
	CLRF	P_D
;
	BCF	P_SIGN
;
	RETURN
;********************************************************************
;CLEAR_Q
CLEAR_Q	CLRF	Q_0
	CLRF	Q_1
	CLRF	Q_2
	CLRF	Q_3
	CLRF	Q_4
	CLRF	Q_5
	CLRF	Q_6
;
	BCF	Q_SIGN
;
	RETURN
;*************************************************************
;CLEAR_R
CLEAR_R	CLRF	R_0
	CLRF	R_1
	CLRF	R_2
	CLRF	R_3
	CLRF	R_4
	CLRF	R_5
	CLRF	R_6
	CLRF	R_7
	CLRF	R_8
	CLRF	R_9
	CLRF	R_A
	CLRF	R_B
	CLRF	R_C
	CLRF	R_D
;
	BCF	R_SIGN
;
	RETURN
;********************************************************************
;CLEAR_S
CLEAR_S	CLRF	S_0
	CLRF	S_1
	CLRF	S_2
	CLRF	S_3
	CLRF	S_4
	CLRF	S_5
	CLRF	S_6
	CLRF	S_EXP
;
	BCF	S_SIGN
	BCF	S_EXP_SIGN
;
	RETURN
;********************************************************************
;CLEAR_SIN
CLEAR_SIN	MOVLW	H'00'
	MOVFF	WREG,SIN_0
	MOVFF	WREG,SIN_1
	MOVFF	WREG,SIN_2
	MOVFF	WREG,SIN_3
	MOVFF	WREG,SIN_4
	MOVFF	WREG,SIN_5
	MOVFF	WREG,SIN_6
	MOVFF	WREG,SIN_EXP
;
	RETURN
;********************************************************************
;CLEAR_SIN_NEW
CLEAR_SIN_NEW	MOVLW	H'00'
	MOVFF	WREG,SIN_NEW_0
	MOVFF	WREG,SIN_NEW_1
	MOVFF	WREG,SIN_NEW_2
	MOVFF	WREG,SIN_NEW_3
	MOVFF	WREG,SIN_NEW_4
	MOVFF	WREG,SIN_NEW_5
	MOVFF	WREG,SIN_NEW_6
	MOVFF	WREG,SIN_NEW_EXP
;
	RETURN
;********************************************************************
;CLEAR_COS
CLEAR_COS	MOVLW	H'00'
	MOVFF	WREG,COS_0
	MOVFF	WREG,COS_1
	MOVFF	WREG,COS_2
	MOVFF	WREG,COS_3
	MOVFF	WREG,COS_4
	MOVFF	WREG,COS_5
	MOVFF	WREG,COS_6
	MOVFF	WREG,COS_EXP
;
	RETURN
;********************************************************************
;CLEAR_COS_NEW
CLEAR_COS_NEW	MOVLW	H'00'
	MOVFF	WREG,COS_NEW_0
	MOVFF	WREG,COS_NEW_1
	MOVFF	WREG,COS_NEW_2
	MOVFF	WREG,COS_NEW_3
	MOVFF	WREG,COS_NEW_4
	MOVFF	WREG,COS_NEW_5
	MOVFF	WREG,COS_NEW_6
	MOVFF	WREG,COS_NEW_EXP
;
	RETURN
;********************************************************************
;CLEAR_TAN
CLEAR_TAN	MOVLW	H'00'
	MOVFF	WREG,TAN_0
	MOVFF	WREG,TAN_1
	MOVFF	WREG,TAN_2
	MOVFF	WREG,TAN_3
	MOVFF	WREG,TAN_4
	MOVFF	WREG,TAN_5
	MOVFF	WREG,TAN_6
	MOVFF	WREG,TAN_EXP
;
	RETURN
;********************************************************************
;SET_TAN
SET_TAN	MOVLW	H'99'
	MOVFF	WREG,TAN_0
	MOVFF	WREG,TAN_1
	MOVFF	WREG,TAN_2
	MOVFF	WREG,TAN_3
	MOVFF	WREG,TAN_4
	MOVFF	WREG,TAN_5
	MOVFF	WREG,TAN_EXP
;
	MOVLW	H'09'
	MOVFF	WREG,TAN_6
;
	BSF	OVFL_BIT
;
	RETURN
;********************************************************************
;CLEAR_ARCTAN
CLEAR_ARCTAN	MOVLW	H'00'
	MOVFF	WREG,ARCTAN_0
	MOVFF	WREG,ARCTAN_1
	MOVFF	WREG,ARCTAN_2
	MOVFF	WREG,ARCTAN_3
	MOVFF	WREG,ARCTAN_4
	MOVFF	WREG,ARCTAN_5
	MOVFF	WREG,ARCTAN_6
	MOVFF	WREG,ARCTAN_EXP
;
	RETURN
;********************************************************************
;COPY_SIN_NEW_2_SIN
COPY_SIN_NEW_2_SIN
	MOVFF	SIN_NEW_0,SIN_0
	MOVFF	SIN_NEW_1,SIN_1
	MOVFF	SIN_NEW_2,SIN_2
	MOVFF	SIN_NEW_3,SIN_3
	MOVFF	SIN_NEW_4,SIN_4
	MOVFF	SIN_NEW_5,SIN_5
	MOVFF	SIN_NEW_6,SIN_6
	MOVFF	SIN_NEW_EXP,SIN_EXP
;
	RETURN

;********************************************************************
;COPY_COS_NEW_2_COS
COPY_COS_NEW_2_COS
	MOVFF	COS_NEW_0,COS_0
	MOVFF	COS_NEW_1,COS_1
	MOVFF	COS_NEW_2,COS_2
	MOVFF	COS_NEW_3,COS_3
	MOVFF	COS_NEW_4,COS_4
	MOVFF	COS_NEW_5,COS_5
	MOVFF	COS_NEW_6,COS_6
	MOVFF	COS_NEW_EXP,COS_EXP
;
	RETURN
;********************************************************************
;LOAD_ANGLE_STEP
;LOOP_NUM SHOULD BE DEFINED PRIOR TO CALLING THIS ROUTINE
LOAD_ANGLE_STEP	MOVLF	UPPER TBL_ARCTAN,TBLPTRU
	MOVLF	HIGH TBL_ARCTAN,TBLPTRH
	MOVFF	LOOP_NUM,TBLPTRL
;LOOP_NUM -> TBLPTRL -> MULTIPLY BY 8
	BCF	C
	RLCF	TBLPTRL,F
	RLCF	TBLPTRL,F
	RLCF	TBLPTRL,F
;
	BTFSC	C
	INCF	TBLPTRH,F
;
	TBLRD*+
	MOVFF	TABLAT,ANGLE_0
	TBLRD*+
	MOVFF	TABLAT,ANGLE_1	
	TBLRD*+
	MOVFF	TABLAT,ANGLE_2
	TBLRD*+
	MOVFF	TABLAT,ANGLE_3
	TBLRD*+
	MOVFF	TABLAT,ANGLE_4
	TBLRD*+
	MOVFF	TABLAT,ANGLE_5
	TBLRD*+
	MOVFF	TABLAT,ANGLE_6
	TBLRD*
	MOVFF	TABLAT,ANGLE_EXP
;
	RETURN
;********************************************************************
;	LOAD CONSTANS
;********************************************************************
;LOAD_C_2_X
LOAD_C_2_X	TBLRD*+
	MOVFF	TABLAT,X_0
	TBLRD*+
	MOVFF	TABLAT,X_1
	TBLRD*+
	MOVFF	TABLAT,X_2
	TBLRD*+
	MOVFF	TABLAT,X_3
	TBLRD*+
	MOVFF	TABLAT,X_4
	TBLRD*+
	MOVFF	TABLAT,X_5
	TBLRD*+
	MOVFF	TABLAT,TEMP
	TBLRD*
	MOVFF	TABLAT,X_EXP
;
	MOVF	TEMP,W
	ANDLW	H'0F'
	MOVWF	X_6
;
	BCF	X_SIGN
	BTFSC	TEMP,6
	BSF	X_SIGN
;
	BCF	X_EXP_SIGN
	BTFSC	TEMP,7
	BSF	X_EXP_SIGN
;
	RETURN
;********************************************************************
;LOAD_C_2_Y
LOAD_C_2_Y	TBLRD*+
	MOVFF	TABLAT,Y_0
	TBLRD*+
	MOVFF	TABLAT,Y_1
	TBLRD*+
	MOVFF	TABLAT,Y_2
	TBLRD*+
	MOVFF	TABLAT,Y_3
	TBLRD*+
	MOVFF	TABLAT,Y_4
	TBLRD*+
	MOVFF	TABLAT,Y_5
	TBLRD*+
	MOVFF	TABLAT,TEMP
	TBLRD*
	MOVFF	TABLAT,Y_EXP
;
	MOVF	TEMP,W
	ANDLW	H'0F'
	MOVWF	Y_6
;
	BCF	Y_SIGN
	BTFSC	TEMP,6
	BSF	Y_SIGN
;
	BCF	Y_EXP_SIGN
	BTFSC	TEMP,7
	BSF	Y_EXP_SIGN
;
	RETURN
;********************************************************************
;LOAD_FACTORIAL_2_X : LOAD FACTORIAL OF THE NUMBER IN W-REGISTER 
;INTO X-REGISTER
;W REGISTER CONTAINS A STACKED BCD NUMBER "n", WHERE n = 0....69
LOAD_FACTORIAL_2_X
	MOVWF	TEMP
	MOVLF	UPPER TBL_FACTORIAL,TBLPTRU
	MOVLF	HIGH TBL_FACTORIAL,TBLPTRH
	MOVF	TEMP,W
	CALL	BCD2_2_BIN8
	MOVWF	TBLPTRL
;ADDRESS SHOULD BE MULTIPLIED BY D'8' -> 8 Bytes = 1 NUMBER
	BCF	C
	RLCF	TBLPTRL,F
	BTFSC	C
	INCF	TBLPTRH,F
	BCF	C
	RLCF	TBLPTRL,F
	BTFSC	C
	INCF	TBLPTRH,F
	BCF	C
	RLCF	TBLPTRL,F
	BTFSC	C
	INCF	TBLPTRH,F
;
	TBLRD*+
	MOVFF	TABLAT,X_0
	TBLRD*+
	MOVFF	TABLAT,X_1
	TBLRD*+
	MOVFF	TABLAT,X_2
	TBLRD*+
	MOVFF	TABLAT,X_3
	TBLRD*+
	MOVFF	TABLAT,X_4
	TBLRD*+
	MOVFF	TABLAT,X_5
	TBLRD*+
	MOVFF	TABLAT,WREG
	ANDLW	H'0F'
	MOVWF	X_6
;
	TBLRD*
	MOVFF	TABLAT,X_EXP
;
	RETURN
;********************************************************************
;LOAD_REC_FACTORIAL_2_X : LOAD RECIPROCAL FACTORIAL OF THE NUMBER IN W-REGISTER 
;INTO X-REGISTER
;W REGISTER CONTAINS A STACKED BCD NUMBER "n", WHERE n = 0....69
LOAD_REC_FACTORIAL_2_X
	MOVWF	TEMP
	MOVLF	UPPER TBL_REC_FACTORIAL,TBLPTRU
	MOVLF	HIGH TBL_REC_FACTORIAL,TBLPTRH
	MOVF	TEMP,W
	CALL	BCD2_2_BIN8
	MOVWF	TBLPTRL
;ADDRESS SHOULD BE MULTIPLIED BY D'8' -> 8 Bytes = 1 NUMBER
	BCF	C
	RLCF	TBLPTRL,F
	BTFSC	C
	INCF	TBLPTRH,F
	BCF	C
	RLCF	TBLPTRL,F
	BTFSC	C
	INCF	TBLPTRH,F
	BCF	C
	RLCF	TBLPTRL,F
	BTFSC	C
	INCF	TBLPTRH,F
;
	TBLRD*+
	MOVFF	TABLAT,X_0
	TBLRD*+
	MOVFF	TABLAT,X_1
	TBLRD*+
	MOVFF	TABLAT,X_2
	TBLRD*+
	MOVFF	TABLAT,X_3
	TBLRD*+
	MOVFF	TABLAT,X_4
	TBLRD*+
	MOVFF	TABLAT,X_5
	TBLRD*+
	MOVFF	TABLAT,WREG
	MOVFF	TABLAT,TEMP
	ANDLW	H'0F'
	MOVWF	X_6
;
	TBLRD*
	MOVFF	TABLAT,X_EXP
;
	BCF	X_EXP_SIGN
	BTFSC	TEMP,7	;EXPONENT SIGN BIT
	BSF	X_EXP_SIGN
;
	RETURN
;********************************************************************
;CLEAR_LNX
CLEAR_LNX	MOVLW	H'00'
	MOVFF	WREG,LNX_0
	MOVFF	WREG,LNX_1
	MOVFF	WREG,LNX_2
	MOVFF	WREG,LNX_3
	MOVFF	WREG,LNX_4
	MOVFF	WREG,LNX_5
	MOVFF	WREG,LNX_6
	MOVFF	WREG,LNX_EXP
;	
	RETURN
;********************************************************************
;CLEAR_SUM_LNX
CLEAR_SUM_LNX	MOVLW	H'00'
	MOVFF	WREG,SUM_LNX_0
	MOVFF	WREG,SUM_LNX_1
	MOVFF	WREG,SUM_LNX_2
	MOVFF	WREG,SUM_LNX_3
	MOVFF	WREG,SUM_LNX_4
	MOVFF	WREG,SUM_LNX_5
	MOVFF	WREG,SUM_LNX_6
	MOVFF	WREG,SUM_LNX_EXP
;	
	RETURN
;********************************************************************
	









