;Q_ROOT_LOG_EXP.INC
;LAST REVISION: 2018. 01. 19.
;HARDWARE INDEPENDENT PROGRAM
;********************************************************************
;SQUARE_ROOT : FUNCTION SQUARE ROOT
;X_x CHECKED PREVIOUSLY
;SAVE THE X-EXPONENT (& IT'S SIGN)
SQUARE_ROOT	MOVFF	X_EXP,X_EXP_TEMP
	BCF	X_EXP_TEMP_SIGN
	BTFSC	X_EXP_SIGN
	BSF	X_EXP_TEMP_SIGN
;
	CALL	COPY_X_2_Y
	CALL	SAVE_Y_TEMP	;Y_y  -> Y_TEMP_y
;LOAD THE INITIAL VALUE
	CALL	LOAD_SQRT_TBL_2_X ; Rn -> X_x  (n = 0)
	CALL	COPY_X_2_TEMP	; Rn -> TEMP_x	
	MOVLF	D'5',LOOP_COUNTER ;NUMBER OF LOOPS
;
SQRT_LOOP	NOP
	CALL	RELOAD_Y_TEMP	;RESTORE Y_y
	CALL	DIV_YREG_BY_XREG	;X = N/Rn
	CALL	COPY_X_2_Y	;Y = N/Rn
	CALL	COPY_TEMP_2_X	;X = Rn
	CALL	ADD_YREG_2_XREG	;X = Rn + N/Rn
	CALL	COPY_X_2_Y	;Y = Rn + N/Rn
	LOAD_CONST_2_X	CONST_2	;X_x := 2
	CALL	DIV_YREG_BY_XREG	;X = Rn+1 = [Rn + N/Rn] / 2
	CALL	COPY_X_2_TEMP	;TEMP_X = Rn+1 = [Rn + N/Rn] / 2
	DECFSZ	LOOP_COUNTER,F
	BRA	SQRT_LOOP
;
	RETURN
;********************************************************************
;LOAD_SQRT_TBL_2_X
LOAD_SQRT_TBL_2_X
;LOAD ABLE ADDRESS UPPER & HIGH ADDRESS
	MOVLF	UPPER TBL_SQUARE_ROOT,TBLPTRU
	MOVLF	HIGH TBL_SQUARE_ROOT,TBLPTRH
;CONVERT X-EXPONENT TO BINARY
	MOVF	X_EXP_TEMP,W
	CALL	BCD2_2_BIN8
	MOVWF	TEMPIKE	;BINARY VALUE IN TEMPIKE
;
	MOVF	TEMPIKE,F	;ZERO CHECKING
	BNZ	X_EXP_NOT_0
;X-EXPONENT IS ZERO. NUMBER = 1,xxxx.xxxx.xxxx ... 9,xxxx.xxxx.xxxx EXP= 00
	CALL	SQRT_TBL_READ
	CLRF	X_EXP
	BCF	X_EXP_SIGN
	RETURN
;CHECK THE SIGN OF EXPONENT
X_EXP_NOT_0	BTFSC	X_EXP_TEMP_SIGN	;SKIP IF EXPONENT IS POSITIVE
	BRA	X_EXP_NEGATIVE
;X-EXPONENT IS POSITIVE
	MOVLW	H'01'
	XORWF	TEMPIKE,W
	BNZ	X_EXP_P_NOT_1
;X-EXPONENT IS ONE. NUMBER = 1,xxxx.xxxx.xxxx ... 9,xxxx.xxxx.xxxx * 10^01
	INCF	TBLPTRH,F	;ADD H'0100' TO TABLE POINTER
	CALL	SQRT_TBL_READ
	CLRF	X_EXP
	BCF	X_EXP_SIGN
	RETURN
;
X_EXP_P_NOT_1	BTFSS	TEMPIKE,0	;SKIP IF TEMPIKE,0 = 1 -> EXPONENT ODD
	BRA	X_EXP_P_EVEN
;EXP = 3 ... 99
X_EXP_P_ODD	INCF	TBLPTRH,F	;ADD H'0100' TO TABLE POINTER
	CALL	SQRT_TBL_READ
;DIVIDE THE EXPONENT BY 2
	BCF	C
	RRCF	TEMPIKE,W
	CALL	BIN8_2_BCD2	;CONVERT THE EXPONENT TO BCD
	MOVWF	X_EXP
	BCF	X_EXP_SIGN
	RETURN
;EXP = 2 ... 98
X_EXP_P_EVEN	CALL	SQRT_TBL_READ
;DIVIDE THE EXPONENT BY 2
	BCF	C
	RRCF	TEMPIKE,W
	CALL	BIN8_2_BCD2	;CONVERT THE EXPONENT TO BCD
	MOVWF	X_EXP
	BCF	X_EXP_SIGN
	RETURN
;X-EXPONENT IS NEGATIVE
X_EXP_NEGATIVE	MOVLW	H'01'
	XORWF	TEMPIKE,W
	BNZ	X_EXP_N_NOT_1
;X-EXPONENT IS ONE. NUMBER = 1,xxxx.xxxx.xxxx ... 9,xxxx.xxxx.xxxx * 10^-01
	INCF	TBLPTRH,F	;ADD H'0100' TO TABLE POINTER
	CALL	SQRT_TBL_READ
	MOVLW	D'1'
	MOVWF	X_EXP
	BSF	X_EXP_SIGN
	RETURN
;
X_EXP_N_NOT_1	BTFSS	TEMPIKE,0	;SKIP IF TEMPIKE,0 = 1 -> EXPONENT ODD
	BRA	X_EXP_N_EVEN
;
X_EXP_N_ODD	INCF	TBLPTRH,F	;ADD H'0100' TO TABLE POINTER
	CALL	SQRT_TBL_READ
;DIVIDE THE EXPONENT BY 2
	BCF	C
	RRCF	TEMPIKE,F
	INCF	TEMPIKE,W	
	CALL	BIN8_2_BCD2	;CONVERT THE EXPONENT TO BCD
	MOVWF	X_EXP
	BSF	X_EXP_SIGN
	RETURN
;
X_EXP_N_EVEN	CALL	SQRT_TBL_READ
;DIVIDE THE EXPONENT BY 2
	BCF	C
	RRCF	TEMPIKE,W
	CALL	BIN8_2_BCD2	;CONVERT THE EXPONENT TO BCD
	MOVWF	X_EXP
	BSF	X_EXP_SIGN
	RETURN
;********************************************************************
SQRT_TBL_READ	MOVF	X_6,W	;
	ANDLW	H'0F'	;MAKE SURE HIGH NIBBLE IS 0
	MOVWF	TBLPTRL
;MULTIPLY BY 8
	BCF	C
	RLCF	TBLPTRL,F
	BCF	C
	RLCF	TBLPTRL,F
	BCF	C
	RLCF	TBLPTRL,F
;
	TBLRD*+
	MOVFF	TABLAT,X_0
	TBLRD*+
	MOVFF	TABLAT,X_1	
	TBLRD*+
	MOVFF	TABLAT,X_2
	TBLRD*+
	MOVFF	TABLAT,X_3
	TBLRD*+
	MOVFF	TABLAT,X_4
	TBLRD*+
	MOVFF	TABLAT,X_5
	TBLRD*+
	MOVFF	TABLAT,X_6
;
	RETURN
;********************************************************************
;e_AD_X
;
;        x^0    x^1   x^2   x^3   x^4   x^5   x^6    x^7   x^8   x^9
;  e^x = --- +  --- + --- + --- + --- + --- + ---- + --- + --- + ---   .....
;         0!    1!    2!    3!    4!     5!    6!     7!    8!    9!
;
;NOTES:
; x^0	x^1
; --- = 1	--- = x
; 0!	1!
;
;                 x^2   x^3   x^4   x^5   x^6    x^7   x^8   x^9
;  e^x = 1 + x +  --- + --- + --- + --- + --- + ---- + --- + --- +  .....
;                 2!    3!    4!     5!    6!     7!    8!    9!
;
;  e^x = e^(z+f) = e^z * e^f    where z=integer part of x & f=decimal part of x
;
;
e_AD_X	CLRF	ERROR_REG
;
	CALL	CHECK_X_0?
	BTFSC	X_0_BIT	
	BRA	e_AD_X_5
;e^0 = 1 -> NOTHING TO DO
	CALL	CLEAR_X
	MOVLF	D'1',X_6
	RETURN
;1st LET'S CALCULATE THE INTEGER & DECIMAL PARTS OF X_x
;BECAUSE WE USE NORMALIZED NUMBERS, THERE ARE 4 VARIANT SOLUTIONS
;
;1st: THE SIGN OF EXPONENT IS NEGATIVE -> X_x < 1
;WE SHOLD CALCULATE e^f ONLY
;
;2nd: THE SIGN OF EXPONENT IS POSITIVE & X_EXP = 0
;  1,000.000.000.000 < NUMBER < 9,999.999.999.999
;WE SHOULD CALCULATE  e^z * e^f, WHERE z = 1...9
;	
;3rd: THE SIGN OF EXPONENT IS POSITIVE & X_EXP = 1
;  10,000.000.000.000 < NUMBER < 99,999.999.999.990
;WE SHOULD CALCULATE  e^z * e^f, WHERE z = 10...99
;
;4th: THE SIGN OF EXPONENT IS POSITIVE & X_EXP > 1 (2....99)
;  ERROR CONDITION
;
;
;AT THE END OF COMPUTING e^x WE SHOLD CHECK OF X_SIGN!
;
; e^(-x) = 1 / e^x
;
;
e_AD_X_5	BCF	X_TEMP_SIGN	;DEFAULT
	BTFSC	X_SIGN
	BSF	X_TEMP_SIGN	;SAVE X_SIGN
;
	BCF	X_SIGN	;X_x := |X_x|
;
	CALL	COPY_X_2_M	;SAVE |X_x|
;SET Z_z FOR LATER USE -> IT WILL CONTAIN THE e^z VALUE
	CALL	SAVE_ORI_Z
	CALL	CLEAR_Z
	MOVLF	D'1',Z_6	;Z= 1,000.000.000.000 * 10^0
;
	BTFSC	X_EXP_SIGN	;SKIP IF X_EXP_SIGN = 0  ->  X_x > 1
	GOTO	e_AD_f	;X_x < 1
;X_EXP POSITIVE. CHECK FOR ERROR
	MOVLW	H'01'
	CPFSGT	X_EXP	;SKIP IF X_EXP > 1  -> 2....99
	BRA	e_AD_z
;
	BSF	ERROR_BIT
	BSF	ERROR_BIT5
	RETURN
;X_EXP = 0 or 1
;NOW, LET'S CALCULATE e^z
;
e_AD_z	MOVF	X_EXP,F	;ZERO CHECKING
	BNZ	e_AD_z_EXP_1	;X_EXP = 10....99
;X_EXP = 0 -> z = LOW NIBBLE OF X_6  -> 1...9
e_AD_z_EXP_0	MOVLW	H'01'
	XORWF	X_6,W
	BNZ	e_AD_z_EXP_0_2_9
;X_6 = 1 -> e^1 = e
e_AD_z_EXP_0_1	LOAD_CONST_2_Y	CONST_e	;Y_y= 2,7182.8182.8459 * 10^0
	CALL	COPY_Y_2_Z	;Z_z= 2,7182.8182.8459 * 10^0	
;X_x LOOKS LIKE THIS: 01,dec.ima.lsx.xxx * 10^0
;WE SHOULD SHIFT-LEFT THE X-REG. TO GET THE DECIMALS IN NORMALIZED FORM
 	CALL	X_CHECK_SHIFT
	CALL	COPY_X_2_M	;SAVE X_x
	BRA	e_AD_f
;X_6 =2...9 -> e^2 ... e^9
e_AD_z_EXP_0_2_9
	MOVF	X_6,W
	ANDLW	H'0F'	;CLEAR HIGH NIBBLE, IF ANY
	MOVWF	N_REG
;X_x = 0N,dec.ima.lsx.xxx * 10^0  WHERE N=2...9
	CALL	COPY_X_2_M	;SAVE X_x
	CALL	e_AD_N	;X_x = e^z
	CALL	COPY_X_2_Z	;Z_z = e^z

	BTFSC	X_TEMP_SIGN
	BSF	Z_SIGN
;WE SHOULD SHIFT-LEFT THE X-REG. TO GET THE DECIMALS IN NORMALIZED FORM
	CALL	COPY_M_2_X	;RESTORE X_x
	CALL	X_CHECK_SHIFT
	CALL	COPY_X_2_M	;SAVE X_x
	BRA	e_AD_f
;X_EXP = 1
e_AD_z_EXP_1	NOP
;BEFORE SHIFTING: 0N,Mde.cim.als.xxx * 10^1
	CALL	SHIFT_X_L1	;AFTER  SHIFTING: NM,xxx.xxx.xxx.xx0 * 10^1
;
	CLRF	X_EXP	;AFTER  CLEARING X_EXP: NM,dec.ima.lsx.xx0 * 10^0
	CALL	COPY_X_2_M	;SAVE X_x   NOTE: INTEGER PART OF X_x = NM !!!
;e^z = e^NM
	MOVF	X_6,W	;IN PACKED-BCD! SHOULD BE CONVRTED TO BINARY
	CALL	BCD2_2_BIN8
	MOVWF	N_REG
;
	CALL	e_AD_N	;X_x = e^z
	CALL	COPY_X_2_Z	;Z_z = e^z
;WE SHOULD SHIFT-LEFT THE NUMBER TO GET THE DECIMALS IN NORMALIZED FORM
	CALL	COPY_M_2_X	;RESTORE X_x
	CALL	X_CHECK_SHIFT
	CALL	COPY_X_2_M	;SAVE X_x IN M_m
	NOP
;e_AD_f -> e^f
e_AD_f	CALL	COPY_M_2_X	;X_x = 0d,eci.mal.sxx.x00 * 10^-N
	CALL	CHECK_X_0?
	BTFSC	X_0_BIT	;SKIP IF X_0_BIT=0  -> X_x = 0	
	BRA	e_AD_f_5
;e^f = 1 IF f=0
	CALL	CLEAR_X
	MOVLF	H'01',X_6	;X_x = 1,000.000.000.000 * 10^0
	BRA	e_AD_f_END
;
e_AD_f_5	MOVFF	X_EXP,TEMP2
;N=0  ->  S := 1 
	CALL	CLEAR_Y
	MOVLF	D'1',Y_6	;Y_y = 1,000.000.000.000 * 10^0
;N=1  ->  S := 1 + X
	CALL	ADD_YREG_2_XREG
	CALL	COPY_X_2_S	;
;
	MOVFF	TEMP2,X_EXP
	MOVLW	H'03'
	CPFSGT	X_EXP
	BRA	e_AD_f_15
;DECIMAL VALUE OF X_x < 10^-4  -> LOOP_NUM SHOULD BE DECRESED
	MOVLF	D'7',LOOP_NUM
	MOVLF	D'2',N_REG
	BRA	e_AD_f_LOOP
;
e_AD_f_15	MOVLF	D'15',LOOP_NUM
	MOVLF	D'2',N_REG
;N=2, 3, 4 ....  ->  S := 1 +  X + X^N/N!
e_AD_f_LOOP	CALL	COPY_M_2_X	;RELOAD X
	CALL	X_AD_N	;X_x^n -> X_x
	CALL	COPY_X_2_Y	;X_x -> Y_y
	CALL	LOAD_RECFRAC_2_X;1/n! -> X_x
	CALL	MUL_YREG_BY_XREG;X_x = X_x^n * 1/n!
	CALL	COPY_S_2_Y	;Y_y = S_s
	CALL	ADD_YREG_2_XREG	;X_x = S_s + X_x^n * 1/n!
	CALL	COPY_X_2_S	;X_x -> S_s
;
	INCF	N_REG,F
	DECFSZ	LOOP_NUM,F
	BRA	e_AD_f_LOOP
;
e_AD_f_END	CALL	COPY_Z_2_Y	;COPY Z_z (e^z) INTO Y_y
	CALL	RELOAD_ORI_Z
	CALL	MUL_YREG_BY_XREG;X=e^x		
;
	BTFSS	X_TEMP_SIGN	;SKIP IF THE SAVED X_SIGN=1
	RETURN
;
	CALL	CLEAR_Y
	MOVLF	H'01',Y_6	;Y_y = 1,000.000.000.000 * 10^0
	CALL	DIV_YREG_BY_XREG; -> RECIPROCAL
;
	RETURN
;********************************************************************
;X_AD_N : X^n, WHERE n => 2
;n IN N-REG
X_AD_N	MOVFF	N_REG,LOOP_CNT
	DECF	LOOP_CNT,F
;
X_AD_N_LOOP	CALL	COPY_M_2_Y	;Y_y = M_m
	CALL	MUL_YREG_BY_XREG
	DECFSZ	LOOP_CNT,F
	BRA	X_AD_N_LOOP
;
	RETURN	
;********************************************************************
;e_AD_N : e^n, WHERE n => 2
e_AD_N	MOVFF	N_REG,LOOP_CNT
	DECF	LOOP_CNT,F
	LOAD_CONST_2_X	CONST_e	;X_x = 2,7182.8182.8459 * 10^0
;
e_AD_N_LOOP	LOAD_CONST_2_Y	CONST_e	;Y_y = 2,7182.8182.8459 * 10^0	
	CALL	MUL_YREG_BY_XREG;X_x = e^.....
	DECFSZ	LOOP_CNT,F
	BRA	e_AD_N_LOOP
	RETURN

;********************************************************************
;TEN_AD_N : 10^n, WHERE n >= 2
TEN_AD_N	MOVFF	N_REG,LOOP_CNT
	DECF	LOOP_CNT,F
;
	CALL	CLEAR_X
	MOVLF	H'01',X_6
	MOVLF	H'01',X_EXP	;X_x = 1,000.000.000.000 * 10^1
;
TEN_AD_N_LOOP	CALL	CLEAR_Y
	MOVLF	H'01',Y_6
	MOVLF	H'01',Y_EXP	;Y_y = 1,000.000.000.000 * 10^1

	CALL	MUL_YREG_BY_XREG;X_x = 10^.....
	DECFSZ	LOOP_CNT,F
	BRA	TEN_AD_N_LOOP
	RETURN
;********************************************************************
;X_CHECK_SHIFT: CHECK X_6. IF ZERO SHIFT X-REG. LEFT UNTIL NON ZERO DECIMAL FOUND
;X < 1  -> X_EXP NEGATIVE
;BEFORE SHIFTING: 01,dec.ima.lsx.xxx * 10^0
X_CHECK_SHIFT	NOP
;1st DECIMAL  -> HAVE TO BE SHIFTED W/O CHECKING
	CALL	X_SHIFT_LEFT
	MOVF	X_6,F
	BTFSS	Z	;SKIP IF X_6=0
	RETURN
;2nd DECIMAL
	CALL	X_SHIFT_LEFT
	MOVF	X_6,F
	BTFSS	Z	;SKIP IF X_6=0
	RETURN
;3rd DECIMAL
	CALL	X_SHIFT_LEFT
	MOVF	X_6,F
	BTFSS	Z	;SKIP IF X_6=0
	RETURN
;4th DECIMAL
	CALL	X_SHIFT_LEFT
	MOVF	X_6,F
	BTFSS	Z	;SKIP IF X_6=0
	RETURN
;5th DECIMAL
	CALL	X_SHIFT_LEFT
	MOVF	X_6,F
	BTFSS	Z	;SKIP IF X_6=0
	RETURN
;6th DECIMAL
	CALL	X_SHIFT_LEFT
	MOVF	X_6,F
	BTFSS	Z	;SKIP IF X_6=0
	RETURN
;7th DECIMAL
	CALL	X_SHIFT_LEFT
	MOVF	X_6,F
	BTFSS	Z	;SKIP IF X_6=0
	RETURN
;8th DECIMAL
	CALL	X_SHIFT_LEFT
	MOVF	X_6,F
	BTFSS	Z	;SKIP IF X_6=0
	RETURN
;9th DECIMAL
	CALL	X_SHIFT_LEFT
	MOVF	X_6,F
	BTFSS	Z	;SKIP IF X_6=0
	RETURN
;10th DECIMAL
	CALL	X_SHIFT_LEFT
	MOVF	X_6,F
	BTFSS	Z	;SKIP IF X_6=0
	RETURN
;11th DECIMAL
	CALL	X_SHIFT_LEFT
	MOVF	X_6,F
	BTFSS	Z	;SKIP IF X_6=0
	RETURN
;
	CALL	CLEAR_X
	RETURN
;
;
X_SHIFT_LEFT	CLRF	X_6
	CALL	SHIFT_X_L1	
	INCF	X_EXP,F
	BSF	X_EXP_SIGN	;AFTER  SHIFTING: 0d,eci.mal.sxx.xx0 * 10^-1
;
	RETURN
;********************************************************************
;TEN_AD_X : 10^x  ->  e^(x * LN(10))
;
; 10^x = 10^(z+f) = 10^z * 10^f  where z=integer part of x & f=decimal part of x
;
; 10^x = 10^z * e^(f * LN(10))
;
;
TEN_AD_X	CALL	CHECK_X_0?
	BTFSC	X_0_BIT	
	BRA	TEN_AD_X_5
;10^0 = 1 -> NOTHING TO DO
	CALL	CLEAR_X
	MOVLF	D'1',X_6
	RETURN
;1st LET'S CALCULATE THE INTEGER & DECIMAL PARTS OF X_x
;BECAUSE WE USE NORMALIZED NUMBERS, THERE ARE 4 VARIANT SOLUTIONS
;
;1st: THE SIGN OF EXPONENT IS NEGATIVE -> X_x < 1
;WE SHOLD CALCULATE 10^f ONLY
;
;2nd: THE SIGN OF EXPONENT IS POSITIVE & X_EXP = 0
;  1,000.000.000.000 < NUMBER < 9,999.999.999.999
;WE SHOULD CALCULATE  10^z * 10^f, WHERE z = 1...9
;	
;3rd: THE SIGN OF EXPONENT IS POSITIVE & X_EXP = 1
;  10,000.000.000.000 < NUMBER < 99,999.999.999.990
;WE SHOULD CALCULATE  10^z * 10^f, WHERE z = 10...99
;
;4th: THE SIGN OF EXPONENT IS POSITIVE & X_EXP > 1 (2....99)
;  ERROR CONDITION
TEN_AD_X_5	CALL	COPY_X_2_M	;SAVE X_x
;SET Z_z FOR LATER USE -> IT WILL CONTAIN THE 10^z VALUE
	CALL	SAVE_ORI_Z
	CALL	CLEAR_Z
	MOVLF	D'1',Z_6	;Z= 1,000.000.000.000 * 10^0
;
	BTFSC	X_EXP_SIGN	;SKIP IF X_EXP_SIGN = 0  ->  X_x > 1
	GOTO	TEN_AD_f	;X_x < 1
;X_EXP POSITIVE. CHECK FOR ERROR
	MOVLW	H'01'
	CPFSGT	X_EXP	;SKIP IF X_EXP > 1  -> 2....99
	BRA	TEN_AD_z
;
	BSF	ERROR_BIT
	BSF	ERROR_BIT5
	RETURN
;X_EXP = 0 or 1
TEN_AD_z	MOVF	X_EXP,F	;ZERO CHECKING
	BNZ	TEN_AD_z_EXP_1	;X_EXP = 10....99
;X_EXP = 0 -> z = LOW NIBBLE OF X_6  -> 1...9
TEN_AD_z_EXP_0	MOVLW	H'01'
	XORWF	X_6,W
	BNZ	TEN_AD_z_EXP_0_2_9
;X_6 = 1 -> 10^1 = 10
TEN_AD_z_EXP_0_1
	CALL	CLEAR_Y
	MOVLF	H'01',Y_6	;Y_y= 1,000.000.000.000 * 10^0
	MOVLF	H'01',Y_EXP	;Y_y= 1,000.000.000.000 * 10^1
;
	CALL	COPY_Y_2_Z	;Z_z= 1,000.000.000.000 * 10^1	
;X_x LOOKS LIKE THIS: 01,dec.ima.lsx.xxx * 10^0
;WE SHOULD SHIFT-LEFT THE X-REG. TO GET THE DECIMALS IN NORMALIZED FORM
 	CALL	X_CHECK_SHIFT
	CALL	COPY_X_2_M	;SAVE X_x
	BRA	TEN_AD_f
;X_6 =2...9 -> e^2 ... e^9
TEN_AD_z_EXP_0_2_9
	MOVF	X_6,W
	ANDLW	H'0F'	;CLEAR HIGH NIBBLE, IF ANY
	MOVWF	N_REG
;X_x = 0N,dec.ima.lsx.xxx * 10^0  WHERE N=2...9
	CALL	COPY_X_2_M	;SAVE X_x
	CALL	TEN_AD_N	;X_x = 10^z
	CALL	COPY_X_2_Z	;Z_z = 10^z
;WE SHOULD SHIFT-LEFT THE X-REG. TO GET THE DECIMALS IN NORMALIZED FORM
	CALL	COPY_M_2_X	;RESTORE X_x
	CALL	X_CHECK_SHIFT
	CALL	COPY_X_2_M	;SAVE X_x
	BRA	TEN_AD_f
;X_EXP = 1
TEN_AD_z_EXP_1	NOP
;BEFORE SHIFTING: 0N,Mde.cim.als.xxx * 10^1
	CALL	SHIFT_X_L1	;AFTER  SHIFTING: NM,xxx.xxx.xxx.xx0 * 10^1
;
	CLRF	X_EXP	;AFTER  CLEARING X_EXP: NM,dec.ima.lsx.xx0 * 10^0
	CALL	COPY_X_2_M	;SAVE X_x   NOTE: INTEGER PART OF X_x = NM !!!
;10^z = 10^NM
	MOVF	X_6,W	;IN PACKED-BCD! SHOULD BE CONVRTED TO BINARY
	CALL	BCD2_2_BIN8
	MOVWF	N_REG
;
	CALL	TEN_AD_N	;X_x = 10^z
	CALL	COPY_X_2_Z	;Z_z = 10^z
;WE SHOULD SHIFT-LEFT THE NUMBER TO GET THE DECIMALS IN NORMALIZED FORM
	CALL	COPY_M_2_X	;RESTORE X_x
	CALL	X_CHECK_SHIFT
	CALL	COPY_X_2_M	;SAVE X_x IN M_m
	NOP
;TEN_AD_f -> 10^f = e^(f*LN10)
TEN_AD_f	LOAD_CONST_2_Y	CONST_LN10	;Y_y = 2,3025.8509.2994 * 10^0	-> LN(10)
	CALL	MUL_YREG_BY_XREG;X_x = X_x * LN(10)
	CALL	COPY_X_2_M	;SAVE X_x IN M_m
;
	CALL	e_AD_f	;X_x = 10^z * e^(f * LN(10))
;
	RETURN
;********************************************************************
;CHECK_X_INT? : CHECK X INTEGER?
CHECK_X_INT?	CLRF	N_REG
	BCF	INT_BIT	;DEFAULT -> X_x NOT INEGER
;WE SUPPOSE THAT X_x IS INTEGER IF:
;X_EXP=0  &  X_5 ....X_0 ARE ALL ZEROS
;X_EXP=+1  &  X_5 HI NIBBLE=0, 1...9  & X_5 LO NIBBLE=0, X_4 ....X_0 ARE ZEROS
;IF X_x INTEGER THE X_x IS COPIED TO N_REG
	BTFSC	X_EXP_SIGN	;SKIP IF X_EXP_SIGN=0  -> X_x > 1
	RETURN		;X_x < 1
	MOVF	X_EXP,F	;ZERO CHECKING
	BZ	X_INT?_EXP_0
;
	MOVLW	H'01'
	XORWF	X_EXP,W
	BNZ	X_INT?_END
;THE NUMBER IN X_x = 0N,Mxx.xxx.xxx.xxx * 10^1
;WHERE N=1....9 & M=0...9
;CHECK THE REMAINING DECIMALS (AFTER THE M)
	MOVF	X_5,W
	ANDLW	H'0F'	;CLEAR TH HI NIBBLE
	BNZ	X_INT?_END
	MOVF	X_4,F
	BNZ	X_INT?_END
	MOVF	X_3,F
	BNZ	X_INT?_END
	MOVF	X_2,F
	BNZ	X_INT?_END
	MOVF	X_1,F
	BNZ	X_INT?_END
	MOVF	X_0,F
	BNZ	X_INT?_END
;O.K.
	SWAPF	X_6,W
	ANDLW	H'F0'	;MAKE SURE LO NIBBLE IS CLEARED
	MOVWF	N_REG
	SWAPF	X_5,W
	ANDLW	H'0F'	;MAKE SURE HI NIBBLE IS CLEARED
	IORWF	N_REG,F
	BSF	INT_BIT
	RETURN
;X_EXP=0  -> DECIMAL ARE ZEROS?
X_INT?_EXP_0	MOVF	X_5,F
	BNZ	X_INT?_END
	MOVF	X_4,F
	BNZ	X_INT?_END
	MOVF	X_3,F
	BNZ	X_INT?_END
	MOVF	X_2,F
	BNZ	X_INT?_END
	MOVF	X_1,F
	BNZ	X_INT?_END
	MOVF	X_0,F
	BNZ	X_INT?_END
;O.K.
	MOVFF	X_6,N_REG
	BSF	INT_BIT
	RETURN
;
X_INT?_END	RETURN
;********************************************************************
;LN_X : FUNCTION LN(x)
;Note: X_x = M * 10^n, IN NORMALIZED FORM!
;
;Calculating the ln(x) function is performed as written in
;Hewlett-Packard Journal (April 1978 Volume 29 Number 8) by William E. Egbert.
;
;IDENTITY: LN (M * 10^K) = LN (M) + LN(10^K) = LN(M) + K*LN(10)
;1st WE SHOULD CALCULATE LN(M) ONLY
;LET'S MODIFY OUR NUMBER IN X-REGISTER: A:= M/10
;LN (M * 10^K) = LN (A) + LN(10^K+1) = LN(M) + (K+1)*LN(10)
;THUS: 0,1 < X_x < 1
;
;
LN_X	CALL	SAVE_X
;
	CALL	CLEAR_Y
	MOVLF	H'01',Y_6	;Y_y = 1,0000.0000.0000 *10^00	
;
	CALL	SUB_XREG_FROM_YREG;X_x = Y_y - X_x
	CALL	CHECK_X_0?
;	
	BTFSS	X_0_BIT	;SKIP IF RESULT OF SUBTRACTION = 0 -> X_x =1
	RETURN		;ORIGINAL X_x = 1 -> LN(1) = 0
;
	CALL	RELOAD_X
;IF X_x = X,xxxx.xxxx.xxxx *10^-1 -> DO (ALMOST) NOTHING!
LN_X_0	BTFSS	X_EXP_SIGN	;SKIP IF X_SIGN = 1 -> 1 < X_x
	BRA	LN_X_5
;
	MOVLW	D'01'
	XORWF	X_EXP,W
	BNZ	LN_X_5	;BRANCH BECAUSE X_EXP =/= 1
;
	CLRF	X_EXP_SAVE	
	BCF	X_EXP_SAVE_SIGN
	BRA	LN_X_10
;CALCULATE & SAVE THE NEW X_EXP -> X-REGISTER:= X,xxxx.xxxx.xxxx * 10^-1 (0,1 < x < 1)
LN_X_5	CALL	INCREMENT_X_EXP
	MOVFF	X_EXP,X_EXP_SAVE
	BCF	X_EXP_SAVE_SIGN
	BTFSC	X_EXP_SIGN
	BSF	X_EXP_SAVE_SIGN
;"DIVIDE" X_x BY TEN -> 0,1 < |x| < 1
	MOVLF	D'1',X_EXP
	BSF	X_EXP_SIGN	;X < 1 -> X-EXP = -1
;
LN_X_10	CALL	STORE_X_NEW
	CALL	CLEAR_SUM_LNX
;
AJ_2_LOOP	LOAD_CONST_2_Y	CONST_2	;Y_y = 2,0000.0000.0000 * 10^0
	CALL	RESTORE_X_NEW
	CALL	MUL_YREG_BY_XREG;X_x = X_x * 2
	CALL	CHECK_X_1?
	BTFSC	X_1_BIT	;SKIP IF (X_x * 2) < 1	
	BRA	AJ_1.1_LOOP
;RESULT OF MULTIPLYING < 1. ADD ln(2) TO SUM_LNx
	CALL	STORE_X_NEW
	LOAD_CONST_2_Y	CONST_LN2	;Y_y = 6,9314.7180.5599 * 10^-1
	CALL	COPY_SUM_LNX_2_X;X_x = SUM_LNx
	CALL	ADD_YREG_2_XREG	;
	CALL	COPY_X_2_SUM_LNX
	BRA	AJ_2_LOOP
;
AJ_1.1_LOOP	LOAD_CONST_2_Y	CONST_1.1	;Y_y = 1,1000.0000.0000 * 10^0
	CALL	RESTORE_X_NEW
	CALL	MUL_YREG_BY_XREG;X_x = X_x * 1,1
	CALL	CHECK_X_1?
	BTFSC	X_1_BIT	;SKIP IF (X_x * 1,1) < 1	
	BRA	AJ_1.01_LOOP
;RESULT OF MULTIPLYING < 1. ADD ln(1,1) TO SUM_LNx
	CALL	STORE_X_NEW
	LOAD_CONST_2_Y	CONST_LN1.1	;Y_y = 
	CALL	COPY_SUM_LNX_2_X;X_x = SUM_LNx
	CALL	ADD_YREG_2_XREG	;
	CALL	COPY_X_2_SUM_LNX
	BRA	AJ_1.1_LOOP
;
AJ_1.01_LOOP	LOAD_CONST_2_Y	CONST_1.1N1	;Y_y = 1,0100.0000.0000 * 10^0
	CALL	RESTORE_X_NEW
	CALL	MUL_YREG_BY_XREG;X_x = X_x * 1,01
	CALL	CHECK_X_1?
	BTFSC	X_1_BIT	;SKIP IF (X_x * 1,01) < 1	
	BRA	AJ_1.2N1_LOOP
;RESULT OF MULTIPLYING < 1. ADD ln(1,01) TO SUM_LNx
	CALL	STORE_X_NEW
	LOAD_CONST_2_Y	CONST_LN1.1N1	;Y_y = 9,9503.3085.3168 * 10^-3
	CALL	COPY_SUM_LNX_2_X;X_x = SUM_LNx
	CALL	ADD_YREG_2_XREG	;
	CALL	COPY_X_2_SUM_LNX
	BRA	AJ_1.01_LOOP
;
AJ_1.2N1_LOOP	LOAD_CONST_2_Y	CONST_1.2N1	;Y_y = 1,0010.0000.0000 * 10^0
	CALL	RESTORE_X_NEW
	CALL	MUL_YREG_BY_XREG;X_x = X_x * 1,001
	CALL	CHECK_X_1?
	BTFSC	X_1_BIT	;SKIP IF (X_x * 1,001) < 1	
	BRA	AJ_1.3N1_LOOP
;RESULT OF MULTIPLYING < 1. ADD ln(1,001) TO SUM_LNx
	CALL	STORE_X_NEW
	LOAD_CONST_2_Y	CONST_LN1.2N1	;Y_y = 9,9950.0333.0835 * 10^-4
	CALL	COPY_SUM_LNX_2_X;X_x = SUM_LNx
	CALL	ADD_YREG_2_XREG	;
	CALL	COPY_X_2_SUM_LNX
	BRA	AJ_1.2N1_LOOP
;
AJ_1.3N1_LOOP	LOAD_CONST_2_Y	CONST_1.3N1	;Y_y = 1,0001.0000.0000 * 10^0
	CALL	RESTORE_X_NEW
	CALL	MUL_YREG_BY_XREG;X_x = X_x * 1,0001
	CALL	CHECK_X_1?
	BTFSC	X_1_BIT	;SKIP IF (X_x * 1,0001) < 1	
	BRA	AJ_1.4N1_LOOP
;RESULT OF MULTIPLYING < 1. ADD ln(1,0001) TO SUM_LNx
	CALL	STORE_X_NEW
	LOAD_CONST_2_Y	CONST_LN1.3N1	;Y_y = 9,9995.0003.3330 * 10^-5
	CALL	COPY_SUM_LNX_2_X;X_x = SUM_LNx
	CALL	ADD_YREG_2_XREG	;
	CALL	COPY_X_2_SUM_LNX
	BRA	AJ_1.3N1_LOOP
;
AJ_1.4N1_LOOP	LOAD_CONST_2_Y	CONST_1.4N1	;Y_y = 1,0000.1000.0000 * 10^0
	CALL	RESTORE_X_NEW
	CALL	MUL_YREG_BY_XREG;X_x = X_x * 1,0000.1
	CALL	CHECK_X_1?
	BTFSC	X_1_BIT	;SKIP IF (X_x * 1,0000.1) < 1	
	BRA	AJ_1.5N1_LOOP
;RESULT OF MULTIPLYING < 1. ADD ln(1,0000.1) TO SUM_LNx
	CALL	STORE_X_NEW
	LOAD_CONST_2_Y	CONST_LN1.4N1	;Y_y = 
	CALL	COPY_SUM_LNX_2_X;X_x = SUM_LNx
	CALL	ADD_YREG_2_XREG	;
	CALL	COPY_X_2_SUM_LNX
	BRA	AJ_1.4N1_LOOP
;
AJ_1.5N1_LOOP	LOAD_CONST_2_Y	CONST_1.5N1	;Y_y = 1,0000.0100.0000 * 10^0
	CALL	RESTORE_X_NEW
	CALL	MUL_YREG_BY_XREG;X_x = X_x * 1,0000.01
	CALL	CHECK_X_1?
	BTFSC	X_1_BIT	;SKIP IF (X_x * 1,0000.01) < 1	
	BRA	AJ_1.6N1_LOOP
;RESULT OF MULTIPLYING < 1. ADD ln(1,0000.01) TO SUM_LNx
	CALL	STORE_X_NEW
	LOAD_CONST_2_Y	CONST_LN1.5N1	;Y_y = 
	CALL	COPY_SUM_LNX_2_X;X_x = SUM_LNx
	CALL	ADD_YREG_2_XREG	;
	CALL	COPY_X_2_SUM_LNX
	BRA	AJ_1.5N1_LOOP
;
AJ_1.6N1_LOOP	LOAD_CONST_2_Y	CONST_1.6N1	;Y_y = 1,0000.0010.0000 * 10^0
	CALL	RESTORE_X_NEW
	CALL	MUL_YREG_BY_XREG;X_x = X_x * 1,0000.001
	CALL	CHECK_X_1?
	BTFSC	X_1_BIT	;SKIP IF (X_x * 1,0000.001) < 1	
	BRA	AJ_1.7N1_LOOP
;RESULT OF MULTIPLYING < 1. ADD ln(1,0000.001) TO SUM_LNx
	CALL	STORE_X_NEW
	LOAD_CONST_2_Y	CONST_LN1.6N1	;Y_y = 
	CALL	COPY_SUM_LNX_2_X;X_x = SUM_LNx
	CALL	ADD_YREG_2_XREG	;
	CALL	COPY_X_2_SUM_LNX
	BRA	AJ_1.6N1_LOOP
;

AJ_1.7N1_LOOP	LOAD_CONST_2_Y	CONST_1.7N1	;Y_y = 1,0000.0001.0000 * 10^0
	CALL	RESTORE_X_NEW
	CALL	MUL_YREG_BY_XREG;X_x = X_x * 1,0000.0001
	CALL	CHECK_X_1?
	BTFSC	X_1_BIT	;SKIP IF (X_x * 1,0000.0001) < 1	
	BRA	AJ_END
;RESULT OF MULTIPLYING < 1. ADD ln(1,0000.0001) TO SUM_LNx
	CALL	STORE_X_NEW
	LOAD_CONST_2_Y	CONST_LN1.7N1	;Y_y = 
	CALL	COPY_SUM_LNX_2_X;X_x = SUM_LNx
	CALL	ADD_YREG_2_XREG	;
	CALL	COPY_X_2_SUM_LNX
	BRA	AJ_1.7N1_LOOP
;
AJ_END
;WE STOP HERE
;LN(x) = (APj - 1) - SUM LN(aj)
	CALL	RESTORE_X_NEW
	CALL	COPY_X_2_Y
	LOAD_CONST_2_X	CONST_1
	CALL	SUB_XREG_FROM_YREG;X_x = (APj - 1)
;
	CALL	COPY_X_2_Y
	CALL	COPY_SUM_LNX_2_X;X_x = SUM_LN(aj)
	CALL	SUB_XREG_FROM_YREG;X_x = (APj - 1) - SUM LN(aj)
	CALL	STORE_X_NEW	;LN(M/10) -> TEMPORARY STORAGE
	CALL	CONV_EXP_2_MAN	;X_x = ORIGINAL EXPONENT OF X-REG.
	LOAD_CONST_2_Y	CONST_LN10	;Y_y = 2,3025.8509.2994 * 10^0
	CALL	MUL_YREG_BY_XREG;X_x = EXP * LN(10)
;
	BCF	X_SIGN
	BTFSC	X_EXP_SAVE_SIGN
	BSF	X_SIGN
;
	CALL	COPY_X_2_Y	;Y_y = EXP * LN(10)
	CALL	RESTORE_X_NEW	;X_x = LN(M/10)
	CALL	ADD_YREG_2_XREG	;LN (M * 10^n) = LN (M) + LN(10^n)
;
	RETURN
;********************************************************************
;CHECK_X_1?
;X_1_BIT IS SET IF X_x = 1 or X_x > 1
CHECK_X_1?	BCF	X_1_BIT	;DEFAULT
;IF X_EXP = 0 -> X_x = 1 or X_x > 1
	MOVF	X_EXP,F	;IF X_EXP = 0   ->  X_x > 1 or =1
	BZ	SET_X_1_BIT
;IF X_EXP_SIGN = 0
	BTFSC	X_EXP_SIGN	;SKIP IF X_EXP_SIGN = 0 -> X_x = 1 or X_x > 1
	RETURN
;
SET_X_1_BIT	BSF	X_1_BIT
	RETURN
;********************************************************************
;CONV_EXP_2_MAN : CONVERT THE SAVED X-EXPONENT TO MANTISSA VALUE (USED AT LNx FUNCTION)
CONV_EXP_2_MAN	CALL	CLEAR_X
	MOVF	X_EXP_SAVE,F
	BTFSC	Z	;SKIP IF X-EXP =/= 0
	RETURN
	MOVF	X_EXP_SAVE,W
	MOVWF	TEMP
	ANDLW	H'F0'	;MASK-OUT LOW NIBBLE
	BZ	HI_NIBBLE_0
;HIGH NIBBLE NOT ZERO
HI_NIBBLE_NOT_0	SWAPF	X_EXP_SAVE,W
	ANDLW	H'F0'
	MOVWF	X_5
;
	MOVF	X_EXP_SAVE,W
	ANDLW	H'0F'
	MOVWF	X_6
;
	MOVLF	D'1',X_EXP
;
	RETURN
;
HI_NIBBLE_0	MOVFF	X_EXP_SAVE,X_6
;
	RETURN
;********************************************************************









