;TRIGONOMETRIC_CORDIC.INC
;LAST REVISION: 2018. 01. 17.
;HARDWARE INDEPENDENT PROGRAM
;********************************************************************
;TRIG_FUNCTION : CALCULATES SINE, COSINE  & TANGENT VALUES OF THE ORIGINAL ANGLE
;ANGLE IS IN DEGREES
;CORDIC ALGORITHM IS USED
TRIG_FUNCTION	CALL	COPY_X_2_LASTX
	CALL	SAVE_ORI_X	;NOTE: ANGLE MAY BE > 360 DEGREES
	CALL	SAVE_ORI_Y
;CHECK_ANGLE : CHECK THE VALUE OF THE ANGLE
;IF ANGLE > 360 DEGREES (2pi RADIANS or 400 GRADS) -> REDUCE IT
CHECK_ANGLE	BTFSC	DEG_BIT
	GOTO	CHECK_DEG
;
	BTFSC	RAD_BIT
	GOTO	CHECK_RAD
;
	BTFSC	GRAD_BIT
	GOTO	CHECK_GRAD
;NONE OF THEM ???? -> SUPPOSE ANGLES ARE IN DEGREES
CHECK_DEG	CALL	SET_DEG
	BTFSC	ERROR_BIT
	GOTO	_ERROR
	GOTO	TRIG_FUNCTION_5
;
CHECK_RAD	CALL	SET_RAD
	BTFSC	ERROR_BIT
	GOTO	_ERROR
	GOTO	TRIG_FUNCTION_5
;	
CHECK_GRAD	CALL	SET_GRAD
	BTFSC	ERROR_BIT
	GOTO	_ERROR
;CONVERTS RADIANS or GRADIENTS TO DEGREES
TRIG_FUNCTION_5 NOP
;######
;	CALL	DISPLAY_REGS
;######
	BTFSC	DEG_BIT
	BRA	ANGLE_0?	;ANGLE IS IN DEGREES -> NO CONVERSION, GO ON
;
	BTFSC	RAD_BIT
	CALL	CONV_RAD_2_DEG
;
	BTFSC	GRAD_BIT
	CALL	CONV_GRAD_2_DEG
;NONE OF THEM -> SUPPOSE ANGLES ARE IN DEGREES
;NOW, THE ANGLES IS IN DEGREES & 0 < ANGLE < 360
;SEARCH FOR SPECIAL ANGLES: 0, 90, 180, 270 & 360 DEGREES
;X_x =?= 0
ANGLE_0?	CALL	SAVE_X	;0 <= ANGLE < 360, SAVED IN  X_SAVE_x
;######
;	CALL	DISPLAY_REGS
;######
	CALL	CHECK_X_0?
	BTFSC	X_0_BIT	;SKIP IF ANGLE = 0
	BRA	ANGLE_90?
;ANGLE = 0 -> SIN0 = 0, COS0 = 1, TAN0 = 0
ANGLE_0_SIN?	MOVLW	"s"	;H'73'
	XORWF	KEYREG,W
	BNZ	ANGLE_0_COS?
	CALL	CLEAR_X
	GOTO	TRIG_END
;
ANGLE_0_COS?	MOVLW	"c"	;H'63'
	XORWF	KEYREG,W
	BNZ	ANGLE_0_TAN?
	LOAD_CONST_2_X	CONST_1
	GOTO	TRIG_END
;
ANGLE_0_TAN?	MOVLW	"t"	;H'74'
	XORWF	KEYREG,W
	BNZ	ANGLE_90?
	CALL	CLEAR_X
	GOTO	TRIG_END	
;
ANGLE_90?	LOAD_CONST_2_Y	CONST_90
	CALL	RELOAD_X
	CALL	COMPARE_X_Y
	BTFSC	X_0_BIT	;SKIP IF ANGLE = 90
	BRA	ANGLE_180?
;ANGLE = 90 -> SIN90 = 1, COS90 = 0, TAN90 = OVERFLOW
ANGLE_90_SIN?	MOVLW	"s"	;H'73'
	XORWF	KEYREG,W
	BNZ	ANGLE_90_COS?
	LOAD_CONST_2_X	CONST_1
	BCF	X_SIGN	;DEFAULT
	BTFSC	X_ORI_SIGN
	BSF	X_SIGN
	GOTO	TRIG_END
;
ANGLE_90_COS?	MOVLW	"c"	;H'63'
	XORWF	KEYREG,W
	BNZ	ANGLE_90_TAN?
	CALL	CLEAR_X
	GOTO	TRIG_END
;
ANGLE_90_TAN?	MOVLW	"t"	;H'74'
	XORWF	KEYREG,W
	BNZ	ANGLE_180?
	GOTO	TRIG_END_OVFL
;
ANGLE_180?	LOAD_CONST_2_Y	CONST_180
	CALL	RELOAD_X
	CALL	COMPARE_X_Y
	BTFSC	X_0_BIT	;SKIP IF ANGLE = 180
	BRA	ANGLE_270?
;ANGLE = 180 -> SIN180 = 0, COS180 = 1, TAN180 = 0
ANGLE_180_SIN?	MOVLW	"s"
	XORWF	KEYREG,W
	BNZ	ANGLE_180_COS?
	CALL	CLEAR_X
	GOTO	TRIG_END
;
ANGLE_180_COS?	MOVLW	"c"
	XORWF	KEYREG,W
	BNZ	ANGLE_180_TAN?
	LOAD_CONST_2_X	CONST_1
	BCF	X_SIGN	;DEFAULT
	BTFSC	X_ORI_SIGN
	BSF	X_SIGN
	GOTO	TRIG_END
;
ANGLE_180_TAN?	MOVLW	"t"
	XORWF	KEYREG,W
	BNZ	ANGLE_270?
	CALL	CLEAR_X
	GOTO	TRIG_END
;
ANGLE_270?	LOAD_CONST_2_Y	CONST_270
	CALL	RELOAD_X
	CALL	COMPARE_X_Y
	BTFSC	X_0_BIT	;SKIP IF ANGLE = 270
	BRA	ANGLE_360?	
;ANGLE = 270 -> SIN270 = -1, COS270 = 0, TAN270 = OVERFLOW
ANGLE_270_SIN?	MOVLW	"s"
	XORWF	KEYREG,W
	BNZ	ANGLE_270_COS?
	LOAD_CONST_2_X	CONST_1
	BSF	X_SIGN	;DEFAULT
	BTFSC	X_ORI_SIGN
	BCF	X_SIGN
	GOTO	TRIG_END
;
ANGLE_270_COS?	MOVLW	"c"
	XORWF	KEYREG,W
	BNZ	ANGLE_270_TAN?
	CALL	CLEAR_X
	GOTO	TRIG_END
;
ANGLE_270_TAN?	MOVLW	"t"
	XORWF	KEYREG,W
	BNZ	ANGLE_360?
	GOTO	TRIG_END_OVFL
;
ANGLE_360?	LOAD_CONST_2_Y	CONST_360
	CALL	RELOAD_X
	CALL	COMPARE_X_Y
	BTFSC	X_0_BIT	;SKIP IF ANGLE = 360
	BRA	CHECK_QUARTER
;ANGLE = 360 -> SIN360 = 0, COS360 = 1, TAN360 = 0
ANGLE_360_SIN?	MOVLW	"s"
	XORWF	KEYREG,W
	BNZ	ANGLE_360_COS?
	CALL	CLEAR_X
	GOTO	TRIG_END
;
ANGLE_360_COS?	MOVLW	"c"
	XORWF	KEYREG,W
	BNZ	ANGLE_360_TAN?
	LOAD_CONST_2_X	CONST_1
	GOTO	TRIG_END
;
ANGLE_360_TAN?	MOVLW	"t"
	XORWF	KEYREG,W
	BNZ	CHECK_QUARTER
	CALL	CLEAR_X
	GOTO	TRIG_END	
;
CHECK_QUARTER	CALL	RELOAD_X
;1st QUARTER?
	CLRF	QUARTER_REG
	BSF	_1ST_Q_BIT	;DEFAULT
	CALL	COPY_X_2_Y	;Y = ANGLE IN DEGREES
	LOAD_CONST_2_X	CONST_90
	CALL	NORM_SUB_X_FROM_Y ;X = ANGLE - 90
	CALL	COPY_X_2_Y	;Y = ANGLE - 90
	BTFSC	X_SIGN	;SKIP IF X_SIGN=0 -> POSITIVE ANGLE
	BRA	CHECK_QUARTER_END
;2nd QUARTER?
	CLRF	QUARTER_REG
	BSF	_2ND_Q_BIT	;DEFAULT
	LOAD_CONST_2_X	CONST_90
	CALL	NORM_SUB_X_FROM_Y ;X = ANGLE - 90 
	CALL	COPY_X_2_Y	;Y = ANGLE - 90  (ANGLE -90 -90)
	BTFSC	X_SIGN	;SKIP IF X_SIGN=0 -> POSITIVE ANGLE
	BRA	CHECK_QUARTER_END
;3rd QUARTER?
	CLRF	QUARTER_REG
	BSF	_3RD_Q_BIT	;DEFAULT
	LOAD_CONST_2_X	CONST_90
	CALL	NORM_SUB_X_FROM_Y ;X = ANGLE - 90
	CALL	COPY_X_2_Y	;Y = ANGLE - 90  (ANGLE -90 -90-90)
	BTFSC	X_SIGN	;SKIP IF X_SIGN=0 -> POSITIVE ANGLE
	BRA	CHECK_QUARTER_END
;4th QUARTER?
	CLRF	QUARTER_REG
	BSF	_4TH_Q_BIT	;DEFAULT
	LOAD_CONST_2_X	CONST_90
	CALL	NORM_SUB_X_FROM_Y ;X = ANGLE - 90
	CALL	COPY_X_2_Y	;Y = ANGLE - 90  (ANGLE -90 -90-90-90)
	BTFSC	X_SIGN	;SKIP IF X_SIGN=0 -> POSITIVE ANGLE
;
CHECK_QUARTER_END LOAD_CONST_2_X CONST_90
	CALL	ADD_YREG_2_XREG
;
	BTFSC	_1ST_Q_BIT	;SKIP IF NO 1st QUARTER
	BRA	_1ST_QUARTER
;
	BTFSC	_2ND_Q_BIT	;SKIP IF NO 2nd QUARTER
	BRA	_2ND_QUARTER
;
	BTFSC	_3RD_Q_BIT
	BRA	_3RD_QUARTER
;
	BTFSC	_4TH_Q_BIT
	BRA	_4TH_QUARTER
;_1st QUARTER : ANGLE IN 1st QUARTER: 0 < ANGLE < 90
_1ST_QUARTER	BCF	X_SIGN
	CALL	SIN_COS_TAN
;
_1ST_Q_SIN?	MOVLW	"s"
	XORWF	KEYREG,W
	BNZ	_1ST_Q_COS?
;
	CALL	COPY_SIN_NEW_2_X
	BTFSC	X_ORI_SIGN
	BSF	X_SIGN
	GOTO	TRIG_END
;
_1ST_Q_COS?	MOVLW	"c"
	XORWF	KEYREG,W
	BNZ	_1ST_Q_TAN?
;
	CALL	COPY_COS_NEW_2_X
	GOTO	TRIG_END
;
_1ST_Q_TAN?	MOVLW	"t"
	XORWF	KEYREG,W
	BTFSS	Z
;????
	GOTO	TRIG_END	
;
	CALL	COPY_SIN_NEW_2_Y
	CALL	COPY_COS_NEW_2_X
	CALL	DIV_YREG_BY_XREG
	BCF	X_SIGN	;DEFAULT
	BTFSC	X_ORI_SIGN
	BSF	X_SIGN
	GOTO	TRIG_END	
;_2nd QUARTER : ANGLE IN 2nd QUARTER: 90 < ANGLE < 180
_2ND_QUARTER	LOAD_CONST_2_Y	CONST_180
	CALL	RELOAD_X
	BCF	X_SIGN
	CALL	SUB_XREG_FROM_YREG
;
	CALL	SIN_COS_TAN
;
_2ND_Q_SIN?	MOVLW	"s"
	XORWF	KEYREG,W
	BNZ	_2ND_Q_COS?
;
	CALL	COPY_SIN_NEW_2_X
	BCF	X_SIGN
	BTFSC	X_ORI_SIGN
	BSF	X_SIGN
	GOTO	TRIG_END
;
_2ND_Q_COS?	MOVLW	"c"
	XORWF	KEYREG,W
	BNZ	_2ND_Q_TAN?
;
	CALL	COPY_COS_NEW_2_X
	BSF	X_SIGN
	GOTO	TRIG_END
;
_2ND_Q_TAN?	MOVLW	"t"
	XORWF	KEYREG,W
	BTFSS	Z
;????
	GOTO	TRIG_END
;
	CALL	COPY_SIN_NEW_2_Y
	CALL	COPY_COS_NEW_2_X
	CALL	DIV_YREG_BY_XREG
	BCF	X_SIGN
	BTFSC	X_ORI_SIGN	;COPY X_ORI_SIGN TO X_SIGN
	BSF	X_SIGN
	BTG	X_SIGN	;COMPLEMENT X_SIGN	
	GOTO	TRIG_END
;_3rd QUARTER : ANGLE IN 3rd QUARTER: 180 < ANGLE < 270
_3RD_QUARTER	CALL	RELOAD_X
	BCF	X_SIGN
	CALL	COPY_X_2_Y
	LOAD_CONST_2_X	CONST_180	
	CALL	SUB_XREG_FROM_YREG
;
	CALL	SIN_COS_TAN
;
_3RD_Q_SIN?	MOVLW	"s"
	XORWF	KEYREG,W
	BNZ	_3RD_Q_COS?
;
	CALL	COPY_SIN_NEW_2_X
	BSF	X_SIGN
	BTFSC	X_ORI_SIGN
	BTG	X_SIGN
	GOTO	TRIG_END
;
_3RD_Q_COS?	MOVLW	"c"
	XORWF	KEYREG,W
	BNZ	_3RD_Q_TAN?
;
	CALL	COPY_COS_NEW_2_X
	BSF	X_SIGN
	GOTO	TRIG_END
;
_3RD_Q_TAN?	MOVLW	"t"
	XORWF	KEYREG,W
	BTFSS	Z
;????
	GOTO	TRIG_END	
;
	CALL	COPY_SIN_NEW_2_Y
	CALL	COPY_COS_NEW_2_X
	CALL	DIV_YREG_BY_XREG
	BTFSC	X_ORI_SIGN	;COPY X_ORI_SIGN TO X_SIGN
	BSF	X_SIGN
	BTG	X_SIGN	;COMPLEMENT X_SIGN
	GOTO	TRIG_END
;_4th QUARTER : ANGLE IN 4th QUARTER: 270 < ANGLE < 360
_4TH_QUARTER	LOAD_CONST_2_Y	CONST_360
	CALL	RELOAD_X
	BCF	X_SIGN
	CALL	SUB_XREG_FROM_YREG
;
	CALL	SIN_COS_TAN
;
_4TH_Q_SIN?	MOVLW	"s"
	XORWF	KEYREG,W
	BNZ	_4TH_Q_COS?
;
	CALL	COPY_SIN_NEW_2_X
	BTFSC	X_ORI_SIGN	;COPY X_ORI_SIGN TO X_SIGN
	BSF	X_SIGN
	BTG	X_SIGN	;COMPLEMENT X_SIGN
	GOTO	TRIG_END

;
_4TH_Q_COS?	MOVLW	"c"
	XORWF	KEYREG,W
	BNZ	_4TH_Q_TAN?
;
	CALL	COPY_COS_NEW_2_X
	GOTO	TRIG_END
	BCF	X_SIGN
;
_4TH_Q_TAN?	MOVLW	"t"
	XORWF	KEYREG,W
	BTFSS	Z
;?????
	BRA	TRIG_END	
;
	CALL	COPY_SIN_NEW_2_Y
	CALL	COPY_COS_NEW_2_X
	CALL	DIV_YREG_BY_XREG
	BTFSC	X_ORI_SIGN	;COPY X_ORI_SIGN TO X_SIGN
	BSF	X_SIGN
	BTG	X_SIGN	;COMPLEMENT X_SIGN
;
TRIG_END
;#####
;	RETURN		;USED AT TESTING
;#####
	CALL	RELOAD_ORI_Y
	CALL	DISPLAY_X
;
	GOTO	START_ENTRY
;
TRIG_END_OVFL	CLRF	ERROR_REG
	BSF	ERROR_BIT
	BSF	OVFL_BIT
	GOTO	_ERROR
;********************************************************************
;SIN_COS_TAN
;C0 = P (PRODUCT OF COS ANGLES ~ 6,0725.2946.3952 10^-1, CALCULATED PREVIOUSLY)
;S0 = 0
;Cm+1 = Cm - 2^-m * Dm * Sm
;Sm+1 = Sm + 2^-m * Dm * Cm
;D0 = (-1), Dm+1 = (-1) IF Sm > 0, ELSE (+1)
;~65msec @ 32MHz (NUMBER OF LOOPS -> n = 30)
;
SIN_COS_TAN	NOP
;######
;	CALL	DISPLAY_REGS
;######
	NOP
;	CALL	SAVE_ORI_Y
	CALL	COPY_X_2_TARGET_ANGLE ;X_x -> TARGET_ANGLE
;LOAD START VALUES:
	BCF	D_BIT
;SIN_x := 0
	CALL	CLEAR_SIN
;COS_X := 6,0725.2946.3952 * 10^-1 (CAN BE CHANGED. IT DEPENDS UPON THE LOOP NUMBER.)
	LOAD_CONST_2_X	CONST_COS_P
	CALL	COPY_X_2_COS
;SUM_ANGLE := 45
	LOAD_CONST_2_X	CONST_45
	CALL	COPY_X_2_SUM_ANGLE
;LOAD ANGLE STEP
	CLRF	LOOP_NUM
	CALL	LOAD_ANGLE_STEP ;ANGLE = arctan 2^-0 -> 45
;Cm+1 = Cm - 2^-m * Dm * Sm
;Sm+1 = Sm + 2^-m * Dm * Cm
;Dm = 1 if D_BIT=0,  Dm = -1 if D_BIT=1
CORDIC_SC_LOOP	NOP
;CALCULATE THE Cm+1 = Cm - 2^-m * Dm * Sm
	CALL	LOAD_2_AD_MINUS_n_2_Y ;Y_y = 2^-m
;
	CALL	COPY_SIN_2_X	;X_x = Sm
	CALL	MUL_YREG_BY_XREG;X_x = 2^-m * Sm
	CALL	COPY_COS_2_Y	;Y_y = Cm
;Cm+1 = Cm - 2^-m * Dm * Sm
;SET THE "SIGN" (ADD OR SUBTRACT) DEPENDING ON Dm
	BTFSS	D_BIT	;SKIP IF Dm = -1
	BRA	SINCOS_Cm_SUB
;SUBTRACT A NEGATIVE NUMBER FROM A POSITIVE NUMBER -> ADDITION
SINCOS_Cm_ADD	CALL	ADD_YREG_2_XREG	;NORM_ADD_Y_2_X
	BRA	SINCOS_Cm_READY	
;
SINCOS_Cm_SUB	CALL	SUB_XREG_FROM_YREG
;
SINCOS_Cm_READY	CALL	COPY_X_2_COS_NEW;COS_NEW_c = Cm - 2^-m * Dm * Sm
;CALCULATE THE Sm+1 = Sm + 2^-m * Dm * Cm
	CALL	LOAD_2_AD_MINUS_n_2_Y ;Y_y = 2^-m
	CALL	COPY_COS_2_X	;X_x = Cm
	CALL	MUL_YREG_BY_XREG;X_x = 2^-m * Cm
	CALL	COPY_SIN_2_Y	;Y_y = Sm
;Sm+1 = Sm + 2^-m * Dm * Cm
;SET THE "SIGN" (ADD OR SUBTRACT) DEPENDING ON Dm
	BTFSS	D_BIT	;SKIP IF Dm = -1
	BRA	SINCOS_Sm_ADD
;
SINCOS_Sm_SUB	CALL	SUB_XREG_FROM_YREG
	BRA	SINCOS_Sm_READY
;
SINCOS_Sm_ADD	CALL	ADD_YREG_2_XREG	;X_x = Sm + 2^-m * Dm * Cm
;
SINCOS_Sm_READY	NOP
	CALL	COPY_X_2_SIN_NEW;SIN_NEW_c = Sm + 2^-m * Dm * Cm
;
	CALL	COPY_SIN_NEW_2_SIN
	CALL	COPY_COS_NEW_2_COS
;CALCULATE THE Dm VALUE FROM THE PREVIOUS ANGLE VALUES
	CALL	COPY_TARGET_ANGLE_2_X ;X = TARGET_ANGLE
	CALL	COPY_SUM_ANGLE_2_Y ;Y = SUM_ANGLE
	CALL	SUB_XREG_FROM_YREG ;X = SUM_ANGLE - TARGET_ANGLE
;IF SUM_ANGLE > TARGET_ANGLE : RESULT OF SUBTRACTION IS POSITIVE -> Dm:= -1, ELSE Dm: =1
	BSF	D_BIT	;DEFAULT
	BTFSC	X_SIGN	;SKIP IF RESULT = POSITIVE -> Dm:= -1
	BCF	D_BIT
;NEW SUM_ANGLE = OLD SUM_ANGLE + D_BIT*ANGLE_STEP
	INCF	LOOP_NUM,F
	MOVLW	D'46'
	XORWF	LOOP_NUM,W
	BTFSC	Z
	RETURN		;RETURN IF LOOP_NUM = 31
;LOOP_NUM <......
	CALL	COPY_SUM_ANGLE_2_Y;
	CALL	LOAD_ANGLE_STEP_2_X;ANGLE = NEXT ANGLE STEP
	BTFSC	D_BIT
	BRA	SINCOS_ANG_SUB
;
SINCOS_ANG_ADD	CALL	ADD_YREG_2_XREG
	BRA	SINCOS_ANG_RDY
;
SINCOS_ANG_SUB	CALL	SUB_XREG_FROM_YREG
;
SINCOS_ANG_RDY	CALL	COPY_X_2_SUM_ANGLE
;#####
;	CALL	DISPLAY_SC
;#####
	BRA	CORDIC_SC_LOOP
;********************************************************************
;ARC_SIN
;
;arcsin A = arctan (A/SQR(1 - A^2))
; |A| <= 1 !!!!
ARC_SIN	NOP		;NOTE: X_x SAVED IN LAST_X !
;CHECK THE ARGUMENT
	CLRF	ERROR_REG
;
	BCF	X_SIGN	;X_x = |A|
;
;Y:= 1,0000.0000.0000 * 10^00
	CALL	CLEAR_Y	;Y_y = 0
	MOVLF	D'1',Y_6	;Y_y = 1,0000.0000.0000 * 10^00
	CALL	SUB_XREG_FROM_YREG ;X_x = 1 - |A|
	BTFSS	X_SIGN	;SKIP IF X_SIGN = 1  ->  |A| > 1  -> ERROR
	BRA	ARC_SIN_5
;
	BSF	ERROR_BIT
	BSF	ERROR_BIT5
	RETURN
;RELOAD X_x
ARC_SIN_5	CALL	COPY_LASTX_2_X
;CHECK THE "HARD-WIRED" VALUES
	CALL	CHECK_X_0?
	BTFSC	X_0_BIT	;SKIP IF X_x = 0
	BRA	X_?_1
;
	RETURN
;X =?= 1 
X_?_1	CALL	CLEAR_Y	;Y_y = 0
	MOVLF	D'1',Y_6	;Y_y = 1,0000.0000.0000 * 10^00
	CALL	COMPARE_ABS_X_Y
	BTFSS	EQU_BIT	;SKIP IF |Y_y| = |X_x|
	BRA	X_?_05
;
	LOAD_CONST_2_X	CONST_90	
	BCF	X_SIGN
	BTFSC	LASTX_SIGN
	BSF	X_SIGN
	RETURN
;
X_?_05	LOAD_CONST_2_Y	CONST_05
	CALL	COMPARE_ABS_X_Y
	BTFSS	EQU_BIT	;SKIP IF |Y_y| = |X_x|
	BRA	ARC_SIN_10
	LOAD_CONST_2_X	CONST_30	
	BCF	X_SIGN
	BTFSC	LASTX_SIGN
	BSF	X_SIGN
	RETURN
;
ARC_SIN_10	CALL	COPY_LASTX_2_X
;
	CALL	COPY_X_2_Y	;Y_y = A
	CALL	SAVE_Y
	CALL	MUL_YREG_BY_XREG;X_x = A^2
;
	CALL	CLEAR_Y	;Y_y = 0
	MOVLF	D'1',Y_6	;Y_y = 1,0000.0000.0000 * 10^00
	CALL	SUB_XREG_FROM_YREG ;X_x = 1 - A^2
	CALL	SQUARE_ROOT
	CALL	RELOAD_Y	;Y_y = A
	CALL	DIV_YREG_BY_XREG
;X_x = A/SQR(1 - A^2)
	CALL	ARC_TAN
;
	RETURN
;********************************************************************
;ARC_COS
; arccos A = 90 - arcsin A
ARC_COS	CALL	ARC_SIN
	BTFSC	ERROR_BIT
	RETURN
	LOAD_CONST_2_Y	CONST_90
	CALL	SUB_XREG_FROM_YREG
;
	RETURN
;********************************************************************
;ARC_TAN
;Z0 = 0, 
;C0 = 0,25
;S0 = C0*T
;Zm+1 = Zm - Dm*Am
;Cm+1 = Cm - 2^-m * Dm * Sm
;Sm+1 = Sm + 2^-m * Dm * Cm
;D0 = (-1), Dm+1 = (-1) IF Sm > 0, ELSE (+1)
;Cm VALUES ARE IN COS_c REGISTERS!
;Sm VALUES ARE IN SIN_s REGISTERS!
;Zm VALUES ARE IN ARCTAN REGISTERS!
;THE NUMBER OF WHOSE WE CALCULATE THE ARCTAN VALUE IS IN TARGET_ANGLE_t
ARC_TAN	NOP
;ARCTAN := 0
	CALL	CLEAR_ARCTAN
;CHECK X_x
	CALL	CHECK_X_0?	
	BTFSS	X_0_BIT	;SKIP IF X_x =/= 0
	BRA	ARC_TAN_END
;SAVE X_x
	CALL	COPY_X_2_TARGET_ANGLE
	BCF	X_SIGN	;|X_x|
;LOAD START VALUES
	CALL	COPY_X_2_Y	;Y_y = TARGET_ANGLE
;C0 := 0,25 (2,50000.0000.0000 * 10^-1)
	LOAD_CONST_2_X	CONST_025
	CALL	COPY_X_2_COS	;C0
;S0 := C0 * T
	CALL	MUL_YREG_BY_XREG
	CALL	COPY_X_2_SIN	;S0 = C0 * T
;D0 := -1 -> D_BIT = 1 (D_BIT IS OPPOSITE TO SIGN OF Sm)
	BSF	D_BIT
;LOAD ANGLE STEP
	CLRF	LOOP_NUM
	CALL	LOAD_ANGLE_STEP ;ANGLE = arctan 2^-m
;START VALUES HAVE BEEN LOADED. LET'S DO THE DIRTY WORK!
;Cm+1 = Cm - 2^-m * Dm * Sm
;Sm+1 = Sm + 2^-m * Dm * Cm
CORDIC_ATAN_LOOP NOP 
;CALCULATE THE Cm+1 = Cm - 2^-m * Dm * Sm
	CALL	LOAD_2_AD_MINUS_n_2_Y ;Y_y = 2^-m
	CALL	COPY_SIN_2_X	;X_x = Sm
	CALL	MUL_YREG_BY_XREG;X_x = 2^-m * Sm
	CALL	COPY_COS_2_Y	;Y_y = Cm
;Cm+1 = Cm - 2^-m * Dm * Sm
;SET THE "SIGN" (ADD OR SUBTRACT) DEPENDING ON Dm
	BTFSS	D_BIT	;SKIP IF Dm = -1
	BRA	ARCTAN_Cm_SUB
;SUBTRACT A NEGATIVE NUMBER FROM A POSITIVE NUMBER -> ADDITION
ARCTAN_Cm_ADD	CALL	ADD_YREG_2_XREG
	BRA	ARCTAN_Cm_READY	
;
ARCTAN_Cm_SUB	CALL	SUB_XREG_FROM_YREG
;
ARCTAN_Cm_READY	CALL	COPY_X_2_COS_NEW;COS_NEW_c = Cm - 2^-m * Dm * Sm
;CALCULATE THE Sm+1 = Sm + 2^-m * Dm * Cm
	CALL	LOAD_2_AD_MINUS_n_2_Y ;Y_y = 2^-m
	CALL	COPY_COS_2_X	;X_x = Cm
	CALL	MUL_YREG_BY_XREG ;X_x = 2^-m * Cm
	CALL	COPY_SIN_2_Y	;Y_y = Sm
;Sm+1 = Sm + 2^-m * Dm * Cm
;SET THE "SIGN" (ADD OR SUBTRACT) DEPENDING ON Dm
	BTFSS	D_BIT	;SKIP IF Dm = -1
	BRA	ARCTAN_Sm_ADD
;
ARCTAN_Sm_SUB	CALL	SUB_XREG_FROM_YREG
	BRA	ARCTAN_Sm_READY
;
ARCTAN_Sm_ADD	CALL	ADD_YREG_2_XREG	;X_x = Sm + 2^-m * Dm * Cm
;
ARCTAN_Sm_READY	CALL	COPY_X_2_SIN_NEW;SIN_NEW_s = Sm + 2^-m * Dm * Cm
;Zm+1 = Zm - Dm * Am
	CALL	COPY_ARCTAN_2_Y	;Y_y = Zm
	CALL	LOAD_ANGLE_2_X	
;####
;	CALL	DISPLAY_X_TEST
;####
	BTFSC	D_BIT	;SKIP IF Dm = 1
	BRA	ARCTAN_Zm_ADD
;
ARCTAN_Zm_SUB	CALL	SUB_XREG_FROM_YREG
	BRA	ARCTAN_Zm_READY
;
ARCTAN_Zm_ADD	CALL	ADD_YREG_2_XREG
;
;####
;	CALL	DISPLAY_X_TEST
;####
ARCTAN_Zm_READY	CALL	COPY_X_2_ARCTAN
;
	CALL	COPY_SIN_NEW_2_SIN
	CALL	COPY_COS_NEW_2_COS
;COPY SIGN OF SIN_s INTO D_BIT
	MOVFF	SIN_6,TEMP
	BCF	D_BIT	;DEFAULT
	BTFSC	TEMP,6
	BSF	D_BIT
;TOGGLE D_BIT
	BTG	D_BIT
;
	INCF	LOOP_NUM,F
	MOVLW	D'43'
	XORWF	LOOP_NUM,W
	BNZ	CORDIC_ATAN_LOOP
;
ARC_TAN_END	CALL	COPY_ARCTAN_2_X
;THE SIGN OF THE INPUT ARGUMENT BECOMES THE SIGN OF THE ANSWER
	MOVFF	TARGET_ANGLE_6,TEMP
	BCF	X_SIGN	;DEFAULT
	BTFSC	TEMP,6
	BSF	X_SIGN
;
	RETURN
;********************************************************************
;CONVERT_ANGLE : AT ARCUS FUNCTIONS THE RESULT IS IN DEGREES
;IT SHOULD BE CONVERTED
CONVERT_ANGLE	BTFSC	RAD_BIT
	BRA	CONV_ANGLE_2_RAD
;
	BTFSC	GRAD_BIT
	BRA	CONV_ANGLE_2_GRAD
;ANGLE IS IN DEGREES
	RETURN		;NO CONVERSION IS NEEDED
;
CONV_ANGLE_2_RAD
	CALL	CONV_DEG_2_RAD
	RETURN
;
CONV_ANGLE_2_GRAD
	CALL	CONV_DEG_2_GRAD
	RETURN
;********************************************************************
;	ANGLE CONVERSIONS
;********************************************************************
;CONV_DEG_2_RAD : CONVERT DEGREES TO RADIANS
CONV_DEG_2_RAD	CALL	SET_DEG	;ANGLE IN DEGREES := 0 <= ANGLE < 360
	CALL	COPY_X_2_Y	;Y = 0 <= ANGLE < 360
;(ANGLE IN DEGREES) * PI / 180
	LOAD_CONST_2_X	CONST_PI_P_180
	CALL	MUL_YREG_BY_XREG
	RETURN
;********************************************************************
;CONV_RAD_2_DEG : CONVERT RADIANS TO DEGREES
CONV_RAD_2_DEG	CALL	SET_RAD	;ANGLE IN RADIANS := 0 <= ANGLE < 2PI
	CALL	COPY_X_2_Y	;Y = 0 <= ANGLE < 2PI
;(ANGLE IN RADIANS) * 180/PI
	LOAD_CONST_2_X	CONST_180_P_PI	;X = 180/PI
	CALL	MUL_YREG_BY_XREG;X = (ANGLE IN RADIANS) * 180/PI
;#####
;	CALL	DISPLAY_REGS
;#####	
	RETURN
;********************************************************************
;SET_DEG : ANGLE IN DEGREES := 0 < ANGLE < 360
SET_DEG	NOP
;CHECK THE EXPONENT
	BTFSC	X_EXP_SIGN	;SKIP IF X-EXPONENT POSITIVE
	BRA	SET_DEG_5	;ANGLE IS LESS THAN 1 DEGREE
;
	MOVLW	H'06'
	CPFSGT	X_EXP	;SKIP IF X_EXP > 6	
	BRA	SET_DEG_5	;X_EXP <= 6, GO ON!
;X-EXPONENT IS TOO BIG
	CLRF	ERROR_REG
	BSF	ERROR_BIT
	BSF	TOO_BIG_BIT
	RETURN
; 0 < ANGLE < 9,9999.9999.9999 * 10^6 DEGREES
;SAVE THE SIGN
SET_DEG_5	BCF	SIGN_SAVE_BIT
	BTFSC	X_SIGN
	BSF	SIGN_SAVE_BIT
;|X_x|
	BCF	X_SIGN
	CALL	COPY_X_2_Y	;Y = ANGLE IN DEGREES
;
SET_DEG_LOOP	LOAD_CONST_2_X	CONST_360	;X = 360
;NOTE: |X_x| !!!
	CLRWDT
	CALL	NORM_SUB_X_FROM_Y ;X = ANGLE - 360
	CALL	COPY_X_2_Y	;Y = ANGLE - 360
	BTFSS	X_SIGN	;SKIP IF X_SIGN=1 -> NEGATIVE ANGLE
	BRA	SET_DEG_LOOP
;ADD 360 TO -ANGLE
	LOAD_CONST_2_X	CONST_360
	CALL	ADD_YREG_2_XREG	;X = ANGLE, 0 < ANGLE < 360
;RELOAD THE ORIGINAL SIGN OF ANGLE
	BCF	X_SIGN
	BTFSC	SIGN_SAVE_BIT
	BSF	X_SIGN
;
	RETURN
;********************************************************************
;SET_RAD : ANGLE IN RADIANS := 0 < ANGLE < 2PI
SET_RAD	NOP
;CHECK THE EXPONENT
	BTFSC	X_EXP_SIGN	;SKIP IF X-EXPONENT POSITIVE
	BRA	SET_RAD_5	;ANGLE IS LESS THAN 1 RADIAN
;
	MOVLW	H'04'
	CPFSGT	X_EXP	;SKIP IF X_EXP > 4	
	BRA	SET_RAD_5	;X_EXP <= 4, GO ON!
;X-EXPONENT IS TOO BIG
	CLRF	ERROR_REG
	BSF	ERROR_BIT
	BSF	TOO_BIG_BIT
	RETURN
; 0 < ANGLE < 9,9999.9999.9999 * 10^4 RADIANS
;SAVE THE SIGN
SET_RAD_5	BCF	SIGN_SAVE_BIT
	BTFSC	X_SIGN
	BSF	SIGN_SAVE_BIT
;|X_x|
	BCF	X_SIGN
	CALL	COPY_X_2_Y	;Y = ANGLE IN RADIANS
SET_RAD_LOOP	LOAD_CONST_2_X	CONST_2PI	;X := 2PI
;
	CALL	SUB_XREG_FROM_YREG;X = ANGLE - 2PI
	NOP
	CALL	COPY_X_2_Y	;Y = ANGLE - 2PI
	BTFSS	X_SIGN	;SKIP IF X_SIGN=1 -> NEGATIVE ANGLE
	BRA	SET_RAD_LOOP
;ADD 2PI TO -ANGLE
	LOAD_CONST_2_X	CONST_2PI	;X := 2PI
	CALL	ADD_YREG_2_XREG	;X = ANGLE, 0 < ANGLE < 2PI
;RELOAD THE ORIGINAL SIGN OF ANGLE
	BCF	X_SIGN
	BTFSC	SIGN_SAVE_BIT
	BSF	X_SIGN
;
	RETURN
;********************************************************************
;SET_GRAD : ANGLE IN GRADIENTS := 0 < ANGLE < 400
SET_GRAD	NOP
;CHECK THE EXPONENT
	BTFSC	X_EXP_SIGN	;SKIP IF X-EXPONENT POSITIVE
	BRA	SET_GRAD_5	;ANGLE IS LESS THAN 1 GRADIENT
;
	MOVLW	H'06'
	CPFSGT	X_EXP	;SKIP IF X_EXP > 6	
	BRA	SET_GRAD_5	;X_EXP <= 6, GO ON!
;X-EXPONENT IS TOO BIG
	CLRF	ERROR_REG
	BSF	ERROR_BIT
	BSF	TOO_BIG_BIT
	RETURN
; 0 < ANGLE < 9,9999.9999.9999 * 10^6 GRADIENTS
;SAVE THE SIGN
SET_GRAD_5	BCF	SIGN_SAVE_BIT
	BTFSC	X_SIGN
	BSF	SIGN_SAVE_BIT
;|X_x|
	BCF	X_SIGN
	CALL	COPY_X_2_Y	;Y = ANGLE IN GRADIENTS
;
SET_GRAD_LOOP	LOAD_CONST_2_X	CONST_400	;X = 400
	CALL	SUB_XREG_FROM_YREG;X = ANGLE - 400
	CALL	COPY_X_2_Y	;Y = ANGLE - 400
	BTFSS	X_SIGN	;SKIP IF X_SIGN=1 -> NEGATIVE ANGLE
	BRA	SET_GRAD_LOOP
;ADD 400 TO -ANGLE
	LOAD_CONST_2_X	CONST_400
	CALL	ADD_YREG_2_XREG	;X = ANGLE, 0 < ANGLE < 400 
;RELOAD THE ORIGINAL SIGN OF ANGLE
	BCF	X_SIGN
	BTFSC	SIGN_SAVE_BIT
	BSF	X_SIGN
;
	RETURN
;********************************************************************
;CONV_GRAD_2_DEG : CONVERT GRADIENTS TO DEGREES
CONV_GRAD_2_DEG	CALL	SET_GRAD	;ANGLE IN GRADIENTS := 0 <= ANGLE < 400
	CALL	COPY_X_2_Y	;Y = 0 <= ANGLE < 400
;((ANGLE IN GRADIENTS) * 9) / 10
	LOAD_CONST_2_X	CONST_9	;X = 9,0000.0000.0000 * 10^0
	CALL	MUL_YREG_BY_XREG;X = ANGLE * 9
	CALL	DECREMENT_X_EXP	;DIVIDE BY 10
	RETURN
;********************************************************************
;CONV_GRAD_2_RAD : CONVERT GRADIENTS TO RADIANS
CONV_GRAD_2_RAD	CALL	SET_GRAD	;ANGLE IN GRADIENTS := 0 < ANGLE < 400
	CALL	COPY_X_2_Y	;Y = 0 <= ANGLE < 400
;(ANGLE IN GRADIENTS) * PI / 200
	LOAD_CONST_2_X	CONST_PI_P_200
	CALL	MUL_YREG_BY_XREG
	RETURN
;********************************************************************
;CONV_DEG_2_GRAD : CONVERT DEGREES INTO GRADIENTS
CONV_DEG_2_GRAD	CALL	SET_DEG	;ANGLE IN DEGREES := 0 <= ANGLE < 360
;((ANGLE IN DEGREES) * 10) / 9
	CALL	INCREMENT_X_EXP	;MULTIPLY BY TEN
	CALL	COPY_X_2_Y
	LOAD_CONST_2_X	CONST_9	;X = 9,0000.0000.0000 * 10^0
	CALL	DIV_YREG_BY_XREG;X = (ANGLE * 10) / 9
	RETURN
;********************************************************************
;CONV_RAD_2_GRAD : CONVERT RADIANS INTO GRADIENTS
CONV_RAD_2_GRAD CALL	SET_RAD	;ANGLE IN RADIANS := 0 < ANGLE < 2PI
	CALL	COPY_X_2_Y	;Y = 0 <= ANGLE < 2PI
;(ANGLE IN RADIANS) * 200/PI
	LOAD_CONST_2_X	CONST_200_P_PI	;X = 200/PI
	CALL	MUL_YREG_BY_XREG;X = (ANGLE IN RADIANS) * 200/PI
	RETURN
;********************************************************************
;COMPARE_X_Y : COMPARAISON IS PERFORMED AS: Y_y - X_x = RESULT
;Y_y SHOULD BE LOADED BY CALLING PROGRAM
;X_0_BIT = 0 IF ALL OF DECIMALS ARE ZERO
COMPARE_X_Y	CALL	SUB_XREG_FROM_YREG
	CALL	CHECK_X_0?	;CHECK X_x = 0 ?
;
	RETURN
;********************************************************************
;COMPARE_ABS_X_Y 
;Y_y SHOULD BE LOADED BY CALLING PROGRAM
;EQU_BIT=1 if |X_x|=|Y_y|, else EQU_BIT=0
COMPARE_ABS_X_Y	BCF	EQU_BIT	;DEFAULT -> |X_x|=/=|Y_y|
;
	MOVF	X_6,W
	XORWF	Y_6,W
	BNZ	COMP_NOT_EQU
;
	MOVF	X_5,W
	XORWF	Y_5,W
	BNZ	COMP_NOT_EQU
;
	MOVF	X_4,W
	XORWF	Y_4,W
	BNZ	COMP_NOT_EQU
;
	MOVF	X_3,W
	XORWF	Y_3,W
	BNZ	COMP_NOT_EQU
;
	MOVF	X_2,W
	XORWF	Y_2,W
	BNZ	COMP_NOT_EQU
;
	MOVF	X_1,W
	XORWF	Y_1,W
	BNZ	COMP_NOT_EQU
;
	MOVF	X_0,W
	XORWF	Y_0,W
	BNZ	COMP_NOT_EQU
;
	MOVF	X_EXP,W
	XORWF	Y_EXP,W
	BNZ	COMP_NOT_EQU
;
	BSF	EQU_BIT
;
COMP_NOT_EQU	RETURN
;********************************************************************
;LOAD_RECFRAC_2_X : LOAD 1/n! INTO X_x,  n IS IN N_REG
;RECFRAC -> RECIPROCAL OF FACTORIALS
LOAD_RECFRAC_2_X
	MOVFF	N_REG,LOOP_CNT
	MOVLF	UPPER TBL_REC_FACTORIAL,TBLPTRU
	MOVLF	HIGH TBL_REC_FACTORIAL,TBLPTRH
;MULTIPLY BY 8
	BCF	C
	RLCF	LOOP_CNT,F
	RLCF	LOOP_CNT,F
	RLCF	LOOP_CNT,F
	MOVFF	LOOP_CNT,TBLPTRL
;
	TBLRD*+
	MOVFF	TABLAT,X_0
	TBLRD*+
	MOVFF	TABLAT,X_1
	TBLRD*+
	MOVFF	TABLAT,X_2
	TBLRD*+
	MOVFF	TABLAT,X_3
	TBLRD*+
	MOVFF	TABLAT,X_4
	TBLRD*+
	MOVFF	TABLAT,X_5
	TBLRD*+
	MOVFF	TABLAT,TEMP	;SAVE
	MOVF	TABLAT,W
	ANDLW	H'0F'
	MOVWF	X_6
;
	TBLRD*
	MOVFF	TABLAT,X_EXP	
;
	BCF	X_EXP_SIGN	;DEFAULT
	BTFSC	TEMP,7	;EXPONENT SIGN
	BSF	X_EXP_SIGN
;
	RETURN
;********************************************************************
;LOAD_N_2_Y
LOAD_N_2_Y	MOVLW	UPPER TBL_FACTORIAL
	MOVWF	TBLPTRU
	MOVLW	HIGH TBL_FACTORIAL
	MOVWF	TBLPTRH
;MULTIPLY BY 8
	BCF	C
	RLCF	N_REG,F
	RLCF	N_REG,F
	RLCF	N_REG,F
	MOVFF	N_REG,TBLPTRL
;
	TBLRD*+
	MOVFF	TABLAT,Y_4
	TBLRD*+
	MOVFF	TABLAT,Y_5
	TBLRD*+
	MOVFF	TABLAT,Y_6
;
	CLRF	Y_0
	CLRF	Y_1
	CLRF	Y_2
	CLRF	Y_3
;
	RETURN
;********************************************************************
;ARCUS_FUNCTION
ARCUS_FUNCTION	BCF	_2ND_BIT
	CALL	SAVE_ORI_Y
	CALL	COPY_X_2_LASTX
;
	MOVLW	"s"
	XORWF	KEYREG,W
	BZ	ARCUS_SINE
;
	MOVLW	"c"
	XORWF	KEYREG,W
	BZ	ARCUS_COS
;
	MOVLW	"t"
	XORWF	KEYREG,W
	BZ	ARCUS_TAN
;NO VALID "ARCUS" FUNCTION FOUND
	CALL	DISPLAY_ANNS
	GOTO	GET_NEXT_KEY
;ARCUS_SINE
ARCUS_SINE	CALL	ARC_SIN
	BTFSS	ERROR_BIT	;SKIP IF ERROR
	BRA	ARCUS_END
	GOTO	_ERROR
;ARCUS_COS
ARCUS_COS	CALL	ARC_COS
	BTFSS	ERROR_BIT	;SKIP IF ERROR
	BRA	ARCUS_END
	GOTO	_ERROR
;ARCUS_TAN
ARCUS_TAN	CALL	ARC_TAN
	BRA	ARCUS_END
;
	NOP
	NOP
;
ARCUS_END	CALL	CONVERT_ANGLE
	CALL	RELOAD_ORI_Y
	CALL	DISPLAY_ANNS
	CALL	DISPLAY_X
;
	STACK_LIFT_ENABLE
	GOTO	START_ENTRY
;********************************************************************
;CALC_FORENSICS: CALCULATES THE VALUE OF
;ARCSIN(ARCCOS(ARCTAN(TAN(COS(SIN "ANGLE")))))
;ANGLE IS IN DEGREES, IN X_x REGISTERS
;CALC_FORENSICS IS AN ALGORITHM ACCORDING TO MIKE SEBASTIAN
;www.calcinfo.com
CALC_FORENSICS	CALL	SIN_COS_TAN
	CALL	COPY_SIN_NEW_2_X
	NOP
;
	CALL	SIN_COS_TAN
	CALL	COPY_COS_NEW_2_X
	NOP
;
	CALL	SIN_COS_TAN
	CALL	COPY_SIN_NEW_2_Y
	CALL	COPY_COS_NEW_2_X
	CALL	DIV_YREG_BY_XREG
	NOP
;
	CALL	ARC_TAN
	NOP
;
	CALL	ARC_COS
	NOP
;
	CALL	ARC_SIN
	NOP
;
	RETURN
;********************************************************************